*DK advance
      subroutine advance
 
c...  This routine advances the Navier-Stokes equations one time step.
 
      include 'size.h'
      include 'pcom.h'
      common /flds/ f((nt+1)**2*nd*(nr+1),8)
      common /temp/ tpb(nt+1), temp((nt+1)**2*nd*(nr+1)), tpe(nt+1)
      common /shht/ shb(nt+1),  shr((nt+1)**2*nd*(nr+1)), she(nt+1)
      common /tdot/ tdb(nt+1), tdot((nt+1)**2*nd*(nr+1),2), tde(nt+1)
      common /velo/ upb(nt+1), u((nt+1)**2*nd*3*(nr+1)),  upe(nt+1)
      common /cycl/ iter, time, tstep, step
      common /conv/ istrt, itmax, step0, stepmin, stepmax, dtdump
      common /nrms/ fnrm, rnrm, unrm, ekin
      common /prop/ ieos,  rho0, visc,  grav,  texpn, tcond,
     &              sheat, hgen, tb(2), cl410, cl660
      common /heat/ htop, hbot, hrad, heat, hshr, hvol, hnet, tnrm,
     &              tav(129), qc(128)
      common /eos2/ rhocv(129), gamma(129), alpha(129), prf(129),
     &               cond(129)
      common /radl/ rshl(nr+1), ird, ibc
      common /solv/ itreq, convrg, divnorm, cutdiv
      common /mgrd/ itlimit, convtol, lreport, itsolve, izerou
      common /call/ ncall
      common /clck/ itmng, sec(50), nop(50)
      if(itmng.eq.1) call second(tin)
 
      msgnum = 1
      ncall  = ncall + 1
 
c...  Update the viscosity variation field.
 
      call oprupdate
 
c...  Update the shear heating rate if appropriate.
 
      if(ieos.ge.10 .and. mod(ncall,4).eq.1)
     &   call shrheat(shr,u,f,f(1,3))
 
c...  Use a second-order Runge-Kutta scheme to update the temperature.
 
      call usolve
 
      call energy(tdot(1,1))
 
      do ii=1,nv
         temp(ii) = temp(ii) + 0.5*tstep*tdot(ii,1)
      end do
 
      call usolve
 
      call energy(tdot(1,2))
 
      do ii=1,nv
         temp(ii) = temp(ii) + tstep*(tdot(ii,2) - 0.5*tdot(ii,1))
      end do
 
c...  Compute the new time step.
 
      call fluxmax(fmax)
 
      if(ncall .gt. 5) then
         if(itreq .gt. 3) then
            step = 0.70*step
         elseif(itreq.eq.1 .and. convrg.lt.0.3*convtol) then
            step = min(1.25*step, stepmax)
         endif
         tstep   = step*tstep/fmax
      endif
 
c...  Compute norms and check energy conservation.
 
      if(mod(ncall,10) .eq. 0) then
         call norm3s(u,unrm,3,nd,nr,nt)
         call kenergy(ekin,u)
         call layrav(temp,tav)
         call heating(heat,hrad,tdot(1,2))
         tnrm = smean(temp)
         hnet = htop - hbot + heat - hrad
         do ir=1,nr
            qc(ir) = 12.56637*(tav(ir+1) - tav(ir))*rshl(ir)*rshl(ir+1)
     &               *sqrt(cond(ir)*cond(ir+1))/(rshl(ir) - rshl(ir+1))
         end do
      end if
 
      if(ncall .eq. 1) call norm3s(u,unrm,3,nd,nr,nt)
 
      if(itmng.eq.1) call second(tout)
      if(itmng.eq.1) sec(4) = sec(4) + tout - tin
      end
*dk convect
      subroutine convect
 
      include 'size.h'
      include 'pcom.h'
      common /flds/ f((nt+1)**2*nd*(nr+1),8)
      common /velo/ upb(nt+1), u((nt+1)**2,nd,3,nr+1),  upe(nt+1)
      common /temp/ tpb(nt+1), temp((nt+1)**2,nd,nr+1), tpe(nt+1)
      common /pres/ ppb(nt+1), pres((nt+1)**2,nd,nr+1), ppe(nt+1)
      common /mesh/ xn((nt+1)**2,nd,3)
      common /radl/ rshl(nr+1), ird, ibc
      common /ndar/  arn((nt+1)**2),  arne((nt+1)**2),
     &              rarn((nt+1)**2), rarne((nt+1)**2)
      common /map0/  map((nt+1)**2*nd*3)
      common /map1/ pmap((nt+1)**2*nd*2)
      common /work/ wk((nt+1)**2,(nr+1)*2)
      common /prop/ ieos,  rho0, visc,  grav,  texpn, tcond,
     &              sheat, hgen, tb(2), cl410, cl660
      common /cycl/ iter, time, tstep, step
      common /conv/ istrt, itmax, step0, stepmin, stepmax, dtdump
      common /cnv1/ it, tdump, tmovi
      common /moon/ imoon, radis(5), tcore, qcgn, visc0
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
      common /eos1/ rhorf(129), tmprf(129), drhdp(129), grv(129)
      common /eos2/ rhocv(129), gamma(129), alpha(129), prf(129),
     &               cond(129)
      common /mgrd/ itlimit, convtol, lreport, itsolve, izerou
      common /plte/ nplate, urtn(3,20)
      common /harm/ lmax, nhar, dtharm
      common /subd/ istage, tbegin, totstage, tstage
      common /vis1/ vscmax, rvscscl, tvscscl, pwrlawn, pwrlawsr, yldstrs
      common /io02/ idump0, ngpath, nlpath
      common /solv/ itreq, convrg, divnorm, cutdiv
      common /call/ ncall
      common /prty/ propr(20)
      common /name/ titl(4,4)
      common /fnam/ vname, sname, cname
      character*8 titl, vname, sname, cname
      common /clck/ itmng, sec(50), nop(50)
      call second(tin)
 
      call nulvec(sec, 50)
 
      lr0    = lreport
      ncall  = 0
      idump  = idump0
      imovi  = 0
      if(dtmovi .eq. dtdump) imovi = idump0
      tstage = 0.
      a      = randomnum(-1)
 
      if(istage .eq. 12) then
 
c...     Note:  istage = 12 implies running with istage = 11
c...     with no transitions to other plate stages.
 
         istage = 11
         tstage = -1.e10
 
      end if
 
      if(istage .ne. 0) call platestage
 
      call opinit
 
      call eosset
 
      call fldsinit
 
      if(istage.ne.0 .and. tstage.eq.0.) tstage = time - tbegin
 
      lmax   = 32
      tharm  = 0.
      dtharm = 1.e50
      nhar   = (lmax+1)*(lmax+2)/2
 
c...  Write header for spherical harmonic output file.
 
      if(mynum.eq.0 .and. dtharm.le.1.e30) then
         write(19,'(10x,"LAYER DEPTH IN METERS:, time =",1pe25.15)')
     &         time
         do i=1,nr+1
            write(19,'(11x,i3,1pe15.5)') i, rshl(i)
         end do
      endif
 
      if(dtmovi.gt.0.) then
         tmovi = int(time/dtmovi)*dtmovi
      else
         tmovi = 1.e35
      endif
 
      if(dtdump.gt.0.) then
         tdump = int(time/dtdump)*dtdump
         vdump = 0.
      else
         tdump = 1.e35
         vdump = 1.e35
      endif
 
c     Begin main time step loop.
 
      do it=1,itmax
 
         iter = iter + 1
 
         iskp = 100
         if(itmax .lt. 500) iskp = 10
         if(it    .le. 100) iskp = 10
         if(itmax .le. 10)  iskp = 1
         if(mod(it,iskp) .eq. 0) then
            if(mynum .eq. 0)
     &         write(6,'(/24x,"CONVECT ITERATION ",i5/)') iter
            lreport = lr0
         else
            lreport = -5
         endif
 
         if(itmax.eq.1 .or. it.eq.itmax
     &                 .or. step.lt.1.5*stepmin) then
            itmng = 1
         else
            itmng = 0
         endif
 
         call advance(u,temp,f)
 
         time  = time  + 3.1688e-8*tstep
         tharm = tharm + 3.1688e-8*tstep
         propr(2) = time
 
         if(tharm .ge. dtharm) then
            tharm = 0.
            call fetosh(temp,f,f(1,5),lmax,nr,18)
            call massflux(19)
         endif
 
         if(istage .ne. 0) then
            tstage = tstage + 3.1688e-8*tstep
            if(tstage .ge. totstage) then
               istage = istage - 1
               if(istage .lt. 1) go to 100
               idump = idump + 1
               imovi = imovi + 1
               call fldsout(idump)
               call graphout(imovi)
c              call gmtout(imovi)
               call massflux(19)
               call radcor(temp,17)
               tstage = 0.
               step   = 0.001
               tstep  = 0.001*tstep
               call platestage
               call mapstage(f,wk)
               do ii=1,(nt+1)**2*nd*2
                  pmap(ii) = real(map(ii))
               end do
            end if
         endif
 
         if(time .gt. tdump+dtdump) then
            idump = idump + 1
            tdump = tdump + dtdump
            call fldsout(idump)
         endif
 
         if(time.gt.tmovi+dtmovi) then
 
            imovi = imovi + 1
            tmovi = tmovi + dtmovi
 
            if(nproc .ge. 1) then
 
               call graphout(imovi)
c              call gmtout(imovi)
 
            else
 
               nn    = (nt + 1)**2*nd
               vname = '        '
               sname = '        '
               cname = '        '
               if(mod(ispec,2).eq.1) vname = ' terra  '
               if(ispec.ne.1)        sname = ' terra  '
               if(ispec/2.eq.4)      cname = ' terra  '
 
c              call sphplot(u,temp,pmap,titl,rshl,xn,f)
 
            endif
 
         endif
 
         if(mod(it,10) .eq. 0) call history(lreport)
 
         if(step .lt. stepmin) go to 100
 
         if(imoon.eq.1 .and. nproc.eq.1) call lunar
 
      end do
 
 100  continue
 
c     call massflux(19)
c     call radcor(temp,17)
 
c     call lithrotn(u,1)
 
      call fldsout(idump+1)
      call graphout(imovi+1)
c     call gmtout(imovi+1)
 
c...  Output CMB heat flux as spherical harmonic coefficients.
 
c     cr = (4./tcond)*cond(nr+1)/(rshl(nr) - rshl(nr+1))
 
c     do id=1,nd
c        do ii=1,(nt+1)**2
c           wk(ii,id) = cr*(temp(ii,id,nr) - temp(ii,id,nr+1))
c        end do
c     end do
 
c     call fetosh(wk,f,f(1,5),10,0,18)
 
      call uradtng
      if(mynum .eq. 0) call radialout
 
c     if(icptn .eq. 1) call pltradl
 
c     if(nproc .eq. 1) call sphplot(u,temp,pmap,titl,rshl,xn,f)
 
      if(mynum .eq. 0) call raylnuss
 
      call wrapup
 
      call second(tout)
      sec(3) = sec(3) + tout - tin
 
      call profile
 
      end
*dk fldsinit
      subroutine fldsinit
 
c     This routine obtains initial temperature, velocity, pressure,
c     and plate map fields by (1) reading data files if a restart run
c     or (2) calling routine tmpinit for the temperature field and
c     routine mapinit for the plate map field.
 
      include 'size.h'
      include 'pcom.h'
      common /flds/ f((nt+1)**2*nd*(nr+1)*8)
      common /velo/ upb(nt+1), u((nt+1)**2,nd,3,nr+1),  upe(nt+1)
      common /temp/ tpb(nt+1), temp((nt+1)**2,nd,nr+1), tpe(nt+1)
      common /pres/ ppb(nt+1), pres((nt+1)**2,nd,nr+1), ppe(nt+1)
      common /map0/  map((nt+1)**2*nd*3)
      common /map1/ pmap((nt+1)**2*nd*2)
      common /work/ wk((nt+1)**2*(nr+1)*2)
      common /name/ titl(4,4)
      common /radl/ rshl(nr+1), ird, ibc
      common /prop/ ieos,  rho0, visc,  grav,  texpn, tcond,
     &              sheat, hgen, tb(2), cl410, cl660
      common /cycl/ iter, time, tstep, step
      common /heat/ htop, hbot, hrad, heat, hshr, hvol, hnet, tnrm,
     &              tav(129), qc(128)
      common /conv/ istrt, itmax, step0, stepmin, stepmax, dtdump
      common /moon/ imoon, radis(5), tcore, qcgn, visc0
      common /subd/ istage, tbegin, totstage, tstage
      common /plte/ nplate, urtn(3,20)
      common /io01/ casenum, gpath,  lpath
      common /io02/ idump0, ngpath, nlpath
      common /prty/ propr(20)
      real orshl(129)
      character*8 titl, otitl(4,4)
      character gpath*80, lpath*80, cname*12, casenum*3
      character char1*1, char2*1, char3*1, char4*1, char5*1, char6*1
 
      iter   = 0
      time   = 0.
      step   = step0
 
      if(istrt.gt.0) then
 
c        New case:
 
         if(nplate .gt. 0) then
            if(istage .eq. 0) then
               call mapinit(f,wk)
            else
               call mapstage(f,wk)
            end if
            do ii=1,(nt+1)**2*nd*2
               pmap(ii) = real(map(ii))
            end do
         end if
         call tempinit(temp,istrt)
         call nulvec(u,   (nt+1)**2*nd*3*(nr+1))
         call nulvec(pres,(nt+1)**2*nd*(nr+1))
 
      else
 
c        Restart case:
 
         char1 = char(48 + mynum/1000)
         char2 = char(48 + mod(mynum/100,10))
         char3 = char(48 + mod(mynum/10,10))
         char4 = char(48 + mod(mynum,10))
         char5 = char(48 + idump0/10)
         char6 = char(48 + mod(idump0,10))
         cname = 'c'//casenum//'.'//char1//char2//char3//char4
     &                       //'.'//char5//char6
 
         open (7, file=cname, status='unknown')
 
         call vecin(temp,otitl,orshl,1,nr,7,1)
         call vecin(u   ,otitl,orshl,3,nr,7,0)
         call vecin(pres,otitl,orshl,1,nr,7,0)
 
         if(nplate .gt. 0) then
            if(propr(20) .gt. 0) then
               call vecin(pmap,otitl,orshl,1,1,7,1)
               do ii=1,(nt+1)**2*nd*2
                  map(ii) = int(pmap(ii))
               end do
            else
               if(istage .eq. 0) then
                  call mapinit(f,wk)
               else
                  call mapstage(f,wk)
               end if
               do ii=1,(nt+1)**2*nd*2
                  pmap(ii) = real(map(ii))
               end do
            endif
         endif
 
         close (7)
 
         if(imoon.eq.1) tb(2) = propr(15)
 
c        Impose temperature boundary conditions.
 
         do id=1,nd
            do ii=1,(nt+1)**2
               temp(ii,id,1) = tb(1)
               if(tb(2) .gt. 0.) temp(ii,id,nr+1) = tb(2)
            end do
         end do
 
         if(istrt .eq. 0) then
 
c           Restart case with history:
 
            iter = propr(1)
            time = propr(2)
c           call histrst(istrt)
 
         endif
 
      endif
 
      if(mynum.eq.0 .and. istrt.ne.0) then
         rewind 4
         propr(2) = 0.
         call proprty
         write(4,10) nr, titl, propr, (rshl(i),i=1,nr+1)
 10      format(i5/4(2x,4a8/),4(2x,1p5e12.4/),3(2x,6e12.4/))
      endif
 
      call layrav(temp,tav)
      tnrm  = smean(temp)
      tstep = 1.e-5*visc/(rho0*grav*(rshl(1) - rshl(nr+1)))
 
      end
*dk fldsout
      subroutine fldsout(idump)
 
c     This routine writes out the temperature, velocity, pressure,
c     and plate map fields.
 
      include 'size.h'
      include 'pcom.h'
      common /temp/ tpb(nt+1), temp((nt+1)**2,nd,nr+1), tpe(nt+1)
      common /velo/ upb(nt+1), u((nt+1)**2,nd,3,nr+1),  upe(nt+1)
      common /pres/ ppb(nt+1), pres((nt+1)**2,nd,nr+1), ppe(nt+1)
      common /map1/ pmap((nt+1)**2*nd*2)
      common /radl/ rshl(nr+1), ird, ibc
      common /plte/ nplate, urtn(3,20)
      common /io01/ casenum, gpath,  lpath
      common /io02/ idump0, ngpath, nlpath
      character gpath*80, lpath*80, cname*12, casenum*3
      character char1*1, char2*1, char3*1, char4*1, char5*1, char6*1
 
      char1 = char(48 + mynum/1000)
      char2 = char(48 + mod(mynum/100,10))
      char3 = char(48 + mod(mynum/10,10))
      char4 = char(48 + mod(mynum,10))
      char5 = char(48 + mod(idump/10,10))
      char6 = char(48 + mod(idump,10))
      cname = 'c'//casenum//'.'//char1//char2//char3//char4
     &                    //'.'//char5//char6
      iunit = 20
 
      open (iunit, file=lpath(1:nlpath)//cname, status='unknown')
 
      call proprty
 
      call vecout(temp,rshl,1,nr,nt,nr,iunit,1)
      call vecout(u   ,rshl,3,nr,nt,nr,iunit,0)
      call vecout(pres,rshl,1,nr,nt,nr,iunit,0)
 
      if(nplate .gt. 0) call vecout(pmap,rshl,1,nr,nt, 1,iunit,1)
 
      close (iunit)
 
      end
*dk fluxmax
      subroutine fluxmax(fmax)
 
c...  This routine finds the maximum value for the ratio of flux through
c...  a radial cell face to the adjacent cell volume for the purpose of
c...  time step control.
 
      include 'size.h'
      include 'pcom.h'
      common /velo/ upb(nt+1), u((nt+1)**2,nd,3,nr+1),  upe(nt+1)
      common /mesh/ xn((nt+1)**2,nd,3)
      common /radl/ rshl(nr+1), ird, ibc
      common /ndar/ arn((nt+1)**2),  arne((nt+1)**2),
     &              rarn((nt+1)**2), rarne((nt+1)**2)
      common /volm/ vol((nt+1)**2,nr+1,2)
      common /cycl/ iter, time, tstep, step
 
      fmax = 0.
 
      do ir=1,nr
 
         jr = ir + 1
         aa = 0.5*tstep*(0.5*(rshl(ir) + rshl(jr)))**2*arn(2)
     &        *min(vol(2,ir,2), vol(2,jr,2))
 
         do id=1,nd
 
            ii1 = 2
            if(mod(id,5) .eq. 1) ii1 = 1
 
            do ii=ii1,(nt+1)**2
               vfl  = aa*(((u(ii,id,1,ir) + u(ii,id,1,jr))*xn(ii,id,1)
     &                   + (u(ii,id,2,ir) + u(ii,id,2,jr))*xn(ii,id,2))
     &                   + (u(ii,id,3,ir) + u(ii,id,3,jr))*xn(ii,id,3))
               fmax = max(fmax, abs(vfl))
            end do
 
         end do
 
      end do
 
      if(nproc .gt. 1) call pmax(fmax)
 
      end
*dk gmtout
      subroutine gmtout(idump)
 
c     This routine is a driver to write out temperature and velocity
c     fields in a format that can be used by the graphics tool GMT.
 
      include 'size.h'
      include 'pcom.h'
      real rsh(129)
      common /flds/ f((nt+1)**2*nd,3,(nr+1),2)
      common /velo/ upb(nt+1), u((nt+1)**2*nd,3,(nr+1)),  upe(nt+1)
      common /temp/ tpb(nt+1), temp((nt+1)**2*nd*(nr+1)), tpe(nt+1)
      common /pres/ ppb(nt+1), pres((nt+1)**2*nd*(nr+1)), ppe(nt+1)
      common /shht/ shb(nt+1),  shr((nt+1)**2*nd*(nr+1)), she(nt+1)
      common /strn/ srate((nt+1)**2*nd*(nr+1))
      common /map1/ pmap((nt+1)**2*nd*2)
      common /radl/ rshl(nr+1), ird, ibc
      common /mesh/ xn((nt+1)**2,nd,3)
      common /plte/ nplate, urtn(3,20)
      common /prop/ ieos,  rho0, visc,  grav,  texpn, tcond,
     &              sheat, hgen, tb(2), cl410, cl660
      common /vis0/ vb(nt+1), vv((nt+1)**2*nd*(nr+1),2), ve(nt+1)
      common /vis1/ vscmax, rvscscl, tvscscl, pwrlawn, pwrlawsr, yldstrs
      common /vis2/ rdvsc(129), tactv(129), vscl(129)
      common /io01/ casenum, gpath,  lpath
      common /io02/ idump0, ngpath, nlpath
      character gpath*80, lpath*80, casenum*3
      character char1*1, char2*1, char3*1, char4*1, char5*1, char6*1
      character gmtpath*6, name1*19, name2*19, name3*19
 
c...  place gmt output into the local GMT directory
      gmtpath  = './GMT/'
 
      char1 = char(48 + mynum/1000)
      char2 = char(48 + mod(mynum/100,10))
      char3 = char(48 + mod(mynum/10,10))
      char4 = char(48 + mod(mynum,10))
      char5 = char(48 + idump/10)
      char6 = char(48 + mod(idump,10))
      name1 = 'gmt'//casenum//'.'//char1//char2//char3//char4
     &             //'.'//char5//char6//'.temp'
      name2 = 'gmt'//casenum//'.'//char1//char2//char3//char4
     &             //'.'//char5//char6//'.vec1'
      name3 = 'gmt'//casenum//'.'//char1//char2//char3//char4
     &             //'.'//char5//char6//'.vec2'
      iunit = 20
 
      call proprty
      call horizontvel(f(1,1,1,1),u)
      call uthetaphi(f(1,1,1,2),f(1,1,1,1),xn)
      call xntolatlong(f(1,1,1,1),xn)
 
      open (iunit, file=gmtpath//name1, status='unknown')
 
c     if(mt .ge. 128) then
c        do ir=1,nr/2+1
c           rsh(ir) = rshl(ir+ir-1)
c        end do
c        call sample(f,temp,1,nr,nt)
c        call vecoutgmt(f(1,4),f(1,1),rsh,nr/2,nt/2,nr/2,iunit,1)
c     else
         call vecoutgmt(temp,f(1,1,1,1),rshl,nr,nt,iunit,1)
c     end if
 
      close (iunit)
      open  (iunit, file=gmtpath//name2, status='unknown')
 
c     if(mt .ge. 128) then
c        call sample(f,u,3,nr,nt)
c        call vecoutgmt(f,rsh,nr/2,nt/2,nr/2,iunit,0)
c     else
         call vecoutgmt(f(1,1,1,2),f(1,1,1,1),rshl,nr,nt,iunit,0)
c     end if
 
      close (iunit)
      open  (iunit, file=gmtpath//name3, status='unknown')
 
c     if(mt .ge. 128) then
c        call sample(f,u,3,nr,nt)
c        call vecoutgmt(f,rsh,nr/2,nt/2,nr/2,iunit,0)
c     else
         call vecoutgmt(f(1,2,1,2),f(1,1,1,1),rshl,nr,nt,iunit,0)
c     end if
 
      close (iunit)
 
      end
*dk graphout
      subroutine graphout(idump)
 
c     This routine writes out the temperature, pressure, velocity,
c     shear heating, viscosity, and plate map fields.
 
      include 'size.h'
      include 'pcom.h'
      real rsh(129)
      common /flds/ f((nt+1)**2*nd*(nr+1),8)
      common /velo/ upb(nt+1), u((nt+1)**2*nd*3*(nr+1)),  upe(nt+1)
      common /temp/ tpb(nt+1), temp((nt+1)**2*nd*(nr+1)), tpe(nt+1)
      common /pres/ ppb(nt+1), pres((nt+1)**2*nd,(nr+1)), ppe(nt+1)
      common /shht/ shb(nt+1),  shr((nt+1)**2*nd*(nr+1)), she(nt+1)
      common /strn/ srate((nt+1)**2*nd*(nr+1))
      common /topo/ h((nt+1)**2*nd,3), g((nt+1)**2*nd,2)
      common /map1/ pmap((nt+1)**2*nd*2)
      common /radl/ rshl(nr+1), ird, ibc
      common /plte/ nplate, urtn(3,20)
      common /prop/ ieos,  rho0, visc,  grav,  texpn, tcond,
     &              sheat, hgen, tb(2), cl410, cl660
      common /vis0/ vb(nt+1), vv((nt+1)**2*nd*(nr+1),2), ve(nt+1)
      common /vis1/ vscmax, rvscscl, tvscscl, pwrlawn, pwrlawsr, yldstrs
      common /vis2/ rdvsc(129), tactv(129), vscl(129)
      common /io01/ casenum, gpath,  lpath
      common /io02/ idump0, ngpath, nlpath
      character gpath*80, lpath*80, cname*12, casenum*3
      character char1*1, char2*1, char3*1, char4*1, char5*1, char6*1
 
      char1 = char(48 + mynum/1000)
      char2 = char(48 + mod(mynum/100,10))
      char3 = char(48 + mod(mynum/10,10))
      char4 = char(48 + mod(mynum,10))
      char5 = char(48 + mod(idump/10,10))
      char6 = char(48 + mod(idump,10))
      cname = 'g'//casenum//'.'//char1//char2//char3//char4
     &                    //'.'//char5//char6
      iunit = 20
 
      call proprty
 
      open (iunit, file=lpath(1:nlpath)//cname, status='unknown')
 
      do ir=1,nr/2+1
         rsh(ir) = rshl(ir+ir-1)
      end do
 
c     call topogrph
 
c...  Write geoid field to graphics file.
 
      if(mt .ge. 128) then
         call sample(f,g,1,0,nt)
         call vecout(f,rsh,1,nr/2,nt/2,0,iunit,0)
      else
         call vecout(g,rshl,1,nr,nt,0,iunit,0)
      end if
 
c...  Write topography fields to graphics file.
 
      if(mt .ge. 128) then
         call sample(f,h,2,0,nt)
         call vecout(f,rsh,1,nr/2,nt/2,1,iunit,0)
      else
         call vecout(h,rshl,1,nr,nt,1,iunit,0)
      end if
 
c...  Write plate map field to graphics file.
 
      if(nplate .gt. 0) then
         if(mt .ge. 128) then
            call sample(f,pmap,2,0,nt)
            call vecout(f,rsh,1,nr/2,nt/2,1,iunit,1)
         else
            call vecout(pmap,rshl,1,nr,nt,1,iunit,1)
         end if
      end if
 
c...  Write temperature field to graphics file.
 
      if(mt .ge. 128) then
         call sample(f,temp,1,nr,nt)
         call vecout(f,rsh,1,nr/2,nt/2,nr/2,iunit,1)
      else
         call vecout(temp,rshl,1,nr,nt,nr,iunit,1)
      end if
 
c...  Write velocity field to graphics file.
 
      if(mt .ge. 128) then
         call sample(f,u,3,nr,nt)
         call vecout(f,rsh,3,nr/2,nt/2,nr/2,iunit,0)
      else
         call vecout(u,rshl,3,nr,nt,nr,iunit,0)
      end if
 
c...  Write viscosity field to graphics file.
 
      if(vscmax.gt.0. .and. tvscscl.gt.0.) then
 
         lvf = 1.45*log(real(mt))
         do ir=1,nr+1
            jj = (ir-1)*(nt+1)**2*nd
            do ii=1,(nt+1)**2*nd
               if(vv(ii+jj,1) .gt. 0.)
     &            f(ii+jj,1) = log10(visc*vv(ii+jj,1)**2)
            end do
         end do
 
         if(mt .ge. 128) then
            call sample(f(1,2),f,1,nr,nt)
            call vecout(f(1,2),rsh,1,nr/2,nt/2,nr/2,iunit,0)
         else
            call vecout(f,rshl,1,nr,nt,nr,iunit,0)
         end if
 
      end if
 
c...  Write shear heating rate field to graphics file.
 
      if(ieos .ge. 10) then
         if(mt .ge. 128) then
            call sample(f,shr,1,nr,nt)
            call vecout(f,rsh,1,nr/2,nt/2,nr/2,iunit,0)
         else
            call vecout(shr,rshl,1,nr,nt,nr,iunit,0)
         end if
      end if
 
c...  Write strain rate field to graphics file.
 
      if(mt .ge. 128) then
         call sample(f,srate,1,nr,nt)
         call vecout(f,rsh,1,nr/2,nt/2,nr/2,iunit,0)
      else
         call vecout(srate,rshl,1,nr,nt,nr,iunit,0)
      end if
 
      close (iunit)
 
      end
*dk history
      subroutine history(lreport)
 
c     This routine writes on file 4 data describing the time history
c     of the convection calculation.  If the level of reporting lreport
c     is high enough, the routine also writes part of this information
c     on output file 6.
 
      include 'size.h'
      include 'pcom.h'
      common /prop/ ieos,  rho0, visc,  grav,  texpn, tcond,
     &              sheat, hgen, tb(2), cl410, cl660
      common /cycl/ iter, time, tstep, step
      common /nrms/ fnrm, rnrm, unrm, ekin
      common /heat/ htop, hbot, hrad, heat, hshr, hvol, hnet, tnrm,
     &              tav(129), qc(128)
      common /solv/ itreq, convrg, divnorm, cutdiv
      common /plte/ nplate, urtn(3,20)
      common /volc/ tmpmlt
 
      if(mynum .eq. 0) write(4,10) real(iter), time, tstep, step,
     &   fnrm, rnrm, divnorm/cutdiv, unrm, ekin, htop, hbot,
     &   hrad, heat, hshr, hvol, hnet, tnrm, (tav(i),i=1,nr+1)
 10   format(2x,1p6e12.4,6x)
 
      if(lreport+int(1.45*log(real(mt)))+1.lt.6) return
 
      if(mynum .eq. 0) write(6,20) tnrm, ekin, divnorm/cutdiv
 20   format(6x,'NORMS:  TEMP',1pe10.3,'  KE',e10.3,
     &       '    PRES CONVERGENCE:',e10.3)
 
      if(mynum .eq. 0) write(6,30)
      if(mynum .eq. 0) write(6,40) (tav(ir),ir=1,nr+1)
 30   format(27x,'MEAN LAYER TEMPERATURES')
 40   format(1x,9f8.1)
 
      if(mynum .eq. 0) write(6,50) htop, (qc(ir),ir=1,nr), hbot
 50   format(15x,' TOTAL RADIAL CONDUCTIVE HEAT FLOW BY LAYER',
     &   6(/1x,1p6e12.3))
 
      if(mynum .eq. 0) write(6,60) hbot, htop, heat, hrad, hshr,
     &   hnet, hvol
 60   format(6x,'INFLOW: ',1pe10.3,'   OUTFLOW:',e10.3,
     &       3x,'SHELL HEATING: ',e10.3/2x,'RADIOGENIC: ',
     &       e10.3,5x,'SHEAR:',e10.3,4x,'CONSERVATION: ',e10.3/
     &       4x,'VOLCANIC: ',e10.3)
 
      if(nplate .gt. 0) then
         call contarea(carea)
         if(mynum .eq. 0) write(6,70) carea
 70      format(25x,'CONTINENTAL AREA =',f6.3)
      endif
 
      if(time.gt.1000.) then
         if(mynum .eq. 0) write(6,80) step, 3.1688e-8*tstep, time
 80      format(3x,'ADVECTION STEP =',f7.4,3x,'TIME STEP =',1pe10.3,
     &          3x,'TIME =',e10.3,' YR')
      else
         if(mynum .eq. 0) write(6,90) step, 1.1574e-5*tstep, time*365.25
 90      format(3x,'ADVECTION STEP =',f7.4,3x,'TIME STEP =',1pe10.3,
     &          3x,'TIME =',e10.3,' DAYS')
      endif
 
c     call flush
 
      end
*dk histrst
      subroutine histrst(istrt)
 
c     This routine reads the history file from logical unit 4.
 
      include 'size.h'
      real w(100), propr(20), rshl(129)
      character*8 titl(4,4)
      common /cycl/ iter, time, tstep, step
 
      k = 17 + nr + 1
 
      read(4,10) m, titl, propr, (rshl(i),i=1,nr+1)
 10   format(i5/4(2x,4a8/),4(2x,1p5e12.4/),3(2x,6e12.4/))
 
      if(m .ne. nr) stop
 
      it = 0
 20   it = it + 1
 
      read(4,30) (w(i),i=1,k)
 30   format(2x,1p6e12.4,6x)
 
      if(int(w(1)+0.1).lt.iter) go to 20
 
      if(istrt .eq. 0) step = w(4)
 
      end
*dk lunar
      subroutine lunar
 
c     This routine computes the heat generation rate and the
c     core-mantle boundary temperature for a time-dependent
c     simulation of history of the lunar mantle.
 
      include 'size.h'
      include 'pcom.h'
      common /radl/ rshl(nr+1), ird, ibc
      common /prop/ ieos,  rho0, visc,  grav,  texpn, tcond,
     &              sheat, hgen, tb(2), cl410, cl660
      common /cycl/ iter, time, tstep, step
      common /heat/ htop, hbot, hrad, heat, hshr, hvol, hnet, tnrm,
     &              tav(129), qc(128)
      common /nrms/ fnrm, rnrm, unrm, ekin
      common /conv/ istrt, itmax, step0, stepmin, stepmax, dtdump
      common /moon/ imoon, radis(5), tcore, qcgn, visc0
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
      common /call/ ncall
 
      if(time .lt. 4.5e8) time = 4.5e8
 
      hgen = radis(1)*94.35e-6*exp(1.1013e-10*(4.55e9 - time))
     &     + radis(2)* 4.05e-6*exp(9.8485e-10*(4.55e9 - time))
     &     + radis(3)*26.60e-6*exp(0.4948e-10*(4.55e9 - time))
     &     + radis(4)* 3.50e-9*exp(5.5440e-10*(4.55e9 - time))
      hgen = 0.6*hgen
 
      aa   = 0.75*tstep/(451.*7874.*3.14159*rshl(nr+1)**3)
      if(tb(2) .ne. 0.) tb(2) = tb(2) - aa*hbot
 
      visc = visc0*exp(48000./tnrm - 48000./1500.)
 
      if(mod(iter,100).eq.1 .and. mynum.eq.0) write(6,10) hgen, tb(2),
     &   visc
 10   format(3x,'HGEN =',1pe10.3,3x,'CMB TEMP =',e10.3,
     &       3x,'VISC =',  e10.3)
 
      if(tav(3).lt.1200.) ibc = 5
 
      if(time .gt. 2.e8) dtdump = 1.e8
      if(time .gt. 2.e9) dtdump = 5.e8
 
c     if(dtmovi.gt.0.) dtmovi = 1.5e-4/(unrm + 1.e-40)
c     dtmovi = min(dtmovi, 5.e7)
 
      end
*dk radialout
      subroutine radialout
 
c...  This routine writes out the radial profiles and other information
c...  needed to plot these profiles.
 
      include 'size.h'
      common /name/ titl(4,4)
      common /prop/ ieos,  rho0, visc,  grav,  texpn, tcond,
     &              sheat, hgen, tb(2), cl410, cl660
      common /cycl/ iter, time, tstep, step
      common /heat/ htop, hbot, hrad, heat, hshr, hvol, hnet, tnrm,
     &              tav(129), qc(128)
      common /radl/ rshl(nr+1), ird, ibc
      common /eos1/ rhorf(129), tmprf(129), drhdp(129), grv(129)
      common /eos2/ rhocv(129), gamma(129), alpha(129), prf(129),
     &               cond(129)
      common /vis2/ rdvsc(129), tactv(129), vscl(129)
      common /shrh/ shrlayr(129)
      common /urut/ ur(129), ut(129)
      common /io01/ casenum, gpath,  lpath
      common /io02/ idump0, ngpath, nlpath
      character casenum*3, gpath*80, lpath*80, cname*9
      character titl*8
 
      cname = 'radial'//casenum
 
      open (33, file=cname, status='unknown')
 
      write(33, '(4a8)') titl
 
      write(33, '(/)')
 
      write(33, '(i5,1p5e12.5)') ieos, rho0, visc, grav, texpn, tcond
      write(33, '(5x,1p5e12.5)') sheat, hgen, tb, time
 
      write(33, '(/"     rshl       rhorf       tmprf   ",
     &             "     tav         prf         grv "/)')
 
      do ir=1,nr+1
         write(33, '(1p6e12.5)')  rshl(ir), rhorf(ir), tmprf(ir),
     &                             tav(ir),   prf(ir),   grv(ir)
      end do
 
      write(33, '(/"     rshl         ur          ut    ",
     &             "      qc       shrlayr      rdvsc"/)')
 
      do ir=1,nr+1
         qcnd = hbot
         if(ir .le. nr) qcnd = qc(ir)
         write(33, '(1p6e12.5)')  rshl(ir),    ur(ir),    ut(ir),
     &                            qcnd, shrlayr(ir), rdvsc(ir)
      end do
 
      write(33, '(/"     rshl        cond       alpha   ",
     &             "    gamma       rhocv       drhdp"/)')
 
      do ir=1,nr+1
         write(33, '(1p6e12.5)')  rshl(ir),  cond(ir), alpha(ir),
     &                           gamma(ir), rhocv(ir), drhdp(ir)
      end do
 
      close (33)
 
      end
*dk raylnuss
      subroutine raylnuss
 
c     This routine computes the Rayleigh and Nusselt numbers.
 
      include 'size.h'
      real bmr(129), rcp(129)
      common /radl/ rshl(nr+1), ird, ibc
      common /prop/ ieos,  rho0, visc,  grav,  texpn, tcond,
     &              sheat, hgen, tb(2), cl410, cl660
      common /cycl/ iter, time, tstep, step
      common /heat/ htop, hbot, hrad, heat, hshr, hvol, hnet, tnrm,
     &              tav(129), qc(128)
      common /eos1/ rhorf(129), tmprf(129), drhdp(129), grv(129)
      common /eos2/ rhocv(129), gamma(129), alpha(129), prf(129),
     &               cond(129)
      common /vis2/ rdvsc(129), tactv(129), vscl(129)
      common /rayl/ rayl, anuss
 
      rmax = rshl(1)
      rmin = rshl(nr+1)
      tadb = 0.
 
      if(ieos.gt.5) then
 
         rl     = 0.
         rlh    = 0.
         sheat  = 0.
         texpn  = 0.
         tcond  = 0.
 
         do ir=1,nr+1
            rcp(ir) = rhocv(ir)*(1.+alpha(ir)*gamma(ir)*tav(ir))
            rcp(ir) = rcp(ir)/rdvsc(ir)
         end do
 
         do ir=1,nr
            rt = rshl(ir)
            rb = rshl(ir+1)
            r3 = (rt**3 - rb**3)/3.
            r4 = (rt**4 - rb**4)/4.
            at = alpha(ir  )*grv(ir  )*rhorf(ir  )*rcp(ir  )/cond(ir  )
            ab = alpha(ir+1)*grv(ir+1)*rhorf(ir+1)*rcp(ir+1)/cond(ir+1)
            bt = rhorf(ir  )/cond(ir  )*at
            bb = rhorf(ir+1)/cond(ir+1)*ab
            ct = rhocv(ir  )/rhorf(ir  )
            cb = rhocv(ir+1)/rhorf(ir+1)
            et = alpha(ir  )
            eb = alpha(ir+1)
            rdr   = 1./(rt - rb)
            rl    = rl    + (r4*(at - ab) + r3*(ab*rt - at*rb))*rdr
            rlh   = rlh   + (r4*(bt - bb) + r3*(bb*rt - bt*rb))*rdr
            sheat = sheat + (r4*(ct - cb) + r3*(cb*rt - ct*rb))*rdr
            texpn = texpn + (r4*(et - eb) + r3*(eb*rt - et*rb))*rdr
            tcond = tcond + 0.5*(cond(ir) + cond(ir+1))*(rt - rb)
         end do
 
         rvol  = 3./(rmax**3 - rmin**3)
         rl    = rvol*rl
         rlh   = rvol*rlh
         sheat = rvol*sheat
         texpn = rvol*texpn
         tcond = tcond/(rmax - rmin)
 
         dx      = 0.05
         bmr( 1) = (1. + alpha( 1)*gamma( 1)*tav( 1))/drhdp( 1)
 
         do ir=2,nr+1
            bmr(ir) = (1. + alpha(ir)*gamma(ir)*tav(ir))/drhdp(ir)
            dr      = (rshl(ir-1) - rshl(ir))*dx
            x       = -0.5*dx
            do i=1,20
               x       =  x + dx
               omx     = 1. - x
               tadb    = tadb + dr*(x*gamma(ir-1) + omx*gamma(ir))
     &                            *(x*  grv(ir-1) + omx*  grv(ir))
     &                            *(x*  tav(ir-1) + omx*  tav(ir))
     &                            /(x*  bmr(ir-1) + omx*  bmr(ir))
            end do
         end do
 
      else
 
         vc  = 0.
 
         do ir=1,nr
            rt = rshl(ir)
            rb = rshl(ir+1)
            r3 = (rt**3 - rb**3)/3.
            r4 = (rt**4 - rb**4)/4.
            at = rdvsc(ir  )
            ab = rdvsc(ir+1)
            vc = vc + (r4*(at - ab) + r3*(ab*rt - at*rb))/(rt - rb)
         end do
 
         rv  = (rmax**3 - rmin**3)/(3.*vc)
         rl  = texpn*grav*rho0**2*sheat*rv/tcond
         rlh = rl*rho0/tcond
 
      endif
 
      if(ieos/10 .eq. 2) tadb = 1200.
 
      if(tb(2).ne.0.) then
         rayl  = rl*(tb(2) - tb(1) - tadb)*(rmax - rmin)**3/visc
         anuss = htop*(rmax - rmin)/(12.56637*tcond*rmax*rmin
     &           *(tb(2) - tb(1)))
      else
         rayl  = rlh*hgen*(rmax - rmin)**5/visc
         eta   = rmin/rmax
         anuss = hgen*rho0*rmax**2*(1. - eta**2*(3. - 2.*eta))/
     &           (6.*tcond*(tav(nr) - tb(1)))
      endif
 
      write(6,10) anuss, rayl, tadb, time
 10   format(/6x,'NUSSELT NUMBER =',1pe10.3,6x,'RAYLEIGH NUMBER =',
     &   e10.3/16x,'TADB =',e10.3,9x,'ELAPSED TIME =',e10.3,' YR'/)
 
      write(6,20) (rdvsc(ir),ir=1,nr+1)
 20   format(22x,'RADIAL VISCOSITY FACTORS:',9(/1x,8f9.3))
 
      end
*dk wrapup
      subroutine wrapup
 
      include 'size.h'
      include 'pcom.h'
      common /velo/ upb(nt+1), u((nt+1)**2,nd,3,nr+1),  upe(nt+1)
      common /temp/ tpb(nt+1), temp((nt+1)**2,nd,nr+1), tpe(nt+1)
      common /radl/ rshl(nr+1), ird, ibc
      common /prop/ ieos,  rho0, visc,  grav,  texpn, tcond,
     &              sheat, hgen, tb(2), cl410, cl660
      common /cycl/ iter, time, tstep, step
      common /heat/ htop, hbot, hrad, heat, hshr, hvol, hnet, tnrm,
     &              tav(129), qc(128)
      common /eos1/ rhorf(129), tmprf(129), drhdp(129), grv(129)
      common /eos2/ rhocv(129), gamma(129), alpha(129), prf(129),
     &               cond(129)
      common /name/ titl(4,4)
      common /rayl/ rayl, anuss
      character*8 titl
      real tempav(129)
 
      if(mynum .eq. 0) write(6,10) titl(1,1), rshl(1), rshl(nr+1), rho0,
     &   visc, texpn, tcond, sheat, hgen, grav, tb
 10   format(1h1,28x,a8,' SUMMARY'//32x,'INPUT DATA'/
     &/9x,'OUTER RADIUS OF SHELL              ',1pe10.3,' M',
     &/9x,'INNER RADIUS OF SHELL              ',1pe10.3,' M',
     &/9x,'REFERENCE DENSITY                  ',1pe10.3,' KG/M**3',
     &/9x,'DYNAMIC VISCOSITY                  ',1pe10.3,' PA-SEC',
     &/9x,'COEFFICIENT OF THERMAL EXPANSION   ',1pe10.3,' 1/K',
     &/9x,'THERMAL CONDUCTIVITY               ',1pe10.3,' W/M/K',
     &/9x,'SPECIFIC HEAT                      ',1pe10.3,' J/KG/K',
     &/9x,'RADIOGENIC HEAT PRODUCTION RATE    ',1pe10.3,' W/KG',
     &/9x,'GRAVITATIONAL ACCELERATION         ',1pe10.3,' M/SEC*2',
     &/9x,'TEMPERATURE OF OUTER BOUNDARY      ',1pe10.3,' K',
     &/9x,'TEMPERATURE OF INNER BOUNDARY      ',1pe10.3,' K')
 
      if(ieos.ge.10 .and. mynum.eq.0) write(6,30)
 30   format(/14x,'SHELL MATERIAL IS TREATED AS A COMPRESSIBLE,',
     &/14x,'ISOTROPIC, HOMOGENEOUS, LINEAR VISCOUS FLUID',
     &/15x,'WITH A MORSE POTENTIAL EQUATION OF STATE.')
      if(ieos.le.5 .and. mynum.eq.0) write(6,40)
 40   format(/13x,'SHELL MATERIAL IS TREATED AS AN INCOMPRESSIBLE,',
     &/14x,'ISOTROPIC, HOMOGENEOUS, LINEAR VISCOUS FLUID.')
 
      if(mynum .eq. 0) write(6,50)
 50   format(/14x,'SHELL BOUNDARIES ARE TREATED AS UNDEFORMABLE,',
     &/21x,'ISOTHERMAL, AND TRACTION-FREE.')
 
      if(hgen.eq.0. .and. mynum.eq.0) write(6,60)
 60   format(/12x,'SHELL IS HEATED STRICTLY FROM ITS INNER BOUNDARY.')
      if(hgen.gt.0. .and. mynum.eq.0) write(6,70)
 70   format(/9x,'SHELL IS HEATED PARTIALLY FROM INTERNAL ',
     &   'RADIOACTIVITY.')
 
      if(mynum .eq. 0) write(6,80) (10*mt**2+2)*(nr+1), 20*mt**2*nr, nr
 80   format(/16x,'GRID DERIVED FROM REGULAR ICOSAHEDRON HAS',
     &/24x,i10,' NODES'/24x,i10,' ELEMENTS',
     &/21x,i3,' RADIAL LAYERS OF ELEMENTS'/)
 
      call surfvel(usurf,u)
      tngarea = 12.56637*rshl(1)**2
      if(mynum .eq. 0) write(6,90) rayl, anuss, usurf, 3.1558e9*usurf,
     &   htop/tngarea, time
 90   format(/30x,'OUTPUT DATA'/
     &/16x,'RAYLEIGH NUMBER           ',1pe10.3,
     &/16x,'NUSSELT NUMBER            ',1pe10.3,
     &/16x,'RMS  SURFACE VELOCITY     ',1pe10.3,' M/SEC ',
     &/16x,'                          ',1pe10.3,' CM/YR ',
     &/16x,'MEAN SURFACE HEAT FLUX    ',1pe10.3,' W/M2  ',
     &/16x,'TOTAL ELAPSED RUN TIME    ',1pe10.3,' YR    ')
 
      lvr = 1.45*log(real(nr))
      call layrav(temp,tempav)
      if(mynum .eq. 0) write(6,120)
 120  format(/60x,'RADIAL'/32x,'LAYER AVERAGES',12x,'CONDUCTIVE',
     &/16x,'DEPTH    DENSITY   PRESSURE  TEMPERATURE   HEAT FLOW',
     &/16x,' (KM)    (KG/M3)     (PA)        (K)          (W)')
 
      do ir=1,nr+1
      depth = rshl(1) - rshl(ir)
      if(mynum .eq. 0) write(6,140) depth,rhorf(ir),prf(ir),tempav(ir)
 140  format(5x,'---------- ',-3pf6.1,1p3e11.3,' -------------')
      if(ir.le.nr .and. mynum.eq.0) write(6,160) ir, qc(ir)
 160  format(6x,'LAYER ',i3,42x,1pe11.3)
      end do
 
      end
