*DK driver
      program terra
 
      include 'size.h'
      include 'pcom.h'
      common /flds/ f(nv*8)
      common /velo/ upb(nt+1), u( 3*nv), upe(nt+1)
      common /temp/ tpb(nt+1), temp(nv), tpe(nt+1)
      common /pres/ ppb(nt+1), pres(nv), ppe(nt+1)
      common /name/ titl(4,4)
      common /radl/ rshl(nr+1), ird, ibc
      common /radi/ rmin, rmax
      common /mgrd/ itlimit, convtol, lreport, itsolve, izerou
      common /conv/ istrt, itmax, step0, stepmin, stepmax, dtdump
      common /prop/ ieos,  rho0, visc,  grav,  texpn, tcond,
     &              sheat, hgen, tb(2), cl410, cl660
      common /vis1/ vscmax, rvscscl, tvscscl, pwrlawn, pwrlawsr, yldstrs
      common /plte/ nplate, urtn(3,20)
      common /subd/ istage, tbegin, totstage, tstage
      common /volc/ tmpmlt
      common /moon/ imoon, radis(5), tcore, qcgn, visc0
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
      common /io01/ casenum, gpath,  lpath
      common /io02/ idump0, ngpath, nlpath
      character*8  titl
      character gpath*80, lpath*80
      character casenum*3
 
      mynum  = 0
      nproc  = (mt/nt)**2*10/nd
      lvproc = 1.45*log(real(mt/nt))
      mproc  = 2**(2*lvproc)
      gpath  = './'
      ngpath = 2
 
c...  Initialize parallel communications.
 
      if(nproc .gt. 1) call pinit
 
c...  Read input data.
 
      open (5, file='interra', status='old')
 
      read (5,10) titl, casenum, ird, ibc, rmin, rmax, itlimit, convtol,
     &   lreport, istrt, itmax, idump0, dtdump, step0, stepmin, stepmax,
     &   ieos, rho0, visc, grav, texpn, tcond, sheat, hgen, tb, cl410,
     &   cl660, vscmax, rvscscl, tvscscl, pwrlawn, pwrlawsr, yldstrs,
     &   nplate, istage, tmpmlt, dtmovi, ispec, iclr, icsl, isctn,
     &   ieqar, ipole, nequa, nskp, imap, icptn, reflng
 10   format(4(4a8/),7x,a3/2(i10/),2(1pe10.3/),i10/,e10.3/4(i10/),
     &   4(e10.3/),i10/17(e10.3/),2(i10/),2(e10.3/),10(i10/),e10.3)
 
      close (5)
 
      lpath  =  gpath
      nlpath = ngpath
 
c...  Open additional input files.
 
      if(mynum .eq. 0) then
         open (4,  file='hst'//casenum,    status='unknown')
         open (6,  file='out'//casenum,    status='unknown')
         open (17, file='radcor'//casenum, status='unknown')
         open (18, file='har'//casenum,    status='unknown')
         open (19, file='mas'//casenum,    status='unknown')
      endif
 
c     open (10, file='mapdat'   , status='unknown')
 
c...  Echo input data to output file.
 
      if(mynum .eq. 0) write(6,20) titl, nproc, nr, nt, ird, ibc,
     &   rmin, rmax, itlimit, convtol, lreport, istrt, itmax, idump0,
     &   dtdump, step0, stepmin, stepmax, ieos, rho0, visc,
     &   grav, texpn, tcond, sheat, hgen, tb, cl410, cl660,
     &   vscmax, rvscscl, tvscscl, pwrlawn, pwrlawsr, yldstrs,
     &   nplate, istage, tmpmlt, dtmovi, ispec, iclr, iscl,
     &   isctn, ieqar, ipole, nequa, nskp, imap, icptn, reflng
 
 20   format(4(4a8/)/,      'NPROC    = ',    i10/,
     &  'NR       = ',  i10/'NT       = ',    i10/'IRD      = ',  i10/,
     &  'IBC      = ',  i10/'RMIN     = ',1pe10.3/'RMAX     = ',e10.3/,
     &  'ITLIMIT  = ',  i10/'CONVTOL  = ',  e10.3/'LREPORT  = ',  i10/,
     &  'ISTRT    = ',  i10/'ITMAX    = ',    i10/'IDUMP0   = ',  i10/,
     &  'DTDUMP   = ',e10.3/'STEP0    = ',  e10.3/,
     &  'STEPMIN  = ',e10.3/'STEPMAX  = ',  e10.3/,
     &  'IEOS     = ',  i10/'RHO0     = ',  e10.3/'VISC     = ',e10.3/,
     &  'GRAV     = ',e10.3/'TEXPN    = ',  e10.3/'TCOND    = ',e10.3/,
     &  'SHEAT    = ',e10.3/'HGEN     = ',  e10.3/'TB(1)    = ',e10.3/,
     &  'TB(2)    = ',e10.3/'CL410    = ',  e10.3/'CL660    = ',e10.3/,
     &  'VSCMAX   = ',e10.3/'RVSCSCL  = ',  e10.3/'TVSCSCL  = ',e10.3/,
     &  'PWRLAWN  = ',e10.3/'PWRLAWSR = ',  E10.3/'YLDSTRS  = ',e10.3/,
     &  'NPLATE   = ',  i10/'ISTAGE   = ',    i10/'TMPMLT   = ',e10.3/,
     &  'DTMOVI   = ',e10.3/'ISPEC    = ',    i10/'ICLR     = ',  i10/,
     &  'ISCL     = ',  i10/'ISCTN    = ',    i10/'IEQAR    = ',  i10/,
     &  'IPOLE    = ',  i10/'NEQUA    = ',    i10/'NSKP     = ',  i10/,
     &  'IMAP     = ',  i10/'ICPTN    = ',    i10/'REFLNG   = ',e10.3/)
 
      if(lreport.eq.6) lreport = 5 - int(1.45*log(real(mt)))
      rshl(1)    = rmax
      rshl(nr+1) = rmin
 
c     if(mynum .eq. 0) call gplotnew(casenum)
 
c...  Perform convection calculation.
 
      call convect
 
c     if(mynum .eq. 0) call gdone
 
c...  Leave PVM before exiting.
 
      if(nproc .gt. 1) call pexit
 
      stop
      end
*dk second
c     subroutine second(time)
 
c     real time
c     time=0.
 
c     end
      block data bdterra
 
      common /radi/ rmin, rmax
      common /mgrd/ itlimit, convtol, lreport, itsolve, izerou
      common /conv/ istrt, itmax, step0, stepmin, stepmax, dtdump
      common /prop/ ieos,  rho0, visc,  grav,  texpn, tcond,
     &              sheat, hgen, tb(2), cl410, cl660
      common /vis1/ vscmax, rvscscl, tvscscl, pwrlawn, pwrlawsr, yldstrs
      common /plte/ nplate, urtn(3,20)
      common /subd/ istage, tbegin, totstage, tstage
      common /volc/ tmpmlt
      common /moon/ imoon, radis(5), tcore, qcgn, visc0
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
 
      data rmin/3.48e6/, rmax/6.37e6/
      data itlimit/10/, lreport/6/, convtol/0.01/, istrt/0/, itmax/500/
      data step0/0.01/, stepmin/1.e-6/, stepmax/0.10/, dtdump/0./
      data ieos/1/, rho0/4.5e3/, visc/1.0e23/, grav/10.0/,
     &     texpn/2.5e-5/, tcond/4.0/, sheat/1.0e3/, hgen/0.0/,
     &     tb/300.,2300./, cl410/0.0e6/, cl660/-0.0e6/
      data vscmax/0./, rvscscl/0./, tvscscl/0./
      data pwrlawn/0./, pwrlawsr/1.e-15/, yldstrs/0./
      data nplate/0/, istage/0/, tmpmlt/0./
      data ispec/3/, iclr/1/, iscl/0/, isctn/0/, ieqar/1/,
     &     ipole/0/, nskp/5/, irmax/65/, imap/0/, nequa/0/, icptn/1/,
     &     reflng/0./, dtmovi/0./
      data imoon/0/, radis/0.033e-6, 0.033e-6, 0.125e-6, 83.e-6, 0./
      data tcore/2500./, qcgn/0.e12/, visc0/2.e20/
 
      end
