      program dumpadd
 
c...  This program reads a TERRA dump generated with nd=5 and creates
c...  another TERRA dump with nd=10 for half as many processors.
 
      include 'size.h'
      include 'pcom.h'
      real temp0((nt+1)**2, 5,nr+1), u0((nt+1)**2, 5,3,nr+1)
      real pres0((nt+1)**2, 5,nr+1), pmap0((nt+1)**2, 5,2)
      real temp1((nt+1)**2, 5,nr+1), u1((nt+1)**2, 5,3,nr+1)
      real pres1((nt+1)**2, 5,nr+1), pmap1((nt+1)**2, 5,2)
      real temp2((nt+1)**2,10,nr+1), u2((nt+1)**2,10,3,nr+1)
      real pres2((nt+1)**2,10,nr+1), pmap2((nt+1)**2,10,2)
      real rshl(129)
      common /prty/ propr(20)
      common /name/ titl(4,4)
      character titl*8, cname*12, casenum*3
      character char1*1, char2*1, char3*1, char4*1, char5*1, char6*1
 
      npart = 8
      nproc = (mt/nt)**2/npart
 
      CALL MPI_INIT( IERROR )
      CALL MPI_COMM_RANK( MPI_COMM_WORLD, MYNUM, IERROR )
      CALL MPI_COMM_SIZE( MPI_COMM_WORLD, NPROC, IERROR )
 
c     write(*, '("What is the three-digit case number?")')
c     read (*, '(a3)') casenum
 
c     write(*, '("What is the two-digit dump number?")')
c     read (*, '(i2)') idump
 
      casenum = '601'
      idump   =   01
 
      do ipart=0,npart-1
 
      iproc = mynum + ipart*nproc
      jproc = iproc + npart*nproc
      char5 = char(48 + idump/10)
      char6 = char(48 + mod(idump,10))
 
      char1 = char(48 + jproc/1000)
      char2 = char(48 + mod(jproc/100,10))
      char3 = char(48 + mod(jproc/10,10))
      char4 = char(48 + mod(jproc,10))
      cname = 'c'//casenum//'.'//char1//char2//char3//char4
     &                     //'.'//char5//char6
 
      open (7, file=cname, status='unknown')
 
c...  Read in temperature, velocity, pressure, and plate map fields.
 
      call vecin(temp1,titl,rshl,1,nr,7,1)
      call vecin(u1   ,titl,rshl,3,nr,7,0)
      call vecin(pres1,titl,rshl,1,nr,7,0)
 
      if(propr(20) .gt. 0.) call vecin(pmap1,titl,rshl,1,1,7,1)
 
      close (7)
 
      char1 = char(48 + iproc/1000)
      char2 = char(48 + mod(iproc/100,10))
      char3 = char(48 + mod(iproc/10,10))
      char4 = char(48 + mod(iproc,10))
      cname = 'c'//casenum//'.'//char1//char2//char3//char4
     &                     //'.'//char5//char6
 
      open (7, file=cname, status='unknown')
 
c...  Read in temperature, velocity, pressure, and plate map fields.
 
      call vecin(temp0,titl,rshl,1,nr,7,1)
      call vecin(u0   ,titl,rshl,3,nr,7,0)
      call vecin(pres0,titl,rshl,1,nr,7,0)
 
      if(propr(20) .gt. 0) call vecin(pmap0,titl,rshl,1,1,7,1)
 
c...  Combine the arrays from the two dump files into one.
 
      do ir=1,nr+1
         do id=1,5
            jd = id + 5
            do ii=1,(nt+1)**2
               temp2(ii,id,ir) = temp0(ii,id,ir)
               temp2(ii,jd,ir) = temp1(ii,id,ir)
               pres2(ii,id,ir) = pres0(ii,id,ir)
               pres2(ii,jd,ir) = pres1(ii,id,ir)
               u2( ii,id,1,ir) = u0( ii,id,1,ir)
               u2( ii,id,2,ir) = u0( ii,id,2,ir)
               u2( ii,id,3,ir) = u0( ii,id,3,ir)
               u2( ii,jd,1,ir) = u1( ii,id,1,ir)
               u2( ii,jd,2,ir) = u1( ii,id,2,ir)
               u2( ii,jd,3,ir) = u1( ii,id,3,ir)
            end do
         end do
      end do
 
      if(propr(20) .gt. 0.) then
         do id=1,5
            jd = id + 5
            do ii=1,(nt+1)**2
               pmap2(ii,id,1) = pmap0(ii,id,1)
               pmap2(ii,jd,1) = pmap1(ii,id,1)
               pmap2(ii,id,2) = pmap0(ii,id,2)
               pmap2(ii,jd,2) = pmap1(ii,id,2)
            end do
         end do
      end if
 
c...  Overwrite the file with the process number less than nproc with
c...  the new nd=10 arrays.
 
      rewind (7)
 
      call vecout(temp2,rshl,1,nr,nt,nr,7,1)
      call vecout(u2   ,rshl,3,nr,nt,nr,7,0)
      call vecout(pres2,rshl,1,nr,nt,nr,7,0)
      if(propr(20) .gt. 0.)
     &   call vecout(pmap2,rshl,1,nr,nt,1,7,1)
 
      close (7)
 
      end do
 
      CALL MPI_FINALIZE( IERROR )
 
      end
*dk vecin
      subroutine vecin(u,titl,rshl,nj,mr,nf,ifmt)
 
c...  This routine reads the nodal field u from logical unit nf
c...  using 1pe10.3 format when ifmt = 0 and f10.3 when ifmt = 1.
 
      include 'size.h'
      real u(*), rshl(*)
      common /prty/ propr(20)
      character*8 titl(4,4)
 
      read(nf,10) kr, kt
 10   format(2i5)
 
      if(kr.ne.nr .or. kt.ne.nt) then
         print *,'Array dimensions of data file and size.h inconsistent'
         stop
      end if
 
      read(nf,20) titl
 20   format(4a8)
 
      read(nf,30) (rshl(i),i=1,nr+1)
      read(nf,30) propr
 30   format(1p10e15.8)
 
      kr = mr
      if(mr .lt. 0) kr = nr
 
      if(ifmt .eq. 0) then
 
         read(nf,40) (u(ii),ii=1,(nt+1)**2*5*nj*(kr+1))
 40      format(1p15e10.3)
 
      elseif(ifmt .eq. 1) then
 
         read(nf,50) (u(ii),ii=1,(nt+1)**2*5*nj*(kr+1))
 50      format(15f10.3)
 
      endif
 
      end
*dk vecout
      subroutine vecout(u,rshl,nj,kr,kt,mr,nf,ifmt)
 
c...  This routine writes the nodal field u to logical unit nf
c...  using 1pe10.3 format when ifmt = 0 and f10.3 when ifmt = 1.
 
      include 'size.h'
      real u(*), rshl(*)
      common /name/ titl(4,4)
      common /prty/ propr(20)
      character*8 titl
 
      write(nf,10) kr, kt
 10   format(2i5)
 
      write(nf,20) titl
 20   format(4a8)
 
      write(nf,30) (rshl(i),i=1,kr+1)
      write(nf,30) propr
 30   format(1p10e15.8)
 
      if(ifmt .eq. 0) then
 
         write(nf,40) (u(ii),ii=1,(kt+1)**2*10*nj*(mr+1))
 40      format(1p15e10.3)
 
      elseif(ifmt .eq. 1) then
 
         write(nf,50) (u(ii),ii=1,(kt+1)**2*10*nj*(mr+1))
 50      format(15f10.3)
 
      endif
 
      end
