      program peachplt
 
c     This program generates a plot of the 3-D icosahedral mesh
c     with a slice removed to display the radial discretization.
 
      real xn(129,129,3,10), p1(3), p2(3), e1(3), e2(3), e3(3)
 
      open (1, file='plot'  , status='unknown')
 
      nr   = 32
      nt   = 64
      rmin = 0.547
      rmax = 1.000
      ird  = 2
      pi   = 3.141592653589793
 
      call gplot("u","gridplt",7)
c     call gscrn2(-1.83,1.83,-1.25,1.25)
      call gscrn2(-1.52,1.52,-1.08,1.20)
      call gwind2(-1.52,1.52,-1.08,1.20)
c     call gwind2(-0.20,0.56, 0.45,1.02)
      call gtfnta
      call gtwdth(0.060)
      phi = 1.10715
      call vupoint(0.,   phi-0.5*pi-0.002,p1,p2,e2)
      call vupoint(0.,2.*phi+0.5*pi-0.009,p1,p2,e3)
      call vupoint(0.,phi,p1,p2,e1)
 
      call gtwdth(0.06)
      call gmova2(-0.72,1.06)
      call gtext("TERRA COMPUTATIONAL MESH",24)
      call gtwdth(0.04)
      call gmova2(-1.05,-0.81)
c     call gtext("NR = 16",7)
      call gtext("NR = 32",7)
c     call gtext("NR = 64",7)
      call gmova2(-1.05,-0.89)
c     call gtext("NT = 32",7)
      call gtext("NT = 64",7)
c     call gtext("NT = 128",8)
      call gmova2(-1.05,-0.97)
c     call gtext("174,114 NODES",13)
c     call gtext("337,986 NODES",13)
      call gtext("1,351,746 NODES",15)
c     call gtext("10,649,730 NODES",16)
      call glogo(0.60,-1.00,1.0)
c     call gmova2(-1.52,-1.08)
c     call glina2(-1.52, 1.20)
c     call glina2( 1.52, 1.20)
c     call glina2( 1.52,-1.08)
c     call glina2(-1.52,-1.08)
 
      call grdgen(xn,nt)
 
c     call gcolor('green')
      do 20 id=1,10
      do 20 it=1,8
      if(id.eq.1  .and.  it.ge.2 .and. it.le.7) go to 10
      if(id.eq.2  .and. (it.eq.3 .or.  it.eq.4 .or. it.eq.7)) go to 10
      if(id.eq.5  .and.  it.ge.5 .and. it.le.7) go to 10
      if(id.eq.6  .and.  it.eq.8) go to 10
      if(id.eq.10 .and.  it.eq.8) go to 10
      call gridtri(rmin,xn,p1,p2,e2,e3,id,it,nt)
 10   continue
 20   continue
 
c     call gcolor('magenta')
      call radgrd(p1,p2,e1,rmin,rmax,ird,nr,nt)
 
c     call gcolor('green')
      do 40 id=1,10
      do 40 it=1,8
      if(id.eq.1  .and.  it.ge.2 .and. it.le.7) go to 30
      if(id.eq.2  .and. (it.eq.3 .or.  it.eq.4 .or. it.eq.7)) go to 30
      if(id.eq.5  .and.  it.ge.5 .and. it.le.7) go to 30
      if(id.eq.6  .and.  it.eq.8) go to 30
      if(id.eq.10 .and.  it.eq.8) go to 30
      call gridtri(rmax,xn,p1,p2,e1,e1,id,it,nt)
 30   continue
 40   continue
 
      call gdone
 
      stop
      end
*dk gridtri
      subroutine gridtri(rad,xn,p1,p2,e1,e2,id,itri,nt)
 
      nh = nt/2
      k1 = (1 - mod((itri+1)/2,2))*nh
      k2 = ((itri+3)/4 - 1)*nh + 1
      ke = 2 - mod(itri,2)
 
      do 20 i1=k1,k1+nh-1
      do 20 i2=k2,k2+nh-1
      do 20 ie=1,2
      ii = i1 + i2 - k1 - k2 + 2
      if(ke.eq.1 .and. (ii.gt.nh+1 .or. (ii.eq.nh+1 .and. ie.eq.2)))
     &   go to 10
      if(ke.eq.2 .and. (ii.lt.nh+1 .or. (ii.eq.nh+1 .and. ie.eq.1)))
     &   go to 10
      y1 =  dotpr(p1,xn,i1+1,i2,id,nt)
      x1 = -dotpr(p2,xn,i1+1,i2,id,nt)
      s1 =  dotpr(e1,xn,i1+1,i2,id,nt)
      t1 =  dotpr(e2,xn,i1+1,i2,id,nt)
      y2 =  dotpr(p1,xn,i1,i2+1,id,nt)
      x2 = -dotpr(p2,xn,i1,i2+1,id,nt)
      s2 =  dotpr(e1,xn,i1,i2+1,id,nt)
      t2 =  dotpr(e2,xn,i1,i2+1,id,nt)
      y3 =  dotpr(p1,xn,i1+ie-1,i2+ie-1,id,nt)
      x3 = -dotpr(p2,xn,i1+ie-1,i2+ie-1,id,nt)
      s3 =  dotpr(e1,xn,i1+ie-1,i2+ie-1,id,nt)
      t3 =  dotpr(e2,xn,i1+ie-1,i2+ie-1,id,nt)
      if(s1.gt.0. .and. s2.gt.0. .and. s3.gt.0. .and.
     &   t1.gt.0. .and. t2.gt.0. .and. t3.gt.0.) then
         call gmova2(rad*x1,rad*y1)
         call glina2(rad*x2,rad*y2)
         call glina2(rad*x3,rad*y3)
         call glina2(rad*x1,rad*y1)
      endif
 10   continue
 20   continue
 
      end
*dk radgrd
      subroutine radgrd(p1,p2,e,rmin,rmax,ird,nr,nt)
 
c        This routine draws the spherical grid as viewed
c        on a plane through the equator.
 
      real r(65), p1(3), p2(3), e(3)
 
      call rshlgen0(r,rmin,rmax,ird,nr)
 
      dphi = 0.4*3.14159265358973/nt
      do 10 ir=1,nr+1
      do 10 i=1,5*nt/2+1
      phi1 = dphi*(i-1)
      phi2 = phi1 + dphi
      y1 =  (p1(1)*sin(phi1) - p1(2)*cos(phi1))*r(ir)
      x1 = -(p2(1)*sin(phi1) - p2(2)*cos(phi1))*r(ir)
      y2 =  (p1(1)*sin(phi2) - p1(2)*cos(phi2))*r(ir)
      x2 = -(p2(1)*sin(phi2) - p2(2)*cos(phi2))*r(ir)
      y3 =  (p1(1)*sin(phi1) - p1(2)*cos(phi1))*r(ir+1)
      x3 = -(p2(1)*sin(phi1) - p2(2)*cos(phi1))*r(ir+1)
      if(i.le.5*nt/2) then
         call gmova2(x1,y1)
         call glina2(x2,y2)
      endif
      if(ir.le.nr) then
         call gmova2(x1,y1)
         call glina2(x3,y3)
      endif
 10   continue
 
      end
*dk rshlgen0
      subroutine rshlgen0(r,rmin,rmax,ird,nr)
 
c     This routine generates the nodal radial locations for the grid
c     type specified by parameter ird for all grids with N .le. nr.
 
      real r(65)
      common /dpth/ dep(32,2)
 
      lvr  = 1.45*log(real(nr))
      pi   = 3.141592653589793
 
      r(1) = rmax
      do 10 ir=2,nr+1
      fr   = real(nr+1-ir)/real(nr)
      if(ird.eq.1) then
         r(ir) = rmin*(rmax/rmin)**fr
      elseif(ird.le.4) then
         aa    = 0.3 + 0.20*(ird - 2)
         r(ir) = (1. - aa)*(rmin + (rmax - rmin)*fr)
     &         + aa*(rmax + rmin - (rmax - rmin)*cos(pi*fr))*0.5
      else
         r(ir) = r(ir-1) - dep(ir-1,lvr-3)/6370.
      endif
 10   continue
 
      end
      block data bdpeach
 
      common /dpth/ dep(32,2)
      data dep/2*100., 150., 4*100., 150., 200., 250., 300., 350., 300.,
     &         250., 200., 140., 16*0., 6*50., 75., 50., 3*75., 50.,
     &         75., 100., 125., 8*150., 2*125., 100., 2*75., 3*50., 40./
 
      end
*dk dot
      function dot(p,x,y,z)
 
      real p(3)
 
      dot = p(1)*x + p(2)*y + p(3)*z
 
      end
*dk dotpr
      function dotpr(e,xn,i1,i2,id,nt)
 
c...  This routine computes the dot product of the vector e
c...  with the vertex coordinate array xn at vertex (i1,i2,id).
 
      real xn(0:nt,nt+1,10,3), e(3)
 
      dotpr = e(1)*xn(i1,i2,id,1) + e(2)*xn(i1,i2,id,2)
     &      + e(3)*xn(i1,i2,id,3)
 
      end
*dk dprd
      function dprd(x,y)
 
c...  This routine computes the dot product of the vectors x and y.
 
      real x(3), y(3)
 
      dprd = x(1)*y(1) + x(2)*y(2) + x(3)*y(3)
 
      end
      subroutine second
      end
      subroutine uradtng
      end
*dk grdgen
      subroutine grdgen(xn,nt)
 
c...  This routine generates the nodal coordinates xn for an
c...  icosahedral grid on the unit sphere.  The grid resolution
c...  corresponds to a subdivision of the edges of the original
c...  icosahedral triangles into nt equal parts.
 
      real xn(nt+1,nt+1,10,3)
 
      fifthpi = 0.4*asin(1.)
      w       = 2.0*acos(1./(2.*sin(fifthpi)))
      cosw    = cos(w)
      sinw    = sin(w)
      lvt     = 1.45*log(real(nt))
      nn      = (nt+1)**2*10
 
      do id=1,10
 
         sgn = 1.
         if(id .ge. 6) sgn = -1.
         phi = (2*mod(id, 5) - 3 + (id - 1)/5)*fifthpi
 
         xn(   1,   1,id,1) =  0.
         xn(   1,   1,id,2) =  0.
         xn(   1,   1,id,3) =  sgn
         xn(nt+1,   1,id,1) =  sinw*cos(phi)
         xn(nt+1,   1,id,2) =  sinw*sin(phi)
         xn(nt+1,   1,id,3) =  cosw*sgn
         xn(   1,nt+1,id,1) =  sinw*cos(phi + fifthpi + fifthpi)
         xn(   1,nt+1,id,2) =  sinw*sin(phi + fifthpi + fifthpi)
         xn(   1,nt+1,id,3) =  cosw*sgn
         xn(nt+1,nt+1,id,1) =  sinw*cos(phi + fifthpi)
         xn(nt+1,nt+1,id,2) =  sinw*sin(phi + fifthpi)
         xn(nt+1,nt+1,id,3) = -cosw*sgn
 
         do k=0,lvt-1
 
            m  = 2**k
            l  = nt/m
            l2 = l/2
 
c...        rows of diamond--
 
            do j1=1,m+1
               do j2=1,m
                     i1 = (j1-1)*l + 1
                     i2 = (j2-1)*l + l2 + 1
                     call midpt(xn(i1,i2,id,1),xn(i1,i2-l2,id,1),
     &                          xn(i1,i2+l2,id,1),nn)
               end do
            end do
 
c...        columns of diamond--
 
            do j1=1,m+1
               do j2=1,m
                     i1 = (j2-1)*l + l2 + 1
                     i2 = (j1-1)*l + 1
                     call midpt(xn(i1,i2,id,1),xn(i1-l2,i2,id,1),
     &                          xn(i1+l2,i2,id,1),nn)
               end do
            end do
 
c...        diagonals of diamond--
 
            do j1=1,m
               do j2=1,m
                     i1 = (j1-1)*l + l2 + 1
                     i2 = (j2-1)*l + l2 + 1
                     call midpt(xn(i1,i2,id,1),xn(i1-l2,i2+l2,id,1),
     &                          xn(i1+l2,i2-l2,id,1),nn)
               end do
            end do
 
         end do
 
      end do
 
      end
*dk midpt
      subroutine midpt(x,x1,x2,nn)
 
c...  This routine finds the midpoint x along the shorter great circle
c...  arc between points x1 and x2 on the unit sphere.
 
      real x(nn,3), x1(nn,3), x2(nn,3)
 
      do j=1,3
         x(1,j) = x1(1,j) + x2(1,j)
      end do
 
      xnorm = 1./sqrt(x(1,1)**2 + x(1,2)**2 + x(1,3)**2)
 
      do j=1,3
         x(1,j) = xnorm*x(1,j)
      end do
 
      end
