*DK contarea
      subroutine contarea(carea)
 
c...  This routine computes the fractional surface area occupied by
c...  continent.
 
      include 'size.h'
      include 'pcom.h'
      common /map0/ map((nt+1)**2,nd,3)
      common /ndar/  arn((nt+1)**2),  arne((nt+1)**2),
     &              rarn((nt+1)**2), rarne((nt+1)**2)
 
      carea = 0.
 
      if(mynum.eq.0 .and.
     &   map(1,1,2).ge.1 .and. map(1,1,2).le.10)
     &   carea = carea + arn(1)
 
      if(mynum.eq.0 .and. nd.eq.10 .and.
     &   map(1,6,2).ge.1 .and. map(1,6,2).le.10)
     &   carea = carea + arn(1)
 
      if(mynum.eq.mproc .and. nd.le.5 .and.
     &   map(1,1,2).ge.1 .and. map(1,1,2).le.10)
     &   carea = carea + arn(1)
 
      do id=1,nd
         do ii=2,(nt+1)**2
            if(map(ii,id,2).ge.1 .and.
     &         map(ii,id,2).le.10) carea = carea + arn(ii)
         end do
      end do
 
      if(nproc .gt. 1) call psum(carea, 1)
 
      carea = 0.0795774*carea
 
      end
*dk diagnose
      subroutine diagnose(u,torq)
 
c...  This routine computes and prints diagnostics of the calculation
c...  of the plate rotation vectors in routine platesolv.
 
      include 'pcom.h'
      real torq(3,20)
      common /plte/ nplate, urtn(3,20)
      common /cycl/ iter, time, tstep, step
 
      if(mynum .eq. 0) then
 
         trms = 0.
         urms = 0.
         do k=1,nplate
            trms = trms + torq(1,k)**2 + torq(2,k)**2 + torq(3,k)**2
            urms = urms + urtn(1,k)**2 + urtn(2,k)**2 + urtn(3,k)**2
         end do
         trms = sqrt(trms/nplate)
         urms = sqrt(urms/nplate)
 
         write(85,'("# iter =",i5,"  trms=",1pe11.3,
     &                            "  urms=",1pe11.3)')
     &            iter, trms, urms
 
         do k=1,nplate
            write(85,'(1p3e12.4)') (urtn(j,k),j=1,3)
         end do
 
      end if
 
      call lithrotn(u,0)
 
      end
*dk lithrotn
      subroutine lithrotn(u,iremove)
 
c...  This routine computes the net rotation in the vector field u
c...  in the topmost layer of nodes and removes it when iremove = 1.
 
      include 'size.h'
      include 'pcom.h'
      real u(0:nt,nt+1,nd,3), s(6)
      common /mesh/ xn(0:nt,nt+1,nd,3)
      common /ndar/  arn(0:nt,nt+1),  arne(0:nt,nt+1),
     &              rarn(0:nt,nt+1), rarne(0:nt,nt+1)
 
      s(3) = 0.
      s(6) = 0.
 
      if(mynum.eq.0 .and. nd.eq.10) then
         s(1) =  2.*arn(0,1)
         s(2) =  2.*arn(0,1)
         s(4) = (u(0,1,1,2) - u(0,1,6,2))*arn(0,1)
         s(5) = (u(0,1,6,1) - u(0,1,1,1))*arn(0,1)
      elseif(mynum .eq. 0) then
         s(1) =  arn(0,1)
         s(2) =  arn(0,1)
         s(4) =  u(0,1,1,2)*arn(0,1)
         s(5) = -u(0,1,1,1)*arn(0,1)
      elseif(mynum.eq.mproc .and. nd.le.5) then
         s(1) =  arn(0,1)
         s(2) =  arn(0,1)
         s(4) = -u(0,1,1,2)*arn(0,1)
         s(5) =  u(0,1,1,1)*arn(0,1)
      else
         s(1) =  0.
         s(2) =  0.
         s(4) =  0.
         s(5) =  0.
      endif
 
      do id=1,nd
         do i2=1,nt
            do i1=1,nt
               s(1) = s(1) + (xn(i1,i2,id,3)**2
     &                     +  xn(i1,i2,id,2)**2)*arn(i1,i2)
               s(2) = s(2) + (xn(i1,i2,id,1)**2
     &                     +  xn(i1,i2,id,3)**2)*arn(i1,i2)
               s(3) = s(3) + (xn(i1,i2,id,2)**2
     &                     +  xn(i1,i2,id,1)**2)*arn(i1,i2)
               s(4) = s(4) + (u(i1,i2,id,2)*xn(i1,i2,id,3)
     &                     -  u(i1,i2,id,3)*xn(i1,i2,id,2))*arn(i1,i2)
               s(5) = s(5) + (u(i1,i2,id,3)*xn(i1,i2,id,1)
     &                     -  u(i1,i2,id,1)*xn(i1,i2,id,3))*arn(i1,i2)
               s(6) = s(6) + (u(i1,i2,id,1)*xn(i1,i2,id,2)
     &                     -  u(i1,i2,id,2)*xn(i1,i2,id,1))*arn(i1,i2)
            end do
         end do
      end do
 
      if(nproc .gt. 1) then
         call psum(s,6)
      endif
 
      s(4) = -s(4)/s(1)
      s(5) = -s(5)/s(2)
      s(6) = -s(6)/s(3)
      rmsspin = sqrt(s(4)**2 + s(5)**2 + s(6)**2)
 
      if(iremove .eq. 1) then
 
         do id=1,nd
 
            if(mynum.eq.0 .or. (mynum.eq.mproc .and. nd.le.5)) then
               u(0,1,id,1) = u(0,1,id,1) - s(5)*xn(0,1,id,3)
               u(0,1,id,2) = u(0,1,id,2) + s(4)*xn(0,1,id,3)
            endif
 
            do i2=1,nt+1
               do i1=0,nt
                  u(i1,i2,id,1) = u(i1,i2,id,1)
     &              - s(5)*xn(i1,i2,id,3) + s(6)*xn(i1,i2,id,2)
                  u(i1,i2,id,2) = u(i1,i2,id,2)
     &              - s(6)*xn(i1,i2,id,1) + s(4)*xn(i1,i2,id,3)
                  u(i1,i2,id,3) = u(i1,i2,id,3)
     &              - s(4)*xn(i1,i2,id,2) + s(5)*xn(i1,i2,id,1)
               end do
            end do
 
         end do
 
         if(mynum .eq. 0)
     &      write(6,'(/"spin removed =",1p3e12.3)') (s(i),i=4,6)
 
      else
 
         if(mynum .eq. 0)
     &      write(85,'("spin =",1p4e12.3)') (s(i),i=4,6), rmsspin
 
      end if
 
      end
*dk platebreakup
      subroutine platebreakup(vrtn,torq)
 
c...  This routine constrains groups of plates to behave as single
c...  rigid units until specified breakup times.
 
      real vrtn(3,20), torq(3,20)
      common /cycl/ iter, time, tstep, step
      common /plte/ nplate, urtn(3,20)
      common /bkup/ tasna, tnagl, tafsa, tafan, tewgw, tafin, tinsu,
     &              tafmd, twpep, tnfsf
 
      do 10 j=1,3
 
      if(time .lt. tasna) then
         vrtn(j,1)  = (urtn(j,1) + urtn(j,2))*0.5
         vrtn(j,2)  =  vrtn(j,1)
         vrtn(j,3)  =  vrtn(j,1)
         torq(j,1)  =  torq(j,1) + torq(j,2) + torq(j,3)
         torq(j,2)  =  torq(j,1)
         torq(j,3)  =  torq(j,1)
      elseif(time .lt. tnagl) then
         vrtn(j,2)  =  urtn(j,2)
         vrtn(j,3)  =  vrtn(j,2)
         torq(j,2)  =  torq(j,2) + torq(j,3)
         torq(j,3)  =  torq(j,2)
      endif
 
      if(time .lt. tafsa) then
 
         vrtn(j,4)  = (urtn(j,4) + urtn(j,6) + urtn(j,7)
     &              +  urtn(j,8) + urtn(j,9) + urtn(j,10))/6.
         vrtn(j,5)  =  vrtn(j,4)
         vrtn(j,6)  =  vrtn(j,4)
         vrtn(j,7)  =  vrtn(j,4)
         vrtn(j,8)  =  vrtn(j,4)
         vrtn(j,9)  =  vrtn(j,4)
         vrtn(j,10) =  vrtn(j,4)
         torq(j,4)  =  torq(j,4) + torq(j,5) + torq(j,6) + torq(j,7)
     &              +  torq(j,8) + torq(j,9) + torq(j,10)
         torq(j,5)  =  torq(j,4)
         torq(j,6)  =  torq(j,4)
         torq(j,7)  =  torq(j,4)
         torq(j,8)  =  torq(j,4)
         torq(j,9)  =  torq(j,4)
         torq(j,10) =  torq(j,4)
 
      elseif(time .lt. tafan) then
 
         vrtn(j,4)  = (urtn(j,4) + urtn(j,7) + urtn(j,8)
     &              +  urtn(j,9) + urtn(j,10))*0.2
         vrtn(j,5)  =  vrtn(j,4)
         vrtn(j,7)  =  vrtn(j,4)
         vrtn(j,8)  =  vrtn(j,4)
         vrtn(j,9)  =  vrtn(j,4)
         vrtn(j,10) =  vrtn(j,4)
         torq(j,4)  =  torq(j,4) + torq(j,5) + torq(j,7)
     &              +  torq(j,8) + torq(j,9) + torq(j,10)
         torq(j,5)  =  torq(j,4)
         torq(j,7)  =  torq(j,4)
         torq(j,8)  =  torq(j,4)
         torq(j,9)  =  torq(j,4)
         torq(j,10) =  torq(j,4)
 
      elseif(time .lt. tewgw) then
 
         vrtn(j,4)  =  urtn(j,4)
         vrtn(j,5)  =  vrtn(j,4)
         torq(j,4)  =  torq(j,4) + torq(j,5)
         torq(j,5)  =  torq(j,4)
 
         vrtn(j,7)  = (urtn(j,7) + urtn(j,8) + urtn(j,9))*0.3333
         vrtn(j,8)  =  vrtn(j,7)
         vrtn(j,9)  =  vrtn(j,7)
         torq(j,7)  =  torq(j,7) + torq(j,8) + torq(j,9)
         torq(j,8)  =  torq(j,7)
         torq(j,9)  =  torq(j,7)
 
      elseif(time .lt. tafin) then
 
         vrtn(j,4)  = (urtn(j,4) + urtn(j,7) + urtn(j,8)
     &              +  urtn(j,9))*0.25
         vrtn(j,5)  =  vrtn(j,4)
         vrtn(j,7)  =  vrtn(j,4)
         vrtn(j,8)  =  vrtn(j,4)
         vrtn(j,9)  =  vrtn(j,4)
         torq(j,4)  =  torq(j,4) + torq(j,5) + torq(j,7) + torq(j,8)
     &              +  torq(j,9)
         torq(j,5)  =  torq(j,4)
         torq(j,7)  =  torq(j,4)
         torq(j,8)  =  torq(j,4)
         torq(j,9)  =  torq(j,4)
 
      elseif(time .lt. tinsu) then
 
         vrtn(j,4)  =  urtn(j,4)
         vrtn(j,5)  =  vrtn(j,4)
         torq(j,4)  =  torq(j,4) + torq(j,5)
         torq(j,5)  =  torq(j,4)
 
         vrtn(j,7)  = (urtn(j,7) + urtn(j,8) + urtn(j,9))*0.3333
         vrtn(j,8)  =  vrtn(j,7)
         vrtn(j,9)  =  vrtn(j,7)
         torq(j,7)  =  torq(j,7) + torq(j,8) + torq(j,9)
         torq(j,8)  =  torq(j,7)
         torq(j,9)  =  torq(j,7)
 
      else
 
         vrtn(j,4)  =  urtn(j,4)
         vrtn(j,5)  =  vrtn(j,4)
         torq(j,4)  =  torq(j,4) + torq(j,5)
         torq(j,5)  =  torq(j,4)
 
      endif
 
      if(time .lt. twpep) then
         vrtn(j,16) = (urtn(j,16) + urtn(j,17) + urtn(j,18))/3.
         vrtn(j,17) =  vrtn(j,16)
         vrtn(j,18) =  vrtn(j,16)
         torq(j,16) =  torq(j,16) + torq(j,17) + torq(j,18)
         torq(j,17) =  torq(j,16)
         torq(j,18) =  torq(j,16)
      elseif(time .lt. tnfsf) then
         vrtn(j,17) = (urtn(j,17) + urtn(j,18))*0.5
         vrtn(j,18) =  vrtn(j,17)
         torq(j,17) =  torq(j,17) + torq(j,18)
         torq(j,18) =  torq(j,17)
      end if
 
 10   continue
 
      end
*dk platecollide
      subroutine platecollide(carea)
 
c...  This routine computes the torques exerted on each continent as
c...  a consequence of continent-continent collision.
 
      include 'size.h'
      include 'pcom.h'
      real carea(0:nt+1,0:nt+1,nd,*), tarea(0:nt,nt+1,nd)
      common /map0/  map(0:nt,nt+1,nd,3)
      common /mesh/   xn(0:nt,nt+1,nd,3)
      common /plte/ nplate, urtn(3,20)
      common /clsn/ ctorq(3,10)
      common /prop/ ieos,  rho0, visc,  grav,  texpn, tcond,
     &              sheat, hgen, tb(2), cl410, cl660
 
c...  Compute total nodal continent area.
 
      call nulvec(tarea, (nt+1)**2*nd)
 
      do k=1,10
         ctorq(1,k) = 0.
         ctorq(2,k) = 0.
         ctorq(3,k) = 0.
         do id=1,nd
            do i2=1,nt
               i10 = 1
               if(mod(mynum,mproc).eq.0 .and. mod(id,5).eq.1
     &            .and. i2.eq.1) i10 = 0
               do i1=i10,nt
                  tarea(i1,i2,id) = tarea(i1,i2,id)
     &                            + carea(i1,i2,id,k)
               end do
            end do
         end do
      end do
 
c...  Find nodes at which two or more continents are overlapping.
c...  Identify these continents and generate forces to move the
c...  continents away from the overlap zone.
 
      aa = 10.*3400.*10.*10.e3*40000.e3*25.e3/(5*mt*visc)
 
      do id=1,nd
         do i2=1,nt
            i10 = 1
            if(mod(mynum,mproc).eq.0 .and. mod(id,5).eq.1
     &         .and. i2.eq.1) i10 = 0
            do i1=i10,nt
               if(tarea(i1,i2,id) .gt. 1.2) then
                  k0 = map(i1,i2,id,2)
                  do k=1,10
                     if(k.ne.k0 .and. carea(i1,i2,id,k).gt.0.) then
 
c...                    Find the relative velocities of the two plates
c...                    at the node.
 
                        v1 = (urtn(2,k) - urtn(2,k0))*xn(i1,i2,id,3)
     &                     - (urtn(3,k) - urtn(3,k0))*xn(i1,i2,id,2)
                        v2 = (urtn(3,k) - urtn(3,k0))*xn(i1,i2,id,1)
     &                     - (urtn(1,k) - urtn(1,k0))*xn(i1,i2,id,3)
                        v3 = (urtn(1,k) - urtn(1,k0))*xn(i1,i2,id,2)
     &                     - (urtn(2,k) - urtn(2,k0))*xn(i1,i2,id,1)
                        vn = sqrt(v1**2 + v2**2 + v3**2)
                        if(vn .gt. 1.e-20) vn = aa/vn
 
c...                    Convert these relative velocities to torques.
 
                        t1 = vn*(xn(i1,i2,id,2)*v3 - xn(i1,i2,id,3)*v2)
                        t2 = vn*(xn(i1,i2,id,3)*v1 - xn(i1,i2,id,1)*v3)
                        t3 = vn*(xn(i1,i2,id,1)*v2 - xn(i1,i2,id,2)*v1)
                        ctorq(1,k)  = ctorq(1,k)  + t1
                        ctorq(2,k)  = ctorq(2,k)  + t2
                        ctorq(3,k)  = ctorq(3,k)  + t3
                        ctorq(1,k0) = ctorq(1,k0) - t1
                        ctorq(2,k0) = ctorq(2,k0) - t2
                        ctorq(3,k0) = ctorq(3,k0) - t3
 
                     end if
                  end do
               end if
            end do
         end do
      end do
 
      if(nproc .gt. 1) call psum(ctorq, 30)
 
      end
*dk plateforce
      subroutine plateforce(f,u,d)
 
c     This routine computes f = f - A*u, where A is a tensor operator.
 
      include 'size.h'
      real d(0:nt,nt+1,ndo,3,3,nr+1), f(0:nt,nt+1,nd,3)
      real u(0:nt,nt+1,nd,3,2), w(4,0:nt,2,nd)
      common /oper/ ra(3,8,nr+1), alp(7,0:nt,nt+1,2),
     &              atn(4,7,0:nt,nt+1,3,3)
      common /vis1/ vscmax, rvscscl, tvscscl, pwrlawn, pwrlawsr, yldstrs
      common /mesh/ xn(0:nt,nt+1,nd,3)
 
      call nuledge(f,nd,0,nt,3)
 
      call uscale(u,1,1)
 
      call rotate(u,nd,1,nt,1)
      call rotate(f,nd,0,nt,1)
 
      do i2=1,nt+1
 
         do j=1,3
 
            call nulvec(w, 4*(nt+1)*2*nd)
 
            do i=1,3
               do ir=1,2
                  do id=1,nd
                     do i1=0,nt
                        w(1,i1,ir,id) = w(1,i1,ir,id) + (((((((
     &                    atn(1,1,i1,i2,i,j)*u(i1  ,i2  ,id,i,ir))
     &                  + atn(1,2,i1,i2,i,j)*u(i1+1,i2  ,id,i,ir))
     &                  + atn(1,3,i1,i2,i,j)*u(i1  ,i2+1,id,i,ir))
     &                  + atn(1,4,i1,i2,i,j)*u(i1-1,i2+1,id,i,ir))
     &                  + atn(1,5,i1,i2,i,j)*u(i1-1,i2  ,id,i,ir))
     &                  + atn(1,6,i1,i2,i,j)*u(i1  ,i2-1,id,i,ir))
     &                  + atn(1,7,i1,i2,i,j)*u(i1+1,i2-1,id,i,ir))
                        w(2,i1,ir,id) = w(2,i1,ir,id) + (((((((
     &                    atn(2,1,i1,i2,i,j)*u(i1  ,i2  ,id,i,ir))
     &                  + atn(2,2,i1,i2,i,j)*u(i1+1,i2  ,id,i,ir))
     &                  + atn(2,3,i1,i2,i,j)*u(i1  ,i2+1,id,i,ir))
     &                  + atn(2,4,i1,i2,i,j)*u(i1-1,i2+1,id,i,ir))
     &                  + atn(2,5,i1,i2,i,j)*u(i1-1,i2  ,id,i,ir))
     &                  + atn(2,6,i1,i2,i,j)*u(i1  ,i2-1,id,i,ir))
     &                  + atn(2,7,i1,i2,i,j)*u(i1+1,i2-1,id,i,ir))
                        w(3,i1,ir,id) = w(3,i1,ir,id) + (((((((
     &                    atn(3,1,i1,i2,i,j)*u(i1  ,i2  ,id,i,ir))
     &                  + atn(3,2,i1,i2,i,j)*u(i1+1,i2  ,id,i,ir))
     &                  + atn(3,3,i1,i2,i,j)*u(i1  ,i2+1,id,i,ir))
     &                  + atn(3,4,i1,i2,i,j)*u(i1-1,i2+1,id,i,ir))
     &                  + atn(3,5,i1,i2,i,j)*u(i1-1,i2  ,id,i,ir))
     &                  + atn(3,6,i1,i2,i,j)*u(i1  ,i2-1,id,i,ir))
     &                  + atn(3,7,i1,i2,i,j)*u(i1+1,i2-1,id,i,ir))
                        w(4,i1,ir,id) = w(4,i1,ir,id) + (((((((
     &                    atn(4,1,i1,i2,i,j)*u(i1  ,i2  ,id,i,ir))
     &                  + atn(4,2,i1,i2,i,j)*u(i1+1,i2  ,id,i,ir))
     &                  + atn(4,3,i1,i2,i,j)*u(i1  ,i2+1,id,i,ir))
     &                  + atn(4,4,i1,i2,i,j)*u(i1-1,i2+1,id,i,ir))
     &                  + atn(4,5,i1,i2,i,j)*u(i1-1,i2  ,id,i,ir))
     &                  + atn(4,6,i1,i2,i,j)*u(i1  ,i2-1,id,i,ir))
     &                  + atn(4,7,i1,i2,i,j)*u(i1+1,i2-1,id,i,ir))
                     end do
                  end do
               end do
            end do
 
            do id=1,nd
 
               do i1=0,nt
                  f(i1,i2,id,j) = f(i1,i2,id,j) - ((((((((
     &                            ra(2,1,1)*w(1,i1,1,id))
     &                          + ra(2,2,1)*w(2,i1,1,id))
     &                          + ra(2,3,1)*w(3,i1,1,id))
     &                          + ra(2,4,1)*w(4,i1,1,id))
     &                          + ra(3,1,1)*w(1,i1,2,id))
     &                          + ra(3,2,1)*w(2,i1,2,id))
     &                          + ra(3,3,1)*w(3,i1,2,id))
     &                          + ra(3,4,1)*w(4,i1,2,id))
               end do
 
            end do
 
         end do
 
      end do
 
      do id=1,nd
         jd = min(ndo, id)
         do i2=1,nt+1
            do i1=0,nt
               f(i1,i2,id,1) = f(i1,i2,id,1) - (((
     &              d(i1,i2,jd,1,1,1)*u(i1,i2,id,1,1))
     &            + d(i1,i2,jd,2,1,1)*u(i1,i2,id,2,1))
     &            + d(i1,i2,jd,3,1,1)*u(i1,i2,id,3,1))
               f(i1,i2,id,2) = f(i1,i2,id,2) - (((
     &              d(i1,i2,jd,1,2,1)*u(i1,i2,id,1,1))
     &            + d(i1,i2,jd,2,2,1)*u(i1,i2,id,2,1))
     &            + d(i1,i2,jd,3,2,1)*u(i1,i2,id,3,1))
               f(i1,i2,id,3) = f(i1,i2,id,3) - (((
     &              d(i1,i2,jd,1,3,1)*u(i1,i2,id,1,1))
     &            + d(i1,i2,jd,2,3,1)*u(i1,i2,id,2,1))
     &            + d(i1,i2,jd,3,3,1)*u(i1,i2,id,3,1))
            end do
         end do
      end do
 
      call rotate(u,nd,1,nt,-1)
      call rotate(f,nd,0,nt,-1)
 
      call uscale(u,2,1)
      call uscale(f,1,0)
 
      call comm3s(f,0,nt,3)
 
      do id=1,nd
         do i2=1,nt+1
            do i1=0,nt
               fn = ((f(i1,i2,id,1)*xn(i1,i2,id,1)
     &              + f(i1,i2,id,2)*xn(i1,i2,id,2))
     &              + f(i1,i2,id,3)*xn(i1,i2,id,3))
               f(i1,i2,id,1) = f(i1,i2,id,1) - fn*xn(i1,i2,id,1)
               f(i1,i2,id,2) = f(i1,i2,id,2) - fn*xn(i1,i2,id,2)
               f(i1,i2,id,3) = f(i1,i2,id,3) - fn*xn(i1,i2,id,3)
            end do
         end do
      end do
 
      end
*dk platemap
      subroutine platemap(tarea,parea,carea)
 
c...  This routine interpolates the particle areas to the nodes and
c...  generates a new plate map based on the plate with the largest
c...  area at each node.
 
      include 'size.h'
      include 'pcom.h'
      parameter (np = 8, na = 4)
      real parea(0:nt+1,0:nt+1,nd,*), pareap(0:2,0:2,2,20)
      real carea(0:nt+1,0:nt+1,nd,*), careap(0:2,0:2,2,20)
      real tarea(0:nt,nt+1,nd)
      common /ptc1/ attr(nt,nt,nd,na,np), attrp(1,1,2,na,np)
      common /map0/  map(0:nt,nt+1,nd,3)
      common /map1/ pmap(0:nt,nt+1,nd,2)
      common /ndar/  arn(0:nt,nt+1),  arne(0:nt,nt+1),
     &              rarn(0:nt,nt+1), rarne(0:nt,nt+1)
      common /ngbr/ xnbr(nt,nt,6,2), xnbrp(1,1,6,2),
     &              cpsi(nt,nt,6),   cpsip(1,1,6),
     &              spsi(nt,nt,6),   spsip(1,1,6),
     &              qnbr(nt,nt,6,2), qnbrp(1,1,6,2),
     &              rdet(nt,nt,6),   rdetp(1,1,6)
      common /plte/ nplate, urtn(3,20)
 
c...  Sum the area of each active particle to its the nearest node.
 
      call platemaparea(parea,carea,attr,xnbr,qnbr,rdet,nd,nt)
 
      if(mod(mynum, mproc) .eq. 0) call platemaparea(pareap,careap,
     &                                  attrp,xnbrp,qnbrp,rdetp,2,1)
 
      call ghostadd(parea,pareap,nplate)
 
      call ghostadd(carea,careap,nplate)
 
c...  Generate a new plate map field based on which plate has the
c...  greatest fraction of the nodal area.
 
      do id=1,nd
         do i2=1,nt+1
            do i1=0,nt
               pmap(i1,i2,id,1) = 0.
               pmap(i1,i2,id,2) = 0.
            end do
         end do
      end do
 
c...  Compute new map of regions occupied by continental crust.
c...  Use array tarea as work array.
 
      call nulvec(tarea, (nt+1)**2*nd)
 
      do kp=1,10
         do id=1,nd
            do i2=1,nt
               i10 = 1
               if(mod(mynum,mproc).eq.0 .and. mod(id,5).eq.1
     &            .and. i2.eq.1) i10 = 0
               do i1=i10,nt
                  carea(i1,i2,id,kp) = carea(i1,i2,id,kp)*rarne(i1,i2)
                  if(carea(i1,i2,id,kp) .gt. tarea(i1,i2,id)) then
                     tarea(i1,i2,id) = carea(i1,i2,id,kp)
                     if(tarea(i1,i2,id) .gt. 0.5)
     &                  pmap(i1,i2,id,2) = int(kp)
                  end if
               end do
            end do
         end do
      end do
 
c...  Compute new nodal map of plate numbers irrespective of whether
c...  nodal area has continental crust or not.
c...  Use array tarea as work array.
 
      call nulvec(tarea, (nt+1)**2*nd)
 
      do kp=1,nplate
         do id=1,nd
            do i2=1,nt
               i10 = 1
               if(mod(mynum,mproc).eq.0 .and. mod(id,5).eq.1
     &            .and. i2.eq.1) i10 = 0
               do i1=i10,nt
                  parea(i1,i2,id,kp) = parea(i1,i2,id,kp)*rarne(i1,i2)
                  if(parea(i1,i2,id,kp) .gt. tarea(i1,i2,id)) then
                     tarea(i1,i2,id) = parea(i1,i2,id,kp)
                     pmap(i1,i2,id,1) = int(kp)
                  end if
               end do
            end do
         end do
      end do
 
c...  Compute total particle area at each node.
 
      call nulvec(tarea, (nt+1)**2*nd)
 
      do kp=1,nplate
         do id=1,nd
            do i2=1,nt
               i10 = 1
               if(mod(mynum,mproc).eq.0 .and. mod(id,5).eq.1
     &            .and. i2.eq.1) i10 = 0
               do i1=i10,nt
                  tarea(i1,i2,id) = tarea(i1,i2,id) + parea(i1,i2,id,kp)
               end do
            end do
         end do
      end do
 
      call comm3s(pmap,1,nt,1)
 
      do id=1,nd
         do i2=1,nt+1
            do i1=0,nt
               if(pmap(i1,i2,id,1) .ne. 0.) then
                  map(i1,i2,id,1) = int(pmap(i1,i2,id,1))
                  map(i1,i2,id,2) = int(pmap(i1,i2,id,2))
               end if
            end do
         end do
      end do
 
c...  Compute torques arising from continent-continent collision
c...  using the array carea of nodal continental areas.
 
      call platecollide(carea)
 
      end
*dk platemaparea
      subroutine platemaparea(parea,carea,attr,xnbr,qnbr,rdet,kd,kt)
 
c...  This routine distributes particle area to the three surrounding
c...  nodes according to plate number to generate nodal fields for
c...  the plate distribution parea and continent distribution carea.
 
      include 'size.h'
      include 'pcom.h'
      parameter (np = 8, na = 4)
      real parea(0:kt+1,0:kt+1,kd,*), carea(0:kt+1,0:kt+1,kd,*)
      real attr(kt,kt,kd,na,*), xnbr(kt,kt,6,2)
      real qnbr(kt,kt,6,2), rdet(kt,kt,6)
      common /plte/ nplate, urtn(3,20)
      common /spok/ ispoke(10)
 
      call nulvec(parea, (kt+2)**2*kd*nplate)
      call nulvec(carea, (kt+2)**2*kd*nplate)
 
      do ip=1,np
         do id=1,kd
 
            sn = 1.
            if(id.ge.6 .or. (kd.eq.2 .and. id.eq.2)) sn = -1.
 
            do i2=1,kt
               do i1=1,kt
 
                  if(attr(i1,i2,id,1,ip) .lt. 1.) then
 
c...                 Compute the dot products of the particle
c...                 locations with each of the unit vectors
c...                 pointing to the neighbor nodes.  The largest
c...                 dot product give the nearest neighbor node.
 
                     d2 = (attr(i1,i2,id,2,ip) + 1.e-50)*sn
                     dm = attr(i1,i2,id,1,ip)*qnbr(i1,i2,1,1)
     &                                   + d2*qnbr(i1,i2,1,2)
                     nbr    = 1
 
                     dd = attr(i1,i2,id,1,ip)*qnbr(i1,i2,2,1)
     &                                   + d2*qnbr(i1,i2,2,2)
                     if(dd .gt. dm) then
                        dm  = dd
                        nbr = 2
                     end if
 
                     dd = attr(i1,i2,id,1,ip)*qnbr(i1,i2,3,1)
     &                                   + d2*qnbr(i1,i2,3,2)
                     if(dd .gt. dm) then
                        dm  = dd
                        nbr = 3
                     end if
 
                     dd = attr(i1,i2,id,1,ip)*qnbr(i1,i2,4,1)
     &                                   + d2*qnbr(i1,i2,4,2)
                     if(dd .gt. dm) then
                        dm  = dd
                        nbr = 4
                     end if
 
                     dd = attr(i1,i2,id,1,ip)*qnbr(i1,i2,5,1)
     &                                   + d2*qnbr(i1,i2,5,2)
                     if(dd .gt. dm) then
                        dm  = dd
                        nbr = 5
                     end if
 
                     dd = attr(i1,i2,id,1,ip)*qnbr(i1,i2,6,1)
     &                                   + d2*qnbr(i1,i2,6,2)
                     if(dd .gt. dm) nbr = 6
 
c...                 Use the cross product to determine which triangle
c...                 contains the particle.
 
                     cp = attr(i1,i2,id,1,ip)*qnbr(i1,i2,nbr,2)
     &                  - attr(i1,i2,id,2,ip)*qnbr(i1,i2,nbr,1)*sn
 
                     m1 = nbr
                     if(cp .gt. 0.) m1 = mod(nbr+4, 6) + 1
                     m2 = mod(m1, 6) + 1
                     if(kt.eq.1 .or. (nt*mynum.eq.mt-nt
     &                  .and. i1.eq.nt .and. i2.eq.1)) then
                        if(m1 .eq. 6) m1 = 5
                        if(m1 .eq. 5) m2 = 1
                     endif
 
                     j1 = i1 + ispoke(m1)
                     j2 = i2 + ispoke(m1+4)
                     k1 = i1 + ispoke(m2)
                     k2 = i2 + ispoke(m2+4)
 
                     kp = attr(i1,i2,id,3,ip)
 
                     aa = abs(attr(i1,i2,id,4,ip))
 
                     alpha =  (xnbr(i1,i2,m2,2)*attr(i1,i2,id,1,ip)
     &                       - xnbr(i1,i2,m2,1)*d2)*rdet(i1,i2,m1)*aa
                     beta  = -(xnbr(i1,i2,m1,2)*attr(i1,i2,id,1,ip)
     &                       - xnbr(i1,i2,m1,1)*d2)*rdet(i1,i2,m1)*aa
                     gamma = aa - alpha - beta
 
                     parea(i1,i2,id,kp) = parea(i1,i2,id,kp) + gamma
                     parea(j1,j2,id,kp) = parea(j1,j2,id,kp) + alpha
                     parea(k1,k2,id,kp) = parea(k1,k2,id,kp) + beta
 
                     if(attr(i1,i2,id,4,ip) .lt. 0.) then
                     carea(i1,i2,id,kp) = carea(i1,i2,id,kp) + gamma
                     carea(j1,j2,id,kp) = carea(j1,j2,id,kp) + alpha
                     carea(k1,k2,id,kp) = carea(k1,k2,id,kp) + beta
                     end if
 
                  end if
 
               end do
            end do
         end do
      end do
 
      end
*dk platemove
      subroutine platemove(u,f,v,w)
 
c...  This routine is a driver routine for the surface plate treatment.
 
c...  The plate model treats each plate as a perfectly rigid portion
c...  of the spherical surface whose motion is described by an Euler
c...  rotation vector.  This set of vectors is obtained by an iterative
c...  procedure that uses the velocities from the previous time step
c...  for nodes internal to the spherical shell to find the plate
c...  rotations that yield integrated torques that approach zero in
c...  the topmost layer of nodes over the area occupied by each plate.
 
c...  The routine then uses the surface velocity field obtained from
c...  the plate rotations to move a set of tracer particles that carry
c...  the plate location information.  It also creates and destroys
c...  tracer particles to account for plate divergence and convergence.
 
c...  Note:  By setting the input parameter stepmax to a value of
c...  1.e-10, this routine will simply compute the plate rotations
c...  without invoking any of the particle features.
 
      include 'size.h'
      include 'pcom.h'
      real torq(3,20)
      common /radl/ rshl(nr+1), ird, ibc
      common /work/ wk((nt+1)**2*(nr+1)*2)
      common /conv/ istrt, itmax, step0, stepmin, stepmax, dtdump
      common /cycl/ iter, time, tstep, step
      common /subd/ istage, tbegin, totstage, tstage
      common /plte/ nplate, urtn(3,20)
      common /clsn/ ctorq(3,10)
      common /io01/ casenum, gpath,  lpath
      character casenum*3, gpath*80, lpath*80
      common /call/ ncall
      common /clck/ itmng, sec(50), nop(50)
      if(itmng.eq.1) call second(tin)
 
      if(nplate .eq. 0) return
 
      if(istage .ne. 0) then
         call platemoveimposed(u)
         return
      end if
 
      if(istrt.gt.0 .and. ncall.le.5) return
 
      if((istrt.gt.0 .and. ncall.eq.6) .or. ncall.eq.1) then
         ibc = 6
         call platevelo(u)
         if(stepmax .ne. 1.e-10) then
            call sphcoord(v)
            call ptclinit
            call nulvec(ctorq, 30)
            urtn(1,nplate+1) = 0.
            urtn(2,nplate+1) = 0.
            urtn(3,nplate+1) = 0.
            if(nplate .gt. 10) call platebreakup(urtn,torq)
         else
            if(mynum .eq. 0)
     &         open (85, file='pvel'//casenum, status='unknown')
         end if
      end if
 
c...  Solve for new set of plate rotations.
 
      call platesolv(u,f,v,w)
 
      if(stepmax .ne. 1.e-10) then
 
         if(nplate .gt. 10) call platebreakup(urtn,torq)
 
c...     Load into array u the surface velocity field implied
c...     by the new plate rotations.
 
         call platerotn(u,urtn)
 
c...     Using the new surface velocity field, move the tracer
c...     particles that carry the plate location information.
 
         call ptclmove(v,w,tstep/rshl(1))
 
c...     Generate a new nodal plate map that gives each surface
c...     node a plate number.
 
         call platemap(wk,v,w)
 
c...     Add particles in regions of plate divergence and delete
c...     particles in regions of plate convergence.
 
         call ptclsubd(wk)
 
         call ptclridg(u,wk,w)
 
      end if
 
      if(itmng.eq.1) call second(tout)
      if(itmng.eq.1) sec(16) = sec(16) + tout - tin
      end
*dk platerotn
      subroutine platerotn(v,vrtn)
 
c...  This routine loads the velocity field into the surface layer
c...  of array v specified by the surface plate rotations vrtn.
 
      include 'size.h'
      real v((nt+1)**2*nd,3,*), vrtn(3,*)
      common /mesh/ xn((nt+1)**2*nd,3)
      common /map0/ map((nt+1)**2*nd,3)
 
      call nulvec(v, (nt+1)**2*nd*3)
 
c...  Generate the surface velocity field from the plate rotations vrtn.
 
      do ii=1,(nt+1)**2*nd
         k = map(ii,1)
         v(ii,1,1) = vrtn(2,k)*xn(ii,3) - vrtn(3,k)*xn(ii,2)
         v(ii,2,1) = vrtn(3,k)*xn(ii,1) - vrtn(1,k)*xn(ii,3)
         v(ii,3,1) = vrtn(1,k)*xn(ii,2) - vrtn(2,k)*xn(ii,1)
      end do
 
      end
*dk platesolv
      subroutine platesolv(u,f,v,w)
 
c...  The plate model treats each plate as a perfectly rigid portion
c...  of the spherical surface whose motion is described by an Euler
c...  rotation vector.  This set of vectors is obtained by an iterative
c...  procedure that uses the velocities from the previous time step
c...  for nodes internal to the spherical shell to find the plate
c...  rotations that yield integrated torques that approach zero in
c...  the topmost layer of nodes over the area occupied by each plate.
 
      include 'size.h'
      include 'pcom.h'
      real u((nt+1)**2*nd,3,*), w((nt+1)**2*nd,3,*)
      real f((nt+1)**2*nd,3,*), torq(3,20), dtrq(3,20)
      real v((nt+1)**2*nd,3,*), vrtn(3,20), drtn(3,20), c(3)
      parameter (nopr=(nt/2+1)**2*ndo*189*(nr/2+1)*7/5+8000)
      common /fopr/ opr(nopr), oprd(nv*ndo/nd*9), b(nv*ndo/nd*18*5/4),
     &              mopr(0:10), mb(0:10)
      common /conv/ istrt, itmax, step0, stepmin, stepmax, dtdump
      common /plte/ nplate, urtn(3,20)
 
c...  Load velocity field for second layer into work array v.
 
      call scopy((nt+1)**2*3*nd, u(1,1,2),1, v(1,1,2),1)
 
c...  Load the nodal force field for the top layer into work array w.
 
      call scopy((nt+1)**2*nd*3, f(1,1,1),1, w(1,1,2),1)
 
c...  Iterate the procedure itsolv times.
 
      itsolv = 1
      if(stepmax .eq. 1.e-10) itsolv = 5
 
      do it=1,itsolv
 
c...     Successively apply a Newton iteration over each of
c...     the three Cartesian coordinate directions.
 
         do j=1,3
 
            call nulvec(c, 3)
            c(j) = 1.e-6
 
c...        Load the nodal force field for the top layer into
c...        work array w.
 
            call scopy((nt+1)**2*nd*3, w(1,1,2),1, w,1)
 
c...        Load a surface velocity field in the top nodal layer
c...        of array v based on the current best estimate of the
c...        plate rotations.
 
            call platerotn(v,urtn)
 
c...        Compute the residual forces in layer one.
 
            call plateforce(w,v,oprd)
 
c...        Compute the residual torque for each plate.
 
            call platetorq(torq,w)
 
c...        Modify the plate rotations by an incremental amount
c...        to compute the numerical derivative du/df.
 
            do k=1,nplate
               vrtn(1,k) = urtn(1,k)*(1. + c(1))
               vrtn(2,k) = urtn(2,k)*(1. + c(2))
               vrtn(3,k) = urtn(3,k)*(1. + c(3))
            end do
 
c...        Load the surface velocity field into array v
c...        implied by the modified plate rotations.
 
            call platerotn(v,vrtn)
 
            call scopy((nt+1)**2*nd*3, w(1,1,2),1, w,1)
 
c...        Compute the modified residual forces in layer one.
 
            call plateforce(w,v,oprd)
 
c...        Compute the modified residual torque for each plate.
 
            call platetorq(dtrq,w)
 
c...        Use the numerical derivatives to modify the plate
c...        rotations to reduce the residual torques.
 
            do k=1,nplate
               do i=1,3
 
                  dtrq(i,k) = dtrq(i,k) - torq(i,k)
 
                  if(abs(dtrq(i,k)) .gt. 1.e-15)
     &                   dtrq(i,k) = torq(i,k)/dtrq(i,k)
 
                  drtn(i,k) = (vrtn(i,k) - urtn(i,k))*dtrq(i,k)
                  urtn(i,k) =  urtn(i,k) - 0.3*drtn(i,k)
 
               end do
            end do
 
         end do
 
      end do
 
c...  Load into array u the surface velocity field implied by the
c...  new plate rotations.
 
      call platerotn(u,urtn)
 
      if(stepmax .eq. 1.e-10) call diagnose(u,torq)
 
      end
*dk platetorq
      subroutine platetorq(torq,r)
 
c...  This routine computes the residual torque vector for each
c...  plate from the cross product of the nodal radial unit vector
c...  with the nodal residual force summed over the nodes of the
c...  plate.
 
      include 'size.h'
      include 'pcom.h'
      real  r((nt+1)**2,nd,3), torq(3,*), vrtn(3,20)
      common /mesh/ xn((nt+1)**2,nd,3)
      common /ndar/  arn((nt+1)**2),  arne((nt+1)**2),
     &              rarn((nt+1)**2), rarne((nt+1)**2)
      common /map0/ map((nt+1)**2,nd,3)
      common /conv/ istrt, itmax, step0, stepmin, stepmax, dtdump
      common /plte/ nplate, urtn(3,20)
      common /clsn/ ctorq(3,10)
 
      call nulvec(torq, 3*nplate)
 
      do 20  k=1,nplate
 
      if(mod(mynum, mproc).eq.0 .and. map(1,1,1).eq.k) then
         torq(1,k) = torq(1,k) - r(1,1,2)
         torq(2,k) = torq(2,k) + r(1,1,1)
      end if
 
      if(mynum.eq.0 .and. nd.eq.10 .and. map(1,6,1).eq.k) then
         torq(1,k) = torq(1,k) + r(1,6,2)
         torq(2,k) = torq(2,k) - r(1,6,1)
      end if
 
      do 10 id=1,nd
      do 10 ii=2,(nt+1)**2
      aa = 0.
      if(map(ii,id,1) .eq. k) aa = 1.0
      if(arn(ii) .eq. 0.) aa = 0.0
      torq(1,k) = torq(1,k) + aa*(xn(ii,id,2)*r(ii,id,3)
     &                          - xn(ii,id,3)*r(ii,id,2))
      torq(2,k) = torq(2,k) + aa*(xn(ii,id,3)*r(ii,id,1)
     &                          - xn(ii,id,1)*r(ii,id,3))
      torq(3,k) = torq(3,k) + aa*(xn(ii,id,1)*r(ii,id,2)
     &                          - xn(ii,id,2)*r(ii,id,1))
 10   continue
 
 20   continue
 
      if(nproc .gt. 1) call psum(torq, 3*nplate)
 
      if(stepmax.ne.1.e-10 .and. nplate.gt.10) then
 
c...     Add torques arising from continent-continent collision.
 
         do k=1,10
            torq(1,k) = torq(1,k) + ctorq(1,k)
            torq(2,k) = torq(2,k) + ctorq(2,k)
            torq(3,k) = torq(3,k) + ctorq(3,k)
         end do
 
         call platebreakup(vrtn,torq)
 
      end if
 
      end
*dk platevelo
      subroutine platevelo(u)
 
c...  This routine computes a rigid rotation vector for each plate and
c...  enforces the rigid plate motions in the surface velocity field.
 
      include 'size.h'
      include 'pcom.h'
      real u((nt+1)**2,nd,3), ar(20)
      common /map0/ map((nt+1)**2,nd*3)
      common /mesh/ xn((nt+1)**2,nd,3)
      common /ndar/  arn((nt+1)**2),  arne((nt+1)**2),
     &              rarn((nt+1)**2), rarne((nt+1)**2)
      common /plte/ nplate, urtn(3,20)
 
      if(nplate .eq. 0) return
 
c...  Compute the velocity rotation vector for each plate.
 
      do 20 k=1,nplate
 
      ar(k)     = 0.
      urtn(1,k) = 0.
      urtn(2,k) = 0.
      urtn(3,k) = 0.
 
      if(mod(mynum, mproc).eq.0 .and. map(1,1).eq.k) then
         ar(k)     = arn(1)
         urtn(1,k) = -u(1,1,2)*arn(1)
         urtn(2,k) =  u(1,1,1)*arn(1)
      end if
 
      if(mynum.eq.0 .and. nd.eq.10 .and. map(1,6).eq.k) then
         ar(k)     = ar(k) + arn(1)
         urtn(1,k) = urtn(1,k) + u(1,6,2)*arn(1)
         urtn(2,k) = urtn(2,k) - u(1,6,1)*arn(1)
      end if
 
      do 10 id=1,nd
      do 10 ii=2,(nt+1)**2
      aa = 0.
      if(map(ii,id) .eq. k) aa = arn(ii)
      ar(k) = ar(k) + aa
      urtn(1,k) = urtn(1,k) + aa*(xn(ii,id,2)*u(ii,id,3)
     &                          - xn(ii,id,3)*u(ii,id,2))
      urtn(2,k) = urtn(2,k) + aa*(xn(ii,id,3)*u(ii,id,1)
     &                          - xn(ii,id,1)*u(ii,id,3))
      urtn(3,k) = urtn(3,k) + aa*(xn(ii,id,1)*u(ii,id,2)
     &                          - xn(ii,id,2)*u(ii,id,1))
 10   continue
 
 20   continue
 
      if(nproc .gt. 1) then
         call psum(ar,nplate)
         call psum(urtn,3*nplate)
      end if
 
      do 30 k=1,nplate
 
      if(ar(k) .ne. 0.) ar(k) = 1./ar(k)
 
      urtn(1,k) = urtn(1,k)*ar(k)
      urtn(2,k) = urtn(2,k)*ar(k)
      urtn(3,k) = urtn(3,k)*ar(k)
 
 30   continue
 
      end
*dk ptclcount
      subroutine ptclcount
 
c...  This routine counts the number of particles.
 
      include 'size.h'
      include 'pcom.h'
      parameter (np = 8, na = 4)
      common /ptc1/ attr(nt*nt*nd,na,np), attrp(1,1,2,na,np)
      common /call/ ncall
 
      cnt = 0.
 
      do ip=1,np
 
         if(attrp(1,1,1,1,ip) .lt. 1.) cnt = cnt + 1.
         if(attrp(1,1,2,1,ip) .lt. 1.) cnt = cnt + 1.
 
         do ii=1,nt*nt*nd
            if(attr(ii,1,ip)  .lt. 1.) cnt = cnt + 1.
         end do
 
      end do
 
      if(nproc .gt. 1) call psum(cnt, 1)
 
      ncnt = cnt
 
      if(mynum .eq. 0)
     &   write(*,'("ncall, particle count =",2i10)') ncall, ncnt
 
      end
*dk ptcldisp
      subroutine ptcldisp(attr,xn,dt,nd,nt)
 
c...  This routine updates the particle coordinates in the neighborhood
c...  of its previous nearest node assuming rigid plate motion.
 
      parameter (np = 8, na = 4)
      real attr(nt**2,nd,na,np), xn(nt**2,nd,3,3)
      common /plte/ nplate, urtn(3,20)
 
      do ip=1,np
         do id=1,nd
 
            do ii=1,nt**2
 
               if(attr(ii,id,1,ip) .lt. 1.) then
 
                  xea = attr(ii,id,1,ip)
                  xno = attr(ii,id,2,ip)
                  kpl = attr(ii,id,3,ip)
 
                  x1  = ((xn(ii,id,1,1) + xn(ii,id,1,2)*xea)
     &                                  + xn(ii,id,1,3)*xno)
                  x2  = ((xn(ii,id,2,1) + xn(ii,id,2,2)*xea)
     &                                  + xn(ii,id,2,3)*xno)
                  x3  = ((xn(ii,id,3,1) + xn(ii,id,3,2)*xea)
     &                                  + xn(ii,id,3,3)*xno)
 
                  d1  = (urtn(2,kpl)*x3 - urtn(3,kpl)*x2)*dt
                  d2  = (urtn(3,kpl)*x1 - urtn(1,kpl)*x3)*dt
                  d3  = (urtn(1,kpl)*x2 - urtn(2,kpl)*x1)*dt
 
                  attr(ii,id,1,ip) = (((xea + d1*xn(ii,id,1,2))
     &                                      + d2*xn(ii,id,2,2))
     &                                      + d3*xn(ii,id,3,2))
                  attr(ii,id,2,ip) = (((xno + d1*xn(ii,id,1,3))
     &                                      + d2*xn(ii,id,2,3))
     &                                      + d3*xn(ii,id,3,3))
 
               end if
 
            end do
 
         end do
      end do
 
      end
*dk ptcledge
      subroutine ptcledge(attr,attrp,nptl,nptlp,anew,anewp,new,newp)
 
c...  This routine loads attributes for particles that have crossed
c...  diamond boundaries into the appropriate nodal locations.
 
      include 'size.h'
      include 'pcom.h'
      parameter (np = 8, na = 4)
      real attr(nt,nt,nd,na,np), attrp(1,1,2,na,np)
      real anew(0:nt+1,0:nt+1,nd,na,4), anewp(0:2,0:2,2,na,4)
      integer nptl(nt,nt,nd), nptlp(1,1,2)
      integer new(0:nt+1,0:nt+1,nd), newp(0:2,0:2,2)
      common /work/ wk((nt+1)**2*(nr+1)*2)
      common /ngbr/ xnbr(nt,nt,6,2), xnbrp(1,1,6,2),
     &              cpsi(nt,nt,6),   cpsip(1,1,6),
     &              spsi(nt,nt,6),   spsip(1,1,6),
     &              qnbr(nt,nt,6,2), qnbrp(1,1,6,2),
     &              rdet(nt,nt,6),   rdetp(1,1,6)
      common /spok/ ispoke(10)
 
      if(nt*mod(mynum, mproc) .eq. mt-nt) then
         do id=1,nd
            jp = new(nt+1,1,id)
            do ip=1,new(nt+1,0,id)
               jp = min(4, jp + 1)
               do ia=1,na
                  anew(nt+1,1,id,ia,jp) = anew(nt+1,0,id,ia,ip)
                  anew(nt+1,0,id,ia,jp) = 0.
               end do
               anew(nt+1,0,id,1,jp) = 1.
               anew(nt+1,0,id,3,jp) = 1.
            end do
            new(nt+1,1,id) = jp
            new(nt+1,0,id) = 0
         end do
      end if
 
      if(mod(mynum, mproc) .eq. 0) then
 
         do id=1,nd
 
            ipole = 1 + id/6
            m  = mod(id-1, 5) + 1
            sn = 1.
            if(id.ge.6 .or. mynum.ge.mproc) sn = -1.
 
            jp = nptlp(1,1,ipole)
            do ip=1,new(0,1,id)
               jp = min(4, jp + 1)
               xea = anew(0,1,id,1,ip)*cpsip(1,1,m)
     &             + anew(0,1,id,2,ip)*spsip(1,1,m)*sn
               xno = anew(0,1,id,2,ip)*cpsip(1,1,m)
     &             - anew(0,1,id,1,ip)*spsip(1,1,m)*sn
               attrp(1,1,ipole,1,jp) = xea
               attrp(1,1,ipole,2,jp) = xno
               do ia=3,na
                  attrp(1,1,ipole,ia,jp) = anew(0,1,id,ia,ip)
               end do
            end do
            nptlp(1,1,ipole) = jp
 
            j1 = 1 + ispoke(mod(id-1,5)+1)
            j2 = 1 + ispoke(mod(id-1,5)+5)
 
            jp = nptl(1,1,id)
            do ip=1,newp(j1,j2,ipole)
               jp = min(4, jp + 1)
               do ia=1,na
                  attr(1,1,id,ia,jp) = anewp(j1,j2,ipole,ia,ip)
               end do
            end do
            nptl(1,1,id) = jp
 
         end do
 
      end if
 
      if(nproc .eq. 1) then
 
c...     The following is for calculation on a single processor.
 
         do id=1,10
 
            idur = mod(id,   5) + 1
            idul = mod(id+3, 5) + 1
            idlr = id   + 5
            idll = idul + 5
            if(id .ge. 6) then
               idlr = idur
               idur = idur + 5
               idul = idll
               idll = id   - 5
            end if
 
            do i=1,nt
 
               jp  = nptl( i,     1,idur)
               do ip=1,new(0, i+1,id)
                  if(nptl(i,1,idur)+ip .le. np) then
                     jp = jp + 1
                     do ia=1,na
                     attr( i,     1,idur,ia,jp) = anew(0, i+1,id,ia,ip)
                     end do
                  end if
               end do
               nptl( i,     1,idur) = jp
 
               jp  = nptl(nt+1-i,nt,idll)
               do ip=1,new(nt+1,i,id)
                  if(nptl(nt+1-i,nt,idll)+ip .le. np) then
                     jp = jp + 1
                     do ia=1,na
                     attr(nt+1-i,nt,idll,ia,jp) = anew(nt+1,i,id,ia,ip)
                     end do
                  end if
               end do
               nptl(nt+1-i,nt,idll) = jp
 
               jp  = nptl( 1,     i,idul)
               do ip=1,new(i,   0,id)
                  if(nptl(1,i,idul)+ip .le. np) then
                     jp = jp + 1
                     do ia=1,na
                     attr( 1,     i,idul,ia,jp) = anew(i,   0,id,ia,ip)
                     end do
                  end if
               end do
               nptl( 1,     i,idul) = jp
 
               jp  = nptl(nt,nt+1-i,idlr)
               do ip=1,new(i,nt+1,id)
                  if(nptl(nt,nt+1-i,idlr)+ip .le. np) then
                     jp = jp + 1
                     do ia=1,na
                     attr(nt,nt+1-i,idlr,ia,jp) = anew(i,nt+1,id,ia,ip)
                     end do
                  end if
               end do
               nptl(nt,nt+1-i,idlr) = jp
 
            end do
 
         end do
 
      else
 
c...     The following is for calculation on multiple processors.
 
         do ip=1,4
            do id=1,nd
               do i2=1,nt
                  do i1=1,nt
                     do ia=1,na
                        anew(i1,i2,id,ia,ip) = 0.
                     end do
                  end do
               end do
            end do
         end do
 
         call pghostadd(anew,16,4)
 
         do ip=1,4
            do id=1,nd
               do i2=1,nt
                  do i1=1,nt
                     if(anew(i1,i2,id,1,ip) .eq. 0.) then
                        anew(i1,i2,id,1,ip) = 1.
                        anew(i1,i2,id,3,ip) = 1.
                     end if
                  end do
               end do
            end do
         end do
 
         do id=1,nd
 
            do i=1,nt-1
 
               jp =  nptl(i+1,1,id)
               do ip=1,4
                  if(anew(i+1,1,id,1,ip) .lt. 1.) then
                     jp = min(np, jp + 1)
                     do ia=1,na
                        attr(i+1,1,id,ia,jp) = anew(i+1,1,id,ia,ip)
                     end do
                  end if
               end do
               nptl(i+1,1,id) = jp
 
               jp =  nptl( i,nt,id)
               do ip=1,4
                  if(anew( i,nt,id,1,ip) .lt. 1.) then
                     jp = min(np, jp + 1)
                     do ia=1,na
                        attr( i,nt,id,ia,jp) = anew( i,nt,id,ia,ip)
                     end do
                  end if
               end do
               nptl( i,nt,id) = jp
 
               jp =  nptl( 1, i,id)
               do ip=1,4
                  if(anew( 1, i,id,1,ip) .lt. 1.) then
                     jp = min(np, jp + 1)
                     do ia=1,na
                        attr( 1, i,id,ia,jp) = anew( 1, i,id,ia,ip)
                     end do
                  end if
               end do
               nptl( 1, i,id) = jp
 
               jp =  nptl(nt,i+1,id)
               do ip=1,4
                  if(anew(nt,i+1,id,1,ip) .lt. 1.) then
                     jp = min(np, jp + 1)
                     do ia=1,na
                        attr(nt,i+1,id,ia,jp) = anew(nt,i+1,id,ia,ip)
                     end do
                  end if
               end do
               nptl(nt,i+1,id) = jp
 
            end do
 
         end do
 
      end if
 
      end
*dk ptclinit
      subroutine ptclinit
 
c...  This routine initializes the particle attribute array attr
c...  using a particle density of four particles per node.
 
      include 'size.h'
      include 'pcom.h'
      parameter (np = 8, na = 4)
      common /mesh/ xn(0:nt,nt+1,nd,3)
      common /ptc1/ attr(nt,nt,nd,na,np), attrp(1,1,2,na,np)
      common /ptc2/ nptl(nt,nt,nd),      nptlp(1,1,2)
      common /ndar/  arn(0:nt,nt+1),  arne(0:nt,nt+1),
     &              rarn(0:nt,nt+1), rarne(0:nt,nt+1)
      common /map0/  map(0:nt,nt+1,nd,3)
      common /ngbr/ xnbr(nt,nt,6,2), xnbrp(1,1,6,2),
     &              cpsi(nt,nt,6),   cpsip(1,1,6),
     &              spsi(nt,nt,6),   spsip(1,1,6),
     &              qnbr(nt,nt,6,2), qnbrp(1,1,6,2),
     &              rdet(nt,nt,6),   rdetp(1,1,6)
 
      do id=1,nd
         sn = 1.
         if(id .ge. 6) sn = -1.
         do i2=1,nt
            do i1=1,nt
 
               deast  = -0.25*xnbr(i1,i2,3,1)
               dnorth = -0.25*xnbr(i1,i2,3,2)*sn
               attr(i1,i2,id,1,1) = deast
               attr(i1,i2,id,2,1) = dnorth
               attr(i1,i2,id,3,1) = map(i1,i2,id,1)
               attr(i1,i2,id,4,1) = 0.25*arne(i1,i2)
               if(map(i1,i2,id,2) .gt. 0)
     &            attr(i1,i2,id,4,1) = -attr(i1,i2,id,4,1)
 
               attr(i1,i2,id,1,2) = 0.5*xnbr(i1,i2,2,1)    + deast
               attr(i1,i2,id,2,2) = 0.5*xnbr(i1,i2,2,2)*sn + dnorth
               attr(i1,i2,id,3,2) = map(i1,i2,id,1)
               attr(i1,i2,id,4,2) = 0.25*arne(i1,i2)
               if(map(i1,i2,id,2) .gt. 0)
     &            attr(i1,i2,id,4,2) = -attr(i1,i2,id,4,2)
 
               attr(i1,i2,id,1,3) = 0.5*xnbr(i1,i2,3,1)    + deast
               attr(i1,i2,id,2,3) = 0.5*xnbr(i1,i2,3,2)*sn + dnorth
               attr(i1,i2,id,3,3) = map(i1,i2,id,1)
               attr(i1,i2,id,4,3) = 0.25*arne(i1,i2)
               if(map(i1,i2,id,2) .gt. 0)
     &            attr(i1,i2,id,4,3) = -attr(i1,i2,id,4,3)
 
               attr(i1,i2,id,1,4) = 0.5*xnbr(i1,i2,4,1)    + deast
               attr(i1,i2,id,2,4) = 0.5*xnbr(i1,i2,4,2)*sn + dnorth
               attr(i1,i2,id,3,4) = map(i1,i2,id,1)
               attr(i1,i2,id,4,4) = 0.25*arne(i1,i2)
               if(map(i1,i2,id,2) .gt. 0)
     &            attr(i1,i2,id,4,4) = -attr(i1,i2,id,4,4)
 
               nptl(i1,i2,id) = 4
 
               do ip=5,np
                  attr(i1,i2,id,1,ip) = 1.
                  attr(i1,i2,id,2,ip) = 0.
                  attr(i1,i2,id,3,ip) = 1.
                  attr(i1,i2,id,4,ip) = 0.
               end do
 
            end do
         end do
 
         if(mod(mynum, mproc) .eq. 2**lvproc-1) then
            attr(nt,1,id,4,1) = 1.16*attr(nt,1,id,4,1)
            attr(nt,1,id,4,2) = 1.16*attr(nt,1,id,4,2)
            attr(nt,1,id,4,3) = 1.16*attr(nt,1,id,4,3)
            attr(nt,1,id,4,4) = 1.16*attr(nt,1,id,4,4)
         end if
 
      end do
 
      nptlp(1,1,1) = 0
      nptlp(1,1,2) = 0
 
      do ip=1,np
         attrp(1,1,1,1,ip) = 1.
         attrp(1,1,1,2,ip) = 0.
         attrp(1,1,1,3,ip) = 1.
         attrp(1,1,1,4,ip) = 0.
         attrp(1,1,2,1,ip) = 1.
         attrp(1,1,2,2,ip) = 0.
         attrp(1,1,2,3,ip) = 1.
         attrp(1,1,2,4,ip) = 0.
      end do
 
      if(mod(mynum, mproc) .eq. 0) then
         do id=1,nd
            jd = 1 + id/6
            ip = mod(id-1, 5) + 1
            sn = 1.
            if(id .ge. 6) sn = -1.
            attrp(1,1,jd,1,ip) = 0.40*xnbrp(1,1,ip,1)
            attrp(1,1,jd,2,ip) = 0.40*xnbrp(1,1,ip,2)*sn
            attrp(1,1,jd,3,ip) = map(0,1,id,1)
            attrp(1,1,jd,4,ip) = 0.255*arne(0,1)
            if(map(0,1,id,2) .gt. 0)
     &         attrp(1,1,jd,4,ip) = -attrp(1,1,jd,4,ip)
            nptlp(1,1,jd) = 5
         end do
      end if
 
      end
*dk ptclmove
      subroutine ptclmove(anew,new,dt)
 
c...  This routine updates the particle coordinates to reflect the
c...  rigid plate rotations during a time step of length dt.
 
      include 'size.h'
      include 'pcom.h'
      parameter (np = 8, na = 4)
      real anew(0:nt+1,0:nt+1,nd,na,4), anewp(0:2,0:2,2,na,4)
      integer new(0:nt+1,0:nt+1,nd), newp(0:2,0:2,2)
      common /ptc1/ attr(nt,nt,nd,na,np), attrp(1,1,2,na,np)
      common /ptc2/ nptl(nt,nt,nd),      nptlp(1,1,2)
      common /xrtn/ xr(nt,nt,nd,3,3), xrp(1,1,2,3,3)
      common /ngbr/ xnbr(nt,nt,6,2), xnbrp(1,1,6,2),
     &              cpsi(nt,nt,6),   cpsip(1,1,6),
     &              spsi(nt,nt,6),   spsip(1,1,6),
     &              qnbr(nt,nt,6,2), qnbrp(1,1,6,2),
     &              rdet(nt,nt,6),   rdetp(1,1,6)
 
c...  Treat the particles associated with all nodes except for the
c...  north and south poles.
 
      call ptcldisp(attr,xr,dt,nd,nt)
 
      call ptclnode(attr,nptl,xnbr,qnbr,cpsi,spsi,anew,new,nd,nt)
 
c...  Treat the north and south poles.
 
      if(mod(mynum, mproc) .eq. 0) then
 
         call ptcldisp(attrp,xrp,dt,2,1)
 
         call ptclnode(attrp,nptlp,xnbrp,qnbrp,
     &                 cpsip,spsip,anewp,newp,2,1)
 
      end if
 
c...  Treat boundary communication.
 
      call ptcledge(attr,attrp,nptl,nptlp,anew,anewp,new,newp)
 
      end
*dk ptclnode
      subroutine ptclnode(attr,nptl,xnbr,qnbr,cpsi,spsi,anew,new,nd,nt)
 
c...  This routine uses nearest node values in array node to ensure
c...  particle information in array attr is associated with the
c...  nearest node.
 
      include 'pcom.h'
      parameter (np = 8, na = 4)
      real attr(nt,nt,nd,na,np), anew(0:nt+1,0:nt+1,nd,na,4)
      real xnbr(nt,nt,6,2), cpsi(nt,nt,6)
      real qnbr(nt,nt,6,2), spsi(nt,nt,6)
      integer nptl(nt,nt,nd), new(0:nt+1,0:nt+1,nd)
      logical empty
      common /spok/ ispoke(10)
 
c...  For a particle that has moved to a new nearest node, rotate the
c...  particle's coordinates to those of the new node and store the
c...  particle's attributes in the temporary array anew at the new nodal
c...  location.  Deactivate the particle in array attr.
 
      do id=1,nd
         do i2=0,nt+1
            do i1=0,nt+1
               new(i1,i2,id) = 0
            end do
         end do
      end do
 
      do ip=1,4
         do id=1,nd
            do i2=0,nt+1
               do i1=0,nt+1
                  anew(i1,i2,id,1,ip) = 1.
                  anew(i1,i2,id,2,ip) = 0.
                  anew(i1,i2,id,3,ip) = 1.
                  anew(i1,i2,id,4,ip) = 0.
               end do
            end do
         end do
      end do
 
      do ip=1,np
         do id=1,nd
 
            sn = 1.
            if(id.ge.6 .or. (nd.eq.2 .and. id.eq.2)) sn = -1.
 
            do i2=1,nt
               do i1=1,nt
 
                  if(attr(i1,i2,id,1,ip) .lt. 1.) then
 
c...                 Compute the dot products of the particle
c...                 locations with each of the unit vectors
c...                 pointing to the neighbor nodes.  The largest
c...                 dot product give the nearest neighbor node.
 
                     d2 = (attr(i1,i2,id,2,ip) + 1.e-50)*sn
                     dm = attr(i1,i2,id,1,ip)*qnbr(i1,i2,1,1)
     &                                   + d2*qnbr(i1,i2,1,2)
                     nbr    = 1
 
                     dd = attr(i1,i2,id,1,ip)*qnbr(i1,i2,2,1)
     &                                   + d2*qnbr(i1,i2,2,2)
                     if(dd .gt. dm) then
                        dm  = dd
                        nbr = 2
                     end if
 
                     dd = attr(i1,i2,id,1,ip)*qnbr(i1,i2,3,1)
     &                                   + d2*qnbr(i1,i2,3,2)
                     if(dd .gt. dm) then
                        dm  = dd
                        nbr = 3
                     end if
 
                     dd = attr(i1,i2,id,1,ip)*qnbr(i1,i2,4,1)
     &                                   + d2*qnbr(i1,i2,4,2)
                     if(dd .gt. dm) then
                        dm  = dd
                        nbr = 4
                     end if
 
                     dd = attr(i1,i2,id,1,ip)*qnbr(i1,i2,5,1)
     &                                   + d2*qnbr(i1,i2,5,2)
                     if(dd .gt. dm) then
                        dm  = dd
                        nbr = 5
                     end if
 
                     dd = attr(i1,i2,id,1,ip)*qnbr(i1,i2,6,1)
     &                                   + d2*qnbr(i1,i2,6,2)
                     if(dd .gt. dm) nbr = 6
 
c...                 Now determine if the particle is closer to its
c...                 home node or the nearest neighbor node.  If it
c...                 is closer to a neighboring node, rotate the
c...                 particle's coordinates to the coordinate frame
c...                 of the neighboring node and load the particle
c...                 attributes into array anew.  Deactivate the
c...                 particle in array attr.
 
                     if(xnbr(i1,i2,nbr,1)*attr(i1,i2,id,1,ip)
     &                + xnbr(i1,i2,nbr,2)*d2 .gt.
     &                 (xnbr(i1,i2,nbr,1)*xnbr(i1,i2,nbr,1)
     &                + xnbr(i1,i2,nbr,2)*xnbr(i1,i2,nbr,2))*0.5) then
 
                        j1  = i1 + ispoke(nbr)
                        j2  = i2 + ispoke(nbr+4)
 
                        new(j1,j2,id) = new(j1,j2,id) + 1
                        jp  = new(j1,j2,id)
 
                        xea = attr(i1,i2,id,1,ip) - xnbr(i1,i2,nbr,1)
                        xno = attr(i1,i2,id,2,ip) - xnbr(i1,i2,nbr,2)*sn
 
                        anew(j1,j2,id, 1,jp) = xea*cpsi(i1,i2,nbr)
     &                                       - xno*spsi(i1,i2,nbr)*sn
                        anew(j1,j2,id, 2,jp) = xno*cpsi(i1,i2,nbr)
     &                                       + xea*spsi(i1,i2,nbr)*sn
                        do ia=3,na
                        anew(j1,j2,id,ia,jp) = attr(i1,i2,id,ia,ip)
                        end do
                        attr(i1,i2,id, 1,ip) = 1.
 
                     end if
 
                  end if
 
               end do
            end do
         end do
      end do
 
c...  Pack the attribute data for the active particles still resident
c...  in array attr into the lowest ip locations.
 
      do id=1,nd
         do i2=1,nt
            do i1=1,nt
 
               npt = 0
 
               do ip=1,nptl(i1,i2,id)
 
                  if(attr(i1,i2,id,1,ip) .ge. 1.) then
 
                     empty = .true.
 
                     do jp=ip+1,nptl(i1,i2,id)
 
                        if(empty .and. attr(i1,i2,id,1,jp).ne.1.) then
 
                           do ia=1,na
                           attr(i1,i2,id,ia,ip) = attr(i1,i2,id,ia,jp)
                           end do
                           attr(i1,i2,id, 1,jp) = 1.
                           empty = .false.
                           npt   = ip
 
                        end if
 
                     end do
 
                  else
 
                     npt = ip
 
                  end if
 
               end do
 
               nptl(i1,i2,id) = npt
 
            end do
         end do
      end do
 
c...  Load attributes of particles in array anew which have not
c...  moved to nodes outside the subdomain back into array attr.
 
      do id=1,nd
         do i2=1,nt
            do i1=1,nt
 
               npt = nptl(i1,i2,id)
 
               do ip=1,new(i1,i2,id)
                  npt = min(np, npt + 1)
                  do ia=1,na
                     attr(i1,i2,id,ia,npt) = anew(i1,i2,id,ia,ip)
                  end do
               end do
 
               new(i1,i2,id)  = 0
               nptl(i1,i2,id) = npt
 
            end do
         end do
      end do
 
      end
*dk ptclridg
      subroutine ptclridg(u,tarea,corr)
 
c...  This routine adds new particles to oceanic plates in regions
c...  of plate divergence.
 
      include 'size.h'
      include 'pcom.h'
      parameter (np = 8, na = 4)
      real u(0:nt,nt+1,nd,3), tarea(0:nt,nt+1,nd)
      real corr(0:nt,nt+1,nd)
      common /ptc1/ attr(nt,nt,nd,na,np), attrp(1,1,2,na,np)
      common /ptc2/ nptl(nt,nt,nd), nptlp(1,1,2)
      common /ngbr/ xnbr(nt,nt,6,2), xnbrp(1,1,6,2),
     &              cpsi(nt,nt,6),   cpsip(1,1,6),
     &              spsi(nt,nt,6),   spsip(1,1,6),
     &              qnbr(nt,nt,6,2), qnbrp(1,1,6,2),
     &              rdet(nt,nt,6),   rdetp(1,1,6)
      common /map0/ map(0:nt,nt+1,nd*3)
      common /ndar/  arn(0:nt,nt+1),  arne(0:nt,nt+1),
     &              rarn(0:nt,nt+1), rarne(0:nt,nt+1)
      common /plte/ nplate, urtn(3,20)
 
      dnbr = 0.7*sqrt(xnbr(nt/2,nt/2,1,1)**2 + xnbr(nt/2,nt/2,1,2)**2)
 
c...  Identify nodes with locally correlated velocity (that is,
c...  nodes not on plate boundaries).
 
      call nulvec(corr, (nt+1)**2*nd)
 
      do id=1,nd
         do i2=1,nt+1
            i2m1 = max(1,    i2-1)
            i2p1 = min(nt+1, i2+1)
            do i1=0,nt
               i1m1 = max(0,  i1-1)
               i1p1 = min(nt, i1+1)
               d1 = ((u(i1p1,i2  ,id,1)*u(i1,i2,id,1)
     &              + u(i1p1,i2  ,id,2)*u(i1,i2,id,2))
     &              + u(i1p1,i2  ,id,3)*u(i1,i2,id,3))
               d2 = ((u(i1  ,i2p1,id,1)*u(i1,i2,id,1)
     &              + u(i1  ,i2p1,id,2)*u(i1,i2,id,2))
     &              + u(i1  ,i2p1,id,3)*u(i1,i2,id,3))
               d3 = ((u(i1m1,i2p1,id,1)*u(i1,i2,id,1)
     &              + u(i1m1,i2p1,id,2)*u(i1,i2,id,2))
     &              + u(i1m1,i2p1,id,3)*u(i1,i2,id,3))
               d4 = ((u(i1m1,i2  ,id,1)*u(i1,i2,id,1)
     &              + u(i1m1,i2  ,id,2)*u(i1,i2,id,2))
     &              + u(i1m1,i2  ,id,3)*u(i1,i2,id,3))
               d5 = ((u(i1  ,i2m1,id,1)*u(i1,i2,id,1)
     &              + u(i1  ,i2m1,id,2)*u(i1,i2,id,2))
     &              + u(i1  ,i2m1,id,3)*u(i1,i2,id,3))
               d6 = ((u(i1p1,i2m1,id,1)*u(i1,i2,id,1)
     &              + u(i1p1,i2m1,id,2)*u(i1,i2,id,2))
     &              + u(i1p1,i2m1,id,3)*u(i1,i2,id,3))
               if(d1.ge.0. .and. d2.ge.0. .and.
     &            d3.ge.0. .and. d4.ge.0. .and.
     &            d5.ge.0. .and. d6.ge.0.) corr(i1,i2,id) = 1.
            end do
         end do
      end do
 
      call comm3s(corr,0,nt,1)
 
      do id=1,nd
         do kk=1,nt
            if(corr(0,   kk,  id) .le. 1.) corr(0,   kk,  id) = 0.
            if(corr(nt,  kk+1,id) .le. 1.) corr(nt,  kk+1,id) = 0.
            if(corr(kk,     1,id) .le. 1.) corr(kk,     1,id) = 0.
            if(corr(kk-1,nt+1,id) .le. 1.) corr(kk-1,nt+1,id) = 0.
         end do
      end do
 
      do id=1,nd
         do i2=1,nt
            do i1=1,nt
 
               if(tarea(i1,i2,id).lt.0.7 .and.
     &             corr(i1,i2,id).gt.0.) then
 
c...              If nodal plate area fraction is below 0.70 and the
c...              velocities at the surrounding nodes are correlated
c...              in direction, add a new particle near the node with
c...              a plate number corresponding to that of the node.
c...              This tends to keep the nodal plate area fraction
c...              close to unity at nodes within plate interiors.
 
                  ip = nptl(i1,i2,id) + 1
                  attr(i1,i2,id,1,ip) = dnbr*(randomnum(0) - 0.5)
                  attr(i1,i2,id,2,ip) = dnbr*(randomnum(0) - 0.5)
                  attr(i1,i2,id,3,ip) = map(i1,i2,id)
                  attr(i1,i2,id,4,ip) = 0.25*arne(i1,i2)
                  nptl(i1,i2,id)      = ip
 
               elseif(tarea(i1,i2,id) .lt. 0.5) then
 
                  i1m1 = max(0,    i1-1)
                  i1p1 = min(nt,   i1+1)
                  i2m1 = max(1,    i2-1)
                  i2p1 = min(nt+1, i2+1)
 
                  np1  = 0
                  np2  = 0
                  kp1  = 0
                  kp2  = 0
 
                  if(map(i1p1,i2  ,id) .ne. map(i1,i2,id)) then
                     kp1 = map(i1p1,i2  ,id)
                     np1 = 1
                  end if
 
                  if(map(i1  ,i2p1,id) .ne. map(i1,i2,id)) then
                     kpq = map(i1  ,i2p1,id)
                     if(kp1 .eq. 0) then
                        kp1 = kpq
                        np1 = 1
                     elseif(kpq .eq. kp1) then
                        np1 = np1 + 1
                     else
                        kp2 = kpq
                        np2 = 1
                     end if
                  end if
 
                  if(map(i1m1,i2p1,id) .ne. map(i1,i2,id)) then
                     kpq = map(i1m1,i2p1,id)
                     if(kp1 .eq. 0) then
                        kp1 = kpq
                        np1 = 1
                     elseif(kpq .eq. kp1) then
                        np1 = np1 + 1
                     elseif(kpq .eq. kp2) then
                        np2 = np2 + 1
                     else
                        kp2 = kpq
                        np2 = 1
                     end if
                  end if
 
                  if(map(i1m1,i2  ,id) .ne. map(i1,i2,id)) then
                     kpq = map(i1m1,i2  ,id)
                     if(kp1 .eq. 0) then
                        kp1 = kpq
                        np1 = 1
                     elseif(kpq .eq. kp1) then
                        np1 = np1 + 1
                     elseif(kpq .eq. kp2) then
                        np2 = np2 + 1
                     else
                        kp2 = kpq
                        np2 = 1
                     end if
                  end if
 
                  if(map(i1  ,i2m1,id) .ne. map(i1,i2,id)) then
                     kpq = map(i1  ,i2m1,id)
                     if(kp1 .eq. 0) then
                        kp1 = kpq
                        np1 = 1
                     elseif(kpq .eq. kp1) then
                        np1 = np1 + 1
                     elseif(kpq .eq. kp2) then
                        np2 = np2 + 1
                     else
                        kp2 = kpq
                        np2 = 1
                     end if
                  end if
 
                  if(map(i1p1,i2m1,id) .ne. map(i1,i2,id)) then
                     kpq = map(i1p1,i2m1,id)
                     if(kp1 .eq. 0) then
                        kp1 = kpq
                        np1 = 1
                     elseif(kpq .eq. kp1) then
                        np1 = np1 + 1
                     elseif(kpq .eq. kp2) then
                        np2 = np2 + 1
                     else
                        kp2 = kpq
                        np2 = 1
                     end if
                  end if
 
                  kpx = kp1
                  if(np2 .gt. np1) then
                     kp1 = kp2
                     kp2 = kpx
                  end if
                  if(map(i1,i2,id) .gt. 0.) then
                     kp0 = map(i1,i2,id)
                  else
                     map(i1,i2,id) = kp1
                     if(kp2 .ne. 0) then
                        kp0 = kp2
                     else
                        kp0 = kp1
                     end if
                  end if
 
                  if(kp1 .ne. 0) then
 
c...                 Add a particle with a plate number the same as
c...                 the plate number of the node.
 
                     ip = nptl(i1,i2,id) + 1
                     attr(i1,i2,id,1,ip) = dnbr*(randomnum(0) - 0.5)
                     attr(i1,i2,id,2,ip) = dnbr*(randomnum(0) - 0.5)
                     attr(i1,i2,id,3,ip) = kp0
                     attr(i1,i2,id,4,ip) = 0.25*arne(i1,i2)
                     nptl(i1,i2,id)      = ip
 
c...                 Add a particle with a plate number equal to
c...                 that of the primary neighboring plate.
 
                     if(np2 .gt. np1) kp1 = kp2
 
                     ip = nptl(i1,i2,id) + 1
                     attr(i1,i2,id,1,ip) = dnbr*(randomnum(0) - 0.5)
                     attr(i1,i2,id,2,ip) = dnbr*(randomnum(0) - 0.5)
                     attr(i1,i2,id,3,ip) = kp1
                     attr(i1,i2,id,4,ip) = 0.25*arne(i1,i2)
                     nptl(i1,i2,id)      = ip
 
                  end if
 
               end if
 
            end do
         end do
      end do
 
      end
*dk ptclsubd
      subroutine ptclsubd(tarea)
 
c...  This routine removes particles from an oceanic plate at nodes
c...  where the oceanic plate is overlapping another plate.
 
      include 'size.h'
      include 'pcom.h'
      parameter (np = 8, na = 4)
      real tarea(0:nt,nt+1,nd)
      common /ptc1/ attr(nt,nt,nd,na,np), attrp(1,1,2,na,np)
      common /ptc2/ nptl(nt,nt,nd),      nptlp(1,1,2)
      common /map0/ map(0:nt,nt+1,nd*3)
      common /plte/ nplate, urtn(3,20)
 
c...  Remove particles where an oceanic plate overlaps another plate.
 
      do id=1,nd
         do i2=1,nt
            do i1=1,nt
 
               if(tarea(i1,i2,id) .gt. 1.2) then
 
c...              Remove the particle on the encroaching ocean plate
c...              nearest the node.
 
                  jp   = 0
                  dmin = 1.
 
                  do ip=1,nptl(i1,i2,id)
                     if(attr(i1,i2,id,3,ip).ne.map(i1,i2,id) .and.
     &                  attr(i1,i2,id,4,ip).gt.0.) then
                        dsq = attr(i1,i2,id,1,ip)**2
     &                      + attr(i1,i2,id,2,ip)**2
                        if(dsq .lt. dmin) then
                           dmin = dsq
                           jp   = ip
                        end if
                     end if
                  end do
 
                  if(jp .ne. 0) then
                     kp = nptl(i1,i2,id)
                     attr(i1,i2,id,1,jp) = attr(i1,i2,id,1,kp)
                     attr(i1,i2,id,2,jp) = attr(i1,i2,id,2,kp)
                     attr(i1,i2,id,3,jp) = attr(i1,i2,id,3,kp)
                     attr(i1,i2,id,4,jp) = attr(i1,i2,id,4,kp)
                     attr(i1,i2,id,1,kp) = 1.
                     nptl(i1,i2,id)      = nptl(i1,i2,id) - 1
                  end if
 
               end if
 
            end do
         end do
      end do
 
c...  Treat the polar nodes.
 
      do id=1,nd,5
 
         ipole = 1 + id/5
 
         if(tarea(0,1,id) .gt. 1.2) then
 
c...        Remove the particle on the encroaching ocean plate
c...        nearest the node.
 
            jp   = 0
            dmin = 1.
 
            do ip=1,nptlp(1,1,ipole)
               if(attrp(1,1,ipole,3,ip).ne.map(0,1,id) .and.
     &            attrp(1,1,ipole,4,ip).gt.0.) then
                  dsq = attrp(1,1,ipole,1,ip)**2
     &                + attrp(1,1,ipole,2,ip)**2
                  if(dsq .lt. dmin) then
                     dmin = dsq
                     jp   = ip
                  end if
               end if
            end do
 
            if(jp .ne. 0) then
               kp = nptlp(1,1,ipole)
               attrp(1,1,ipole,1,jp) = attrp(1,1,ipole,1,kp)
               attrp(1,1,ipole,2,jp) = attrp(1,1,ipole,2,kp)
               attrp(1,1,ipole,3,jp) = attrp(1,1,ipole,3,kp)
               attrp(1,1,ipole,4,jp) = attrp(1,1,ipole,4,kp)
               attrp(1,1,ipole,1,kp) = 1.
               nptlp(1,1,ipole) = nptlp(1,1,ipole) - 1
            end if
 
         end if
 
      end do
 
      end
*dk sphcoord
      subroutine sphcoord(xg)
 
c...  This routine calculates the unit vectors that define the
c...  local spherical coordinate system at each node.  It also
c...  computes the coordinates of the neighboring nodes and their
c...  angles in the local coordinate frame.
 
      include 'size.h'
      include 'pcom.h'
      real xg(0:nt+1,0:nt+1,3,3)
      common /mesh/ xn(0:nt,nt+1,nd,3)
      common /xnex/ xne(-1:nt+1,0:nt+2,nd,3)
      common /xrtn/ xr(nt,nt,nd,3,3), xrp(1,1,2,3,3)
      common /ngbr/ xnbr(nt,nt,6,2), xnbrp(1,1,6,2),
     &              cpsi(nt,nt,6),   cpsip(1,1,6),
     &              spsi(nt,nt,6),   spsip(1,1,6),
     &              qnbr(nt,nt,6,2), qnbrp(1,1,6,2),
     &              rdet(nt,nt,6),   rdetp(1,1,6)
      common /spok/ ispoke(10)
 
      do i=1,10
         ispoke(i) = (mod(i-1,3) - 1)*(-1)**i
      end do
 
c...  Compute the unit longitude and unit latitude vectors.
 
      do id=1,nd
         do i2=1,nt
            do i1=1,nt
               t1 = -xn(i1,i2,id,2)
               t2 =  xn(i1,i2,id,1)
               tn =  1./sqrt((1.e-100 + t1**2) + t2**2)
               t1 =  tn*t1
               t2 =  tn*t2
               xr(i1,i2,id,1,1)  =  xn(i1,i2,id,1)
               xr(i1,i2,id,2,1)  =  xn(i1,i2,id,2)
               xr(i1,i2,id,3,1)  =  xn(i1,i2,id,3)
               xr(i1,i2,id,1,2)  =  t1
               xr(i1,i2,id,2,2)  =  t2
               xr(i1,i2,id,3,2)  =  0.
               xr(i1,i2,id,1,3)  = -xn(i1,i2,id,3)*t2
               xr(i1,i2,id,2,3)  =  xn(i1,i2,id,3)*t1
               xr(i1,i2,id,3,3)  =  xn(i1,i2,id,1)*t2
     &                           -  xn(i1,i2,id,2)*t1
            end do
         end do
      end do
 
      if(mod(mynum, mproc) .eq. 0) then
         chi = 0.8*asin(1.)
         do ip=1,10/nd
            sn  =  1.
            eta = -0.5*chi
            if(ip .eq. 2) sn  = -1.
            if(ip .eq. 2) eta =  0.
            xrp(1,1,ip,1,1) =  0.
            xrp(1,1,ip,2,1) =  0.
            xrp(1,1,ip,3,1) =  sn
            xrp(1,1,ip,1,2) = -sin(eta)
            xrp(1,1,ip,2,2) =  cos(eta)
            xrp(1,1,ip,3,2) =  0.
            xrp(1,1,ip,1,3) = -cos(eta)*sn
            xrp(1,1,ip,2,3) = -sin(eta)*sn
            xrp(1,1,ip,3,3) =  0.
         end do
      end if
 
c...  Obtain unit longitude and unit latitude vectors for extended
c...  array xg.
 
      do i2=0,nt+1
         do i1=0,nt+1
            t1 = -xne(i1,i2,1,2)
            t2 =  xne(i1,i2,1,1)
            tn =  1./sqrt((1.e-100 + t1**2) + t2**2)
            t1 =  tn*t1
            t2 =  tn*t2
            xg(i1,i2,1,2)  =  t1
            xg(i1,i2,2,2)  =  t2
            xg(i1,i2,3,2)  =  0.
            xg(i1,i2,1,3)  = -xne(i1,i2,1,3)*t2
            xg(i1,i2,2,3)  =  xne(i1,i2,1,3)*t1
            xg(i1,i2,3,3)  =  xne(i1,i2,1,1)*t2 - xne(i1,i2,1,2)*t1
            xg(i1,i2,1,1)  =  xne(i1,i2,1,1)
            xg(i1,i2,2,1)  =  xne(i1,i2,1,2)
            xg(i1,i2,3,1)  =  xne(i1,i2,1,3)
         end do
      end do
 
      if(mod(mynum, mproc) .eq. 0) then
         xg(0,1,1,2) = xrp(1,1,1,1,2)
         xg(0,1,2,2) = xrp(1,1,1,2,2)
         xg(0,1,3,2) = xrp(1,1,1,3,2)
         xg(0,1,1,3) = xrp(1,1,1,1,3)
         xg(0,1,2,3) = xrp(1,1,1,2,3)
         xg(0,1,3,3) = xrp(1,1,1,3,3)
      end if
 
c...  Compute the sine and cosine of the rotation angles psi needed to
c...  transform from the local coordinate system of the neighboring nodes
c...  to the local coordinate system of a given node (i1,i2).  Also
c...  compute the local coordinates of the neighboring nodes in the
c...  coordinate system of node (i1,i2).
 
      do m=1,6
         do i2=1,nt
            j2  = i2 + ispoke(m+4)
 
            do i1=1,nt
               j1  = i1 + ispoke(m)
               d1  = xg(i1,i2,1,1)*xg(j1,j2,1,1)
     &             + xg(i1,i2,2,1)*xg(j1,j2,2,1)
     &             + xg(i1,i2,3,1)*xg(j1,j2,3,1)
               d2  = xg(i1,i2,1,2)*xg(j1,j2,1,1)
     &             + xg(i1,i2,2,2)*xg(j1,j2,2,1)
     &             + xg(i1,i2,3,2)*xg(j1,j2,3,1)
               d3  = xg(i1,i2,1,3)*xg(j1,j2,1,1)
     &             + xg(i1,i2,2,3)*xg(j1,j2,2,1)
     &             + xg(i1,i2,3,3)*xg(j1,j2,3,1)
               d3  = sign(min(1., abs(d3)), d3)
               xi  = asin(d3)
               eta = atan(d2/(d1 + 1.e-20))
               xnbr(i1,i2,m,1) = eta
               xnbr(i1,i2,m,2) = xi
               d12 = xg(i1,i2,1,1)*xg(j1,j2,1,2)
     &             + xg(i1,i2,2,1)*xg(j1,j2,2,2)
     &             + xg(i1,i2,3,1)*xg(j1,j2,3,2)
               d13 = xg(i1,i2,1,1)*xg(j1,j2,1,3)
     &             + xg(i1,i2,2,1)*xg(j1,j2,2,3)
     &             + xg(i1,i2,3,1)*xg(j1,j2,3,3)
               d22 = xg(i1,i2,1,2)*xg(j1,j2,1,2)
     &             + xg(i1,i2,2,2)*xg(j1,j2,2,2)
     &             + xg(i1,i2,3,2)*xg(j1,j2,3,2)
               d23 = xg(i1,i2,1,2)*xg(j1,j2,1,3)
     &             + xg(i1,i2,2,2)*xg(j1,j2,2,3)
     &             + xg(i1,i2,3,2)*xg(j1,j2,3,3)
               csp = cos(eta)
               snp = sin(eta)
               cpsi(i1,i2,m) = csp*d22 - snp*d12
               spsi(i1,i2,m) = csp*d23 - snp*d13
            end do
 
         end do
 
      end do
 
      do m=1,6
         k = mod(m, 6) + 1
         do i2=1,nt
            do i1=1,nt
               det = xnbr(i1,i2,m,1)*xnbr(i1,i2,k,2)
     &             - xnbr(i1,i2,k,1)*xnbr(i1,i2,m,2)
               if(det .ne. 0.) det = 1./det
               rdet(i1,i2,m)   = det
               xnrm = 1./sqrt(xnbr(i1,i2,m,1)**2 + xnbr(i1,i2,m,2)**2)
               qnbr(i1,i2,m,1) = xnrm*xnbr(i1,i2,m,1)
               qnbr(i1,i2,m,2) = xnrm*xnbr(i1,i2,m,2)
            end do
         end do
      end do
 
c...  Generate the same arrays for the polar node.
 
      if(mod(mynum, mproc) .eq. 0) then
 
         do m=1,5
            d1  = xrp(1,1,1,1,1)*xr(1,1,m,1,1)
     &          + xrp(1,1,1,2,1)*xr(1,1,m,2,1)
     &          + xrp(1,1,1,3,1)*xr(1,1,m,3,1)
            d2  = xrp(1,1,1,1,2)*xr(1,1,m,1,1)
     &          + xrp(1,1,1,2,2)*xr(1,1,m,2,1)
     &          + xrp(1,1,1,3,2)*xr(1,1,m,3,1)
            d3  = xrp(1,1,1,1,3)*xr(1,1,m,1,1)
     &          + xrp(1,1,1,2,3)*xr(1,1,m,2,1)
     &          + xrp(1,1,1,3,3)*xr(1,1,m,3,1)
            d3  = sign(min(1., abs(d3)), d3)
            xi  = asin(d3)
            eta = atan(d2/(d1 + 1.e-20))
            xnbrp(1,1,m,1) = eta
            xnbrp(1,1,m,2) = xi
            d12 = xrp(1,1,1,1,1)*xr(1,1,m,1,2)
     &          + xrp(1,1,1,2,1)*xr(1,1,m,2,2)
     &          + xrp(1,1,1,3,1)*xr(1,1,m,3,2)
            d13 = xrp(1,1,1,1,1)*xr(1,1,m,1,3)
     &          + xrp(1,1,1,2,1)*xr(1,1,m,2,3)
     &          + xrp(1,1,1,3,1)*xr(1,1,m,3,3)
            d22 = xrp(1,1,1,1,2)*xr(1,1,m,1,2)
     &          + xrp(1,1,1,2,2)*xr(1,1,m,2,2)
     &          + xrp(1,1,1,3,2)*xr(1,1,m,3,2)
            d23 = xrp(1,1,1,1,2)*xr(1,1,m,1,3)
     &          + xrp(1,1,1,2,2)*xr(1,1,m,2,3)
     &          + xrp(1,1,1,3,2)*xr(1,1,m,3,3)
            csp = cos(eta)
            snp = sin(eta)
            cpsip(1,1,m) = csp*d22 - snp*d12
            spsip(1,1,m) = csp*d23 - snp*d13
         end do
 
         do m=1,5
            k = mod(m, 5) + 1
            det = xnbrp(1,1,m,1)*xnbrp(1,1,k,2)
     &          - xnbrp(1,1,k,1)*xnbrp(1,1,m,2)
            rdetp(1,1,m)   = 1./det
            xnrm = 1./sqrt(xnbrp(1,1,m,1)**2 + xnbrp(1,1,m,2)**2)
            qnbrp(1,1,m,1) = xnrm*xnbrp(1,1,m,1)
            qnbrp(1,1,m,2) = xnrm*xnbrp(1,1,m,2)
         end do
 
      end if
 
      end
*dk bdplates
      block data bdplates
 
      common /nghbr/ idul(10), idur(10), idll(10), idlr(10)
      data idul/5,1,2,3,4,10,6,7,8,9/,idur/2,3,4,5,1,7,8,9,10,6/,
     &     idll/10,6,7,8,9,1,2,3,4,5/,idlr/6,7,8,9,10,2,3,4,5,1/
 
      common /bkup/ tasna, tnagl, tafsa, tafan, tewgw, tafin, tinsu,
     &              tafmd, twpep, tnfsf
      data tasna/ 50.e6/, tnagl/ 52.e6/, tafsa/ 25.e6/, tafan/ 33.e6/
      data tewgw/ 45.e6/, tafin/ 75.e6/, tinsu/100.e6/, tafmd/300.e6/
      data twpep/  0.e6/, tnfsf/300.e6/
 
      common /plte/ nplate, urtn(3,20)
 
c...  Rick's plate data (an au af pa eu na nz co ca ar ph sa in jf):
 
c     data urtn/ 1.5300e-10, 3.4201e-10, 9.8996e-11,
c    &           1.9681E-09, 1.7596E-09, 4.4651E-10,
c    &           5.2496E-10, 3.3046E-11,-5.0661E-11,
c    &            .0000E+00, 1.7158E-09,-2.9960E-09,
c    &           1.1890E-10, 1.9102E-10,-2.2343E-10,
c    &           3.7509E-10,-7.3596E-11,-9.0936E-10,
c    &          -3.9458E-12,-1.1318E-09, 1.1598E-09,
c    &          -1.8836E-09,-3.8792E-09, 1.4345E-09,
c    &           2.7610E-10,-2.7550E-11,-5.3074E-10,
c    &           1.7281E-09, 5.7488E-10, 5.4987E-10,
c    &           2.3929E-09,-8.6624E-10,-2.9692E-09,
c    &           1.0026E-10, 3.6657E-10,-1.0614E-09,
c    &           1.7229E-09, 6.9259E-10, 5.5357E-10,
c    &           1.3741E-09, 2.3801E-09,-1.9101E-09,
*    &           18*0./
 
c...  Mark's plate data (an af pa eu na nz co ca ar ph sa in):
 
      data urtn/-2.0218E-10,-1.6139E-10, 8.5146E-10,
     &           2.0222E-10,-5.4377E-10, 9.3569E-10,
     &          -6.4365E-10, 7.1735E-10,-2.3153E-09,
     &          -1.1102E-11,-4.8920E-10, 7.8919E-10,
     &           1.5873E-10,-7.1010E-10, 1.0485E-10,
     &          -4.8949E-10,-2.2079E-09, 2.4167E-09,
     &          -2.4101E-09,-6.9996E-09, 3.2189E-09,
     &          -3.4340E-11,-2.9681E-10, 6.4076E-10,
     &           1.3273E-09,-1.1845E-10, 1.5168E-09,
     &           1.6459E-09,-2.2406E-09,-1.3201E-09,
     &          -3.5557E-10,-1.5980E-10,-1.8762E-10,
     &           1.6844E-09, 1.1447E-09, 1.1996E-09,
     &           24*0./
 
      end
