*dk platemoveimposed
      subroutine platemoveimposed(u)
 
c...  This routine is a reduced version of the plate driver
c...  routine (platemov). It applies pre-specified rigid rotation
c...  vectors to the surface velocity field. No new vectors and no
c...  no new plate maps are computed.
c
      include 'size.h'
      include 'pcom.h'
      real u((nt+1)**2*10,3,*)
      character platename(20)*15
      common /radl/ rshl(nr+2), ird, ibc
      common /plte/ nplate, urtn(3,20)
      common /subd/ istage, tbegin, totstage, tstage
      common /call/ ncall
      common /clck/ itmng, sec(50), nop(50)
      if(itmng.eq.1) call second(tin)
 
      if(ncall .le. 0 .or. nplate. eq. 0) return
      ibc = 6
 
c     Load rotation vector based on plate stage.
 
c...  present  :  0-10 Ma
      if(istage.eq.1 ) call platevelimposed1
c...  stage 5  : 10-25 Ma
      if(istage.eq.2 ) call platevelimposed2
c...  stage 13 : 25-43 Ma
      if(istage.eq.3 ) call platevelimposed3
c...  stage 21 : 43-48 Ma
      if(istage.eq.4 ) call platevelimposed4
c...  stage 21b: 48-56 Ma
      if(istage.eq.5 ) call platevelimposed5
c...  stage 27 : 56-64 Ma
      if(istage.eq.6 ) call platevelimposed6
c...  stage 74 : 64-74 Ma
      if(istage.eq.7 ) call platevelimposed7
c...  stage 84 : 74-84 Ma
      if(istage.eq.8 ) call platevelimposed8
c...  stage 94 : 84-94 Ma
      if(istage.eq.9 ) call platevelimposed9
c...  stage 100: 94-100 Ma
      if(istage.eq.10) call platevelimposed10
c...  stage 119: 100-119 Ma
      if(istage.eq.11) call platevelimposed11
 
c...  Apply euler-rotation based on plate-stage.
      call platerotn(u,urtn)
 
      if(mynum.eq.0 .and. mod(ncall,500).eq.1) then
 
         platename(1) ='1'
         platename(2) ='2'
         platename(3) ='3'
         platename(4) ='4'
         platename(5) ='5'
         platename(6) ='6'
         platename(7) ='7'
         platename(8) ='8'
         platename(9) ='9'
         platename(10)='10'
         platename(11)='11'
         platename(12)='12'
         platename(13)='13'
 
         write(6,'(/"Cartesian rotation vector components in m/sec")')
 
         do k=1,nplate
            write(6,'(a15,":",1p3e15.6)') platename(k),(urtn(i,k),i=1,3)
         end do
 
         write(6,'(/)')
 
      endif
 
      if(itmng.eq.1) call second(tout)
      if(itmng.eq.1) sec(16) = sec(16) + tout - tin
      end
*dk platestage
      subroutine platestage
 
      common /subd/ istage, tbegin, totstage, tstage
      common /plte/ nplate, urtn(3,20)
 
c...  This routine initializes the duration
c     of past plate motion intervals.
 
c...  stage 0  :  0-10 Ma
      if(istage.eq.1) tbegin    = 109.e6
      if(istage.eq.1) totstage  = 10.e6
      if(istage.eq.1) nplate    = 12
 
c...  stage 5  : 10-25 Ma
      if(istage.eq.2) tbegin    = 94.e6
      if(istage.eq.2) totstage  = 15.e6
      if(istage.eq.2) nplate    = 12
 
c...  stage 13 : 25-43 Ma
      if(istage.eq.3) tbegin    = 76.e6
      if(istage.eq.3) totstage  = 18.e6
      if(istage.eq.3) nplate    = 12
 
c...  stage 21 : 43-48 Ma
      if(istage.eq.4) tbegin    = 71.e6
      if(istage.eq.4) totstage  = 5.e6
      if(istage.eq.4) nplate    = 13
 
c...  stage 21b: 48-56 Ma
      if(istage.eq.5) tbegin    = 63.e6
      if(istage.eq.5) totstage  = 8.e6
      if(istage.eq.5) nplate    = 13
 
c...  stage 27 : 56-64 Ma
      if(istage.eq.6) tbegin    = 55.e6
      if(istage.eq.6) totstage  = 8.e6
      if(istage.eq.6) nplate    = 13
 
c...  stage 74 : 64-74 Ma
      if(istage.eq.7) tbegin    = 45.e6
      if(istage.eq.7) totstage  = 10.e6
      if(istage.eq.7) nplate    = 12
 
c...  stage 84 : 74-84 Ma
      if(istage.eq.8) tbegin    = 35.e6
      if(istage.eq.8) totstage  = 10.e6
      if(istage.eq.8) nplate    = 11
 
c...  stage 94 : 84-94 Ma
      if(istage.eq.9) tbegin    = 25.e6
      if(istage.eq.9) totstage  = 10.e6
      if(istage.eq.9) nplate    = 11
 
c...  stage 100: 94-100 Ma
      if(istage.eq.10) tbegin   = 19.e6
      if(istage.eq.10) totstage = 6.e6
      if(istage.eq.10) nplate   = 10
 
c...  stage 119: 100-119 Ma
      if(istage.eq.11) tbegin   = 0.e6
      if(istage.eq.11) totstage = 19.e6
      if(istage.eq.11) nplate   = 10
 
      end
*dk platevelimposed1
      subroutine platevelimposed1
 
c...  Peter: may14th, 1995: This routine applies prespecified rigid
c     rotation vectors for each plate and enforces the rigid plate
c     motions in the surface velocity field. In this sense it is similar
c     to routine "platevel", where rotation vectors are determined
c     self-consistently from the surface velocity field.
 
      include 'size.h'
      include 'pcom.h'
      common /plte/ nplate, urtn(3,20)
      common /subd/ istage, tbegin, totstage, tstage
 
      call nulvec(urtn,60)
 
c...  specify rotation poles for present-day plate map, units
c     are: cm/yr; THESE VALUES ARE FOR HOT-SPOT-REFERENCE FRAME.
 
c     Africa:
      urtn(1, 1)=  0.136004E+01
      urtn(2, 1)= -0.543976E+00
      urtn(3, 1)=  0.498655E+00
c...  Antarctica
      urtn(1, 2)=  0.138706E+00
      urtn(2, 2)=  0.540223E+00
      urtn(3, 2)=  0.224212E+00
c...  Arabia
      urtn(1, 3)=  0.382923E+01
      urtn(2, 3)= -0.261050E+00
      urtn(3, 3)=  0.198100E+01
c...  Caribbean
      urtn(1, 4)=  0.415078E+00
      urtn(2, 4)=  0.968449E+00
      urtn(3, 4)= -0.975693E+00
c...  Cocos
      urtn(1, 5)= -0.636929E+01
      urtn(2, 5)= -0.132344E+02
      urtn(3, 5)=  0.590426E+01
c...  Eurasia
      urtn(1, 6)=  0.388778E+00
      urtn(2, 6)= -0.166631E+00
      urtn(3, 6)=  0.516796E-02
c...  India
      urtn(1, 7)=  0.612032E+01
      urtn(2, 7)=  0.438172E+01
      urtn(3, 7)=  0.262122E+01
c...  North America
      urtn(1, 8)=  0.109538E+01
      urtn(2, 8)= -0.942173E+00
      urtn(3, 8)= -0.233938E+01
c...  Nazca
      urtn(1, 9)= -0.288789E+00
      urtn(2, 9)= -0.434793E+01
      urtn(3, 9)=  0.483950E+01
c...  Pacific
      urtn(1,10)= -0.639622E+00
      urtn(2,10)=  0.506313E+01
      urtn(3,10)= -0.947799E+01
c...  Phillipine
      urtn(1,11)=  0.756111E+01
      urtn(2,11)= -0.273708E+01
      urtn(3,11)= -0.938191E+01
c...  South America
      urtn(1,12)=  0.104996E+00
      urtn(2,12)=  0.411914E+00
      urtn(3,12)= -0.314400E+01
 
c...  apply scaling factors
c     1)change from cm/yr to m/sec
c     2)present day rms plate velocities are 4.4cm/yr,
c     TERRA values are likely to be less. Scale accordingly.
 
      factor1 =  0.3171*1.0e-9
      factor2 =  1.00
 
      do i1=1,3
         do i2=1,20
            urtn(i1,i2) = factor1*factor2*urtn(i1,i2)
         end do
      end do
 
      end
*dk platevelimposed2
      subroutine platevelimposed2
 
c...  Peter: may14th, 1995: This routine applies prespecified rigid
c     rotation vectors for each plate and enforces the rigid plate
c     motions in the surface velocity field. In this sense it is similar
c     to routine "platevel", where rotation vectors are determined
c     self-consistently from the surface velocity field.
 
      include 'size.h'
      include 'pcom.h'
      common /plte/ nplate, urtn(3,20)
      common /subd/ istage, tbegin, totstage, tstage
 
      if(nplate .eq. 0) return
      call nulvec(urtn,60)
 
c...  specify stage5 rotation poles (units are cm/yr)
c...  1
      urtn(1, 1)=  0.158035E+01
      urtn(2, 1)= -0.113560E+01
      urtn(3, 1)=  0.224657E+01
c...  2
      urtn(1, 2)=  0.120312E+00
      urtn(2, 2)= -0.102032E+00
      urtn(3, 2)=  0.209802E+01
c...  3
      urtn(1, 3)= -0.620487E+00
      urtn(2, 3)=  0.163344E+01
      urtn(3, 3)= -0.457579E+01
c...  4
      urtn(1, 4)= -0.978515E+01
      urtn(2, 4)= -0.220815E+02
      urtn(3, 4)=  0.112112E+02
c...  5
      urtn(1, 5)=  0.153872E+00
      urtn(2, 5)= -0.533101E+00
      urtn(3, 5)=  0.140860E+01
c...  6
      urtn(1, 6)= -0.266922E+01
      urtn(2, 6)=  0.367386E+01
      urtn(3, 6)=  0.792660E-01
c...  7
      urtn(1, 7)=  0.509968E+01
      urtn(2, 7)=  0.252042E+01
      urtn(3, 7)=  0.370830E+01
c...  8
      urtn(1, 8)=  0.637372E+00
      urtn(2, 8)= -0.126727E+01
      urtn(3, 8)= -0.770198E+00
c...  9
      urtn(1, 9)= -0.763029E+00
      urtn(2, 9)= -0.437196E+01
      urtn(3, 9)=  0.696634E+01
c... 10
      urtn(1,10)= -0.114623E+01
      urtn(2,10)=  0.283702E+01
      urtn(3,10)= -0.797110E+01
c... 11
      urtn(1,11)=  0.390631E+01
      urtn(2,11)= -0.187998E+01
      urtn(3,11)=  0.481468E+01
c... 12
      urtn(1,12)= -0.213121E+00
      urtn(2,12)=  0.488112E-01
      urtn(3,12)= -0.130653E+01
 
c...  apply scaling factors
c     1)change from cm/yr to m/sec
c     2)present day rms plate velocities are 4.4cm/yr,
c     TERRA values are likely to be less. Scale accordingly.
 
      factor1 =  0.3171*1.0e-9
      factor2 =  1.00
 
      do i1=1,3
         do i2=1,20
            urtn(i1,i2) = factor1*factor2*urtn(i1,i2)
         end do
      end do
 
      end
*dk platevelimposed3
      subroutine platevelimposed3
 
c...  Peter: may14th, 1995: This routine applies prespecified rigid
c     rotation vectors for each plate and enforces the rigid plate
c     motions in the surface velocity field. In this sense it is similar
c     to routine "platevel", where rotation vectors are determined
c     self-consistently from the surface velocity field.
 
      include 'size.h'
      include 'pcom.h'
      common /plte/ nplate, urtn(3,20)
      common /subd/ istage, tbegin, totstage, tstage
 
      if(nplate .eq. 0) return
      call nulvec(urtn,60)
 
c...  specify stage13 rotation poles (units are cm/yr)
c...  1
      urtn(1, 1)=  0.137073E+01
      urtn(2, 1)= -0.130078E+01
      urtn(3, 1)=  0.185699E+01
c...  2
      urtn(1, 2)= -0.844291E+00
      urtn(2, 2)= -0.253299E+00
      urtn(3, 2)=  0.200804E+01
c...  3
      urtn(1, 3)=  0.484989E+01
      urtn(2, 3)=  0.200889E+01
      urtn(3, 3)=  0.312932E+01
c...  4
      urtn(1, 4)= -0.248646E+01
      urtn(2, 4)=  0.895182E+00
      urtn(3, 4)= -0.650818E+01
c...  5
      urtn(1, 5)= -0.146017E+01
      urtn(2, 5)= -0.138026E+00
      urtn(3, 5)= -0.897058E-01
c...  6
      urtn(1, 6)= -0.470161E+01
      urtn(2, 6)= -0.560633E+00
      urtn(3, 6)=  0.748989E+01
c...  7
      urtn(1, 7)=  0.484989E+01
      urtn(2, 7)=  0.200889E+01
      urtn(3, 7)=  0.312932E+01
c...  8
      urtn(1, 8)= -0.135834E+00
      urtn(2, 8)= -0.112247E+01
      urtn(3, 8)= -0.172127E+01
c...  9
      urtn(1, 9)= -0.498582E+01
      urtn(2, 9)=  0.249671E+01
      urtn(3, 9)=  0.534720E+01
c... 10
      urtn(1,10)= -0.114623E+01
      urtn(2,10)=  0.283702E+01
      urtn(3,10)= -0.797110E+01
c... 11
      urtn(1,11)=  0.219968E+01
      urtn(2,11)= -0.189202E+01
      urtn(3,11)=  0.420587E+01
c... 12
      urtn(1,12)= -0.398994E+00
      urtn(2,12)= -0.201546E+00
      urtn(3,12)= -0.203311E+01
 
c...  apply scaling factors
c     1)change from cm/yr to m/sec
c     2)present day rms plate velocities are 4.4cm/yr,
c     TERRA values are likely to be less. Scale accordingly.
 
      factor1 =  0.3171*1.0e-9
      factor2 =  1.00
 
      do i1=1,3
         do i2=1,20
            urtn(i1,i2) = factor1*factor2*urtn(i1,i2)
         end do
      end do
 
      end
*dk platevelimposed4
      subroutine platevelimposed4
 
c...  Peter: may14th, 1995: This routine applies prespecified rigid
c     rotation vectors for each plate and enforces the rigid plate
c     motions in the surface velocity field. In this sense it is similar
c     to routine "platevel", where rotation vectors are determined
c     self-consistently from the surface velocity field.
 
      include 'size.h'
      include 'pcom.h'
      common /plte/ nplate, urtn(3,20)
      common /subd/ istage, tbegin, totstage, tstage
 
      if(nplate .eq. 0) return
      call nulvec(urtn,60)
 
c...  specify stage21 rotation poles (units are cm/yr)
c...  1
      urtn(1, 1)=  0.863960E+00
      urtn(2, 1)= -0.143787E+01
      urtn(3, 1)=  0.141256E+01
c...  2
      urtn(1, 2)= -0.198520E+01
      urtn(2, 2)=  0.476605E+00
      urtn(3, 2)=  0.163564E+01
c...  3
      urtn(1, 3)= -0.993432E+00
      urtn(2, 3)=  0.145087E+01
      urtn(3, 3)=  0.490951E+00
c...  4
      urtn(1, 4)= -0.335128E+01
      urtn(2, 4)=  0.391000E+01
      urtn(3, 4)= -0.347350E+01
c...  5
      urtn(1, 5)= -0.446409E+01
      urtn(2, 5)=  0.406264E+00
      urtn(3, 5)= -0.318557E+01
c...  6
      urtn(1, 6)= -0.620472E+01
      urtn(2, 6)=  0.280154E+01
      urtn(3, 6)=  0.147336E+02
c...  7
      urtn(1, 7)= -0.247032E+01
      urtn(2, 7)= -0.121555E+01
      urtn(3, 7)= -0.388847E+01
c...  8
      urtn(1, 8)=  0.722111E+01
      urtn(2, 8)=  0.413557E+01
      urtn(3, 8)=  0.404070E+01
c...  9
      urtn(1, 9)= -0.137999E+01
      urtn(2, 9)= -0.108985E+01
      urtn(3, 9)= -0.373689E+01
c... 10
      urtn(1,10)= -0.536279E+01
      urtn(2,10)=  0.681490E+01
      urtn(3,10)=  0.743274E+01
c... 11
      urtn(1,11)= -0.154815E+01
      urtn(2,11)=  0.781873E+01
      urtn(3,11)= -0.169419E+01
c... 12
      urtn(1,12)=  0.196436E+01
      urtn(2,12)= -0.385528E+01
      urtn(3,12)=  0.207309E+01
c... 13
      urtn(1,13)= -0.606360E+00
      urtn(2,13)= -0.581478E+00
      urtn(3,13)= -0.428209E+01
 
c...  apply scaling factors
c     1)change from cm/yr to m/sec
c     2)present day rms plate velocities are 4.4cm/yr,
c     TERRA values are likely to be less. Scale accordingly.
 
      factor1 =  0.3171*1.0e-9
      factor2 =  1.00
 
      do i1=1,3
         do i2=1,20
            urtn(i1,i2) = factor1*factor2*urtn(i1,i2)
         end do
      end do
 
      end
*dk platevelimposed5
      subroutine platevelimposed5
 
c...  Peter: may14th, 1995: This routine applies prespecified rigid
c     rotation vectors for each plate and enforces the rigid plate
c     motions in the surface velocity field. In this sense it is similar
c     to routine "platevel", where rotation vectors are determined
c     self-consistently from the surface velocity field.
 
      include 'size.h'
      include 'pcom.h'
      common /plte/ nplate, urtn(3,20)
      common /subd/ istage, tbegin, totstage, tstage
 
      if(nplate .eq. 0) return
      call nulvec(urtn,60)
 
c...  specify stage21b rotation poles (units are cm/yr)
c...  1
      urtn(1, 1)=  0.625205E+00
      urtn(2, 1)= -0.223923E+01
      urtn(3, 1)=  0.144711E+01
c...  2
      urtn(1, 2)= -0.948498E+00
      urtn(2, 2)=  0.133303E+00
      urtn(3, 2)=  0.522220E+00
c...  3
      urtn(1, 3)=  0.466578E-01
      urtn(2, 3)=  0.111322E+01
      urtn(3, 3)= -0.607480E+00
c...  4
      urtn(1, 4)= -0.229269E+01
      urtn(2, 4)=  0.362667E+01
      urtn(3, 4)= -0.455306E+01
c...  5
      urtn(1, 5)= -0.654734E+00
      urtn(2, 5)= -0.211511E+01
      urtn(3, 5)=  0.104661E+01
c...  6
      urtn(1, 6)= -0.800413E+01
      urtn(2, 6)=  0.407831E+01
      urtn(3, 6)=  0.108589E+02
c...  7
      urtn(1, 7)= -0.132736E+01
      urtn(2, 7)= -0.235568E+01
      urtn(3, 7)= -0.460870E+01
c...  8
      urtn(1, 8)=  0.884010E+01
      urtn(2, 8)= -0.454320E+01
      urtn(3, 8)=  0.703736E+01
c...  9
      urtn(1, 9)= -0.455394E+01
      urtn(2, 9)=  0.972163E+01
      urtn(3, 9)= -0.105261E+01
c... 10
      urtn(1,10)=  0.169323E+01
      urtn(2,10)= -0.302967E+01
      urtn(3,10)= -0.291228E+01
c... 11
      urtn(1,11)= -0.154757E+01
      urtn(2,11)=  0.781581E+01
      urtn(3,11)= -0.170810E+01
c... 12
      urtn(1,12)=  0.483604E+01
      urtn(2,12)= -0.905710E+01
      urtn(3,12)= -0.223864E+01
c... 13
      urtn(1,13)= -0.115267E+01
      urtn(2,13)= -0.126676E+01
      urtn(3,13)= -0.282800E+01
 
c...  apply scaling factors
c     1)change from cm/yr to m/sec
c     2)present day rms plate velocities are 4.4cm/yr,
c     TERRA values are likely to be less. Scale accordingly.
 
      factor1 =  0.3171*1.0e-9
      factor2 =  1.00
 
      do i1=1,3
         do i2=1,20
            urtn(i1,i2) = factor1*factor2*urtn(i1,i2)
         end do
      end do
 
      end
*dk platevelimposed6
      subroutine platevelimposed6
 
c...  Peter: may14th, 1995: This routine applies prespecified rigid
c     rotation vectors for each plate and enforces the rigid plate
c     motions in the surface velocity field. In this sense it is similar
c     to routine "platevel", where rotation vectors are determined
c     self-consistently from the surface velocity field.
 
      include 'size.h'
      include 'pcom.h'
      common /plte/ nplate, urtn(3,20)
      common /subd/ istage, tbegin, totstage, tstage
 
      if(nplate .eq. 0) return
      call nulvec(urtn,60)
 
c...  specify stage27 rotation poles (units are cm/yr)
c...  1
      urtn(1, 1)=  0.395657E+00
      urtn(2, 1)= -0.304640E+01
      urtn(3, 1)=  0.147185E+01
c...  2
      urtn(1, 2)= -0.858490E+00
      urtn(2, 2)= -0.431775E+00
      urtn(3, 2)=  0.190274E+00
c...  3
      urtn(1, 3)=  0.136542E+00
      urtn(2, 3)=  0.551741E+00
      urtn(3, 3)= -0.931165E+00
c...  4
      urtn(1, 4)= -0.561863E+01
      urtn(2, 4)=  0.580628E+00
      urtn(3, 4)= -0.133720E+02
c...  5
      urtn(1, 5)=  0.155151E+01
      urtn(2, 5)= -0.391867E+01
      urtn(3, 5)=  0.178033E+01
c...  6
      urtn(1, 6)= -0.495606E+01
      urtn(2, 6)=  0.960218E+01
      urtn(3, 6)=  0.527032E+01
c...  7
      urtn(1, 7)=  0.926540E+01
      urtn(2, 7)= -0.705834E+01
      urtn(3, 7)=  0.744898E+01
c...  8
      urtn(1, 8)= -0.585064E+01
      urtn(2, 8)=  0.103410E+02
      urtn(3, 8)= -0.122781E+01
c...  9
      urtn(1, 9)= -0.482810E+01
      urtn(2, 9)=  0.679380E+01
      urtn(3, 9)= -0.514758E+01
c... 10
      urtn(1,10)=  0.695611E+00
      urtn(2,10)= -0.341904E+01
      urtn(3,10)= -0.183181E+01
c... 11
      urtn(1,11)= -0.154757E+01
      urtn(2,11)=  0.781581E+01
      urtn(3,11)= -0.170810E+01
c... 12
      urtn(1,12)=  0.561360E+01
      urtn(2,12)= -0.115096E+02
      urtn(3,12)= -0.384186E+01
c... 13
      urtn(1,13)= -0.155951E+01
      urtn(2,13)= -0.202507E+01
      urtn(3,13)= -0.228530E+01
 
c...  apply scaling factors
c     1)change from cm/yr to m/sec
c     2)present day rms plate velocities are 4.4cm/yr,
c     TERRA values are likely to be less. Scale accordingly.
 
      factor1 =  0.3171*1.0e-9
      factor2 =  1.00
 
      do i1=1,3
         do i2=1,20
            urtn(i1,i2) = factor1*factor2*urtn(i1,i2)
         end do
      end do
 
      end
*dk platevelimposed7
      subroutine platevelimposed7
 
c...  Peter: may14th, 1995: This routine applies prespecified rigid
c     rotation vectors for each plate and enforces the rigid plate
c     motions in the surface velocity field. In this sense it is similar
c     to routine "platevel", where rotation vectors are determined
c     self-consistently from the surface velocity field.
 
      include 'size.h'
      include 'pcom.h'
      common /plte/ nplate, urtn(3,20)
      common /subd/ istage, tbegin, totstage, tstage
 
      if(nplate .eq. 0) return
      call nulvec(urtn,60)
 
c...  specify stage74 rotation poles (units are cm/yr)
c...  1
      urtn(1, 1)=  0.993497E+00
      urtn(2, 1)= -0.306331E+01
      urtn(3, 1)=  0.125428E+01
c...  2
      urtn(1, 2)= -0.301170E+00
      urtn(2, 2)= -0.735754E+00
      urtn(3, 2)=  0.172237E+01
c...  3
      urtn(1, 3)=  0.189438E+00
      urtn(2, 3)= -0.606580E-01
      urtn(3, 3)=  0.388025E+00
c...  4
      urtn(1, 4)= -0.987924E+00
      urtn(2, 4)= -0.321369E+01
      urtn(3, 4)= -0.120216E+01
c...  5
      urtn(1, 5)= -0.150427E-01
      urtn(2, 5)= -0.301344E+01
      urtn(3, 5)=  0.405938E+00
c...  6
      urtn(1, 6)= -0.328937E+01
      urtn(2, 6)=  0.857492E+01
      urtn(3, 6)=  0.417328E+01
c...  7
      urtn(1, 7)=  0.107658E+02
      urtn(2, 7)= -0.236464E+01
      urtn(3, 7)=  0.367136E+01
c...  8
      urtn(1, 8)= -0.107534E+02
      urtn(2, 8)=  0.106674E+02
      urtn(3, 8)=  0.660004E+00
c...  9
      urtn(1, 9)= -0.924523E+00
      urtn(2, 9)= -0.265681E+01
      urtn(3, 9)= -0.310882E+01
c... 10
      urtn(1,10)=  0.125557E+00
      urtn(2,10)=  0.652725E+01
      urtn(3,10)= -0.262310E+01
c... 11
      urtn(1,11)=  0.578591E+01
      urtn(2,11)= -0.114096E+02
      urtn(3,11)= -0.388430E+01
c... 12
      urtn(1,12)= -0.134235E+01
      urtn(2,12)= -0.191175E+01
      urtn(3,12)= -0.284901E+01
 
c...  apply scaling factors
c     1)change from cm/yr to m/sec
c     2)present day rms plate velocities are 4.4cm/yr,
c     TERRA values are likely to be less. Scale accordingly.
 
      factor1 =  0.3171*1.0e-9
      factor2 =  1.00
 
      do i1=1,3
         do i2=1,20
            urtn(i1,i2) = factor1*factor2*urtn(i1,i2)
         end do
      end do
 
      end
*dk platevelimposed8
      subroutine platevelimposed8
 
c...  Peter: may14th, 1995: This routine applies prespecified rigid
c     rotation vectors for each plate and enforces the rigid plate
c     motions in the surface velocity field. In this sense it is similar
c     to routine "platevel", where rotation vectors are determined
c     self-consistently from the surface velocity field.
 
      include 'size.h'
      include 'pcom.h'
      common /plte/ nplate, urtn(3,20)
      common /subd/ istage, tbegin, totstage, tstage
 
      if(nplate .eq. 0) return
      call nulvec(urtn,60)
 
c...  specify stage84 rotation poles (units are cm/yr)
c...  1
      urtn(1, 1)=  0.993497E+00
      urtn(2, 1)= -0.306331E+01
      urtn(3, 1)=  0.125428E+01
c...  2
      urtn(1, 2)= -0.173919E+01
      urtn(2, 2)=  0.381557E+00
      urtn(3, 2)=  0.393450E+01
c...  3
      urtn(1, 3)= -0.108901E+01
      urtn(2, 3)=  0.124845E+01
      urtn(3, 3)=  0.258182E+01
c...  4
      urtn(1, 4)= -0.227060E+01
      urtn(2, 4)= -0.217689E+01
      urtn(3, 4)= -0.456531E+00
c...  5
      urtn(1, 5)= -0.826069E+01
      urtn(2, 5)=  0.765056E+01
      urtn(3, 5)= -0.174443E+01
c...  6
      urtn(1, 6)=  0.128612E+02
      urtn(2, 6)= -0.110888E+00
      urtn(3, 6)=  0.198397E+01
c...  7
      urtn(1, 7)= -0.222857E+01
      urtn(2, 7)=  0.124532E+02
      urtn(3, 7)= -0.690386E+01
c...  8
      urtn(1, 8)= -0.330661E+01
      urtn(2, 8)= -0.178266E+01
      urtn(3, 8)= -0.378853E+01
c...  9
      urtn(1, 9)= -0.332103E+01
      urtn(2, 9)=  0.608767E+01
      urtn(3, 9)= -0.757206E+01
c... 10
      urtn(1,10)=  0.561360E+01
      urtn(2,10)= -0.115096E+02
      urtn(3,10)= -0.384186E+01
c... 11
      urtn(1,11)= -0.249994E+01
      urtn(2,11)= -0.142397E+01
      urtn(3,11)= -0.352158E+01
 
c...  apply scaling factors
c     1)change from cm/yr to m/sec
c     2)present day rms plate velocities are 4.4cm/yr,
c     TERRA values are likely to be less. Scale accordingly.
 
      factor1 =  0.3171*1.0e-9
      factor2 =  1.00
 
      do i1=1,3
         do i2=1,20
            urtn(i1,i2) = factor1*factor2*urtn(i1,i2)
         end do
      end do
 
      end
*dk platevelimposed9
      subroutine platevelimposed9
 
c...  Peter: may14th, 1995: This routine applies prespecified rigid
c     rotation vectors for each plate and enforces the rigid plate
c     motions in the surface velocity field. In this sense it is similar
c     to routine "platevel", where rotation vectors are determined
c     self-consistently from the surface velocity field.
 
      include 'size.h'
      include 'pcom.h'
      common /plte/ nplate, urtn(3,20)
      common /subd/ istage, tbegin, totstage, tstage
 
      if(nplate .eq. 0) return
      call nulvec(urtn,60)
 
c...  specify stage94 rotation poles (units are cm/yr)
c...  1
      urtn(1, 1)=  0.319453E+01
      urtn(2, 1)= -0.191196E+01
      urtn(3, 1)=  0.157341E+00
c...  2
      urtn(1, 2)= -0.272916E+01
      urtn(2, 2)=  0.240244E+01
      urtn(3, 2)=  0.118462E+01
c...  3
      urtn(1, 3)= -0.150423E+01
      urtn(2, 3)=  0.360746E+01
      urtn(3, 3)= -0.672728E+00
c...  4
      urtn(1, 4)= -0.214064E+01
      urtn(2, 4)= -0.173532E+01
      urtn(3, 4)= -0.328360E+01
c...  5
      urtn(1, 5)= -0.119535E+02
      urtn(2, 5)=  0.698535E+01
      urtn(3, 5)=  0.277579E+01
c...  6
      urtn(1, 6)=  0.325203E+01
      urtn(2, 6)=  0.563476E+00
      urtn(3, 6)=  0.292586E+00
c...  7
      urtn(1, 7)=  0.734321E+01
      urtn(2, 7)=  0.174322E+02
      urtn(3, 7)= -0.998915E+01
c...  8
      urtn(1, 8)= -0.279225E+01
      urtn(2, 8)= -0.142580E+01
      urtn(3, 8)= -0.517828E+01
c...  9
      urtn(1, 9)= -0.332103E+01
      urtn(2, 9)=  0.608767E+01
      urtn(3, 9)= -0.757206E+01
c... 10
      urtn(1,10)=  0.794117E+00
      urtn(2,10)= -0.360436E+01
      urtn(3,10)= -0.457439E+01
c... 11
      urtn(1,11)= -0.313384E+01
      urtn(2,11)=  0.872509E+00
      urtn(3,11)= -0.159168E+01
 
c...  apply scaling factors
c     1)change from cm/yr to m/sec
c     2)present day rms plate velocities are 4.4cm/yr,
c     TERRA values are likely to be less. Scale accordingly.
 
      factor1 =  0.3171*1.0e-9
      factor2 =  1.00
 
      do i1=1,3
         do i2=1,20
            urtn(i1,i2) = factor1*factor2*urtn(i1,i2)
         end do
      end do
 
      end
*dk platevelimposed10
      subroutine platevelimposed10
 
c...  Peter: may14th, 1995: This routine applies prespecified rigid
c     rotation vectors for each plate and enforces the rigid plate
c     motions in the surface velocity field. In this sense it is similar
c     to routine "platevel", where rotation vectors are determined
c     self-consistently from the surface velocity field.
 
      include 'size.h'
      include 'pcom.h'
      common /plte/ nplate, urtn(3,20)
      common /subd/ istage, tbegin, totstage, tstage
 
      if(nplate .eq. 0) return
      call nulvec(urtn,60)
 
c...  specify stage100 rotation poles (units are cm/yr)
c...  1
      urtn(1, 1)=  0.319453E+01
      urtn(2, 1)= -0.191196E+01
      urtn(3, 1)=  0.157341E+00
c...  2
      urtn(1, 2)= -0.272916E+01
      urtn(2, 2)=  0.240244E+01
      urtn(3, 2)=  0.118462E+01
c...  3
      urtn(1, 3)= -0.269373E+01
      urtn(2, 3)= -0.170396E+01
      urtn(3, 3)= -0.312441E+01
c...  4
      urtn(1, 4)= -0.123927E+02
      urtn(2, 4)=  0.687448E+01
      urtn(3, 4)=  0.324680E+01
c...  5
      urtn(1, 5)=  0.325203E+01
      urtn(2, 5)=  0.563476E+00
      urtn(3, 5)=  0.292586E+00
c...  6
      urtn(1, 6)=  0.749607E+01
      urtn(2, 6)=  0.177950E+02
      urtn(3, 6)= -0.101971E+02
c...  7
      urtn(1, 7)= -0.349116E+01
      urtn(2, 7)= -0.139771E+01
      urtn(3, 7)= -0.514266E+01
c...  8
      urtn(1, 8)= -0.332103E+01
      urtn(2, 8)=  0.608767E+01
      urtn(3, 8)= -0.757206E+01
c...  9
      urtn(1, 9)=  0.128226E+01
      urtn(2, 9)= -0.465490E+01
      urtn(3, 9)= -0.424115E+01
c... 10
      urtn(1,10)= -0.313384E+01
      urtn(2,10)=  0.872509E+00
      urtn(3,10)= -0.159168E+01
 
c...  apply scaling factors
c     1)change from cm/yr to m/sec
c     2)present day rms plate velocities are 4.4cm/yr,
c     TERRA values are likely to be less. Scale accordingly.
 
      factor1 =  0.3171*1.0e-9
      factor2 =  1.00
 
      do i1=1,3
         do i2=1,20
            urtn(i1,i2) = factor1*factor2*urtn(i1,i2)
         end do
      end do
 
      end
*dk platevelimposed11
      subroutine platevelimposed11
 
c...  Peter: may14th, 1995: This routine applies prespecified rigid
c     rotation vectors for each plate and enforces the rigid plate
c     motions in the surface velocity field. In this sense it is similar
c     to routine "platevel", where rotation vectors are determined
c     self-consistently from the surface velocity field.
 
      include 'size.h'
      include 'pcom.h'
      common /plte/ nplate, urtn(3,20)
      common /subd/ istage, tbegin, totstage, tstage
 
      if(nplate .eq. 0) return
      call nulvec(urtn,60)
 
c...  specify stage119 rotation poles (units are cm/yr)
c...  1
      urtn(1, 1)=  0.305433E+01
      urtn(2, 1)= -0.186854E+01
      urtn(3, 1)=  0.147691E+00
c...  2
      urtn(1, 2)= -0.286650E+01
      urtn(2, 2)=  0.244926E+01
      urtn(3, 2)=  0.117745E+01
c...  3
      urtn(1, 3)= -0.317187E+01
      urtn(2, 3)= -0.149548E+01
      urtn(3, 3)= -0.444142E+01
c...  4
      urtn(1, 4)= -0.796990E+01
      urtn(2, 4)= -0.109939E+01
      urtn(3, 4)=  0.478516E+01
c...  5
      urtn(1, 5)=  0.311231E+01
      urtn(2, 5)=  0.607057E+00
      urtn(3, 5)=  0.276140E+00
c...  6
      urtn(1, 6)=  0.967691E+01
      urtn(2, 6)=  0.133514E+02
      urtn(3, 6)= -0.776429E+01
c...  7
      urtn(1, 7)= -0.340089E+01
      urtn(2, 7)= -0.140744E+01
      urtn(3, 7)= -0.497316E+01
c...  8
      urtn(1, 8)=  0.553061E+00
      urtn(2, 8)= -0.118604E+01
      urtn(3, 8)= -0.625327E+01
c...  9
      urtn(1, 9)=  0.811836E+01
      urtn(2, 9)= -0.101679E+02
      urtn(3, 9)= -0.202262E+01
c... 10
      urtn(1,10)= -0.310343E+01
      urtn(2,10)=  0.828429E+00
      urtn(3,10)= -0.151390E+01
 
c...  apply scaling factors
c     1)change from cm/yr to m/sec
c     2)present day rms plate velocities are 4.4cm/yr,
c     TERRA values are likely to be less. Scale accordingly.
 
      factor1 =  0.3171*1.0e-9
      factor2 =  1.00
 
      do i1=1,3
         do i2=1,20
            urtn(i1,i2) = factor1*factor2*urtn(i1,i2)
         end do
      end do
 
      end
