*DK renderfile
      program renderfile
 
c     This routine generates an output file readable by the graphics
c     program terra_render.
 
      include 'size.h'
      parameter (nn=(mt+1)**2*10)
 
      common /flds/ v(nn*(nr+1)*3), s(nn,(nr+1)), w(nn*(nr+1),3),
     &              pmap(nn*2)
      common /radl/ rshl(nr+1), ird, ibc
      common /prty/ propr(20)
      include 'pcom.h'
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
      common /eos1/ rhorf(129), tmprf(129), drhdp(129), grv(129)
      character cname*4, fname*12
      character char1*1, char2*1, char3*1, char4*1, char5*1, char6*1
      character*8 titl(4,4)
 
      open ( 5, file='inplot'  , status='old')
 
      read (5,10) cname, ispec, iclr, iscl, isctn, ieqar,
     &            ipole, nequa, nskp, irmax, imap, idbeg, idend
 10   format(a4/i2/i2/i2/i2/i2/i2/i2/i2/i2/i2/i2/i2)
 
      write(6,20) cname, ispec, iclr, iscl, isctn, ieqar,
     &            ipole, nequa, nskp, irmax, imap, idbeg, idend
 20   format('cname = ',a4/'ispec = ',i2/'iclr  = ',i2/'iscl  = ',i2/
     &       'isctn = ',i2/'ieqar = ',i2/'ipole = ',i2/'nequa = ',i2/
     &       'nskp  = ',i2/'irmax = ',i2/'imap  = ',i2/'idbeg = ',i2/
     &       'idend = ',i2)
 
      nproc = (mt/nt)**2*10/nd
 
      do 50 idump=idbeg,idend
 
      char5 = char(48 + idump/10)
      char6 = char(48 + mod(idump,10))
 
      do 40 iproc=0,nproc-1
 
      char1 = char(48 + iproc/1000)
      char2 = char(48 + mod(iproc/100,10))
      char3 = char(48 + mod(iproc/10,10))
      char4 = char(48 + mod(iproc,10))
      fname = cname//'.'//char1//char2//char3//char4//'.'//char5//char6
 
      open (8, file=fname, status='unknown')
 
c...  Read in geoid field.
 
      call vecin(w,titl,rshl,1, 0,8,0)
      if(ispec/2 .eq. 6) then
         call collect(s,w,iproc,1)
         if(mod(ispec, 2) .eq. 0) go to 30
      end if
 
c...  Read in topography field.
 
      call vecin(w,titl,rshl,1, 1,8,0)
      if(ispec/2 .eq. 7) then
         call collect(s,w,iproc,2)
         if(mod(ispec, 2) .eq. 0) go to 30
      end if
 
c...  If there are lithospheric plates, read in plate map field.
 
      nplate = propr(20)
      if(nplate .gt. 0) call vecin(w,titl,rshl,1, 1,8,1)
      if(ispec/2 .eq. 4) then
         mname = 'terra   '
         call collect(pmap,w,iproc,2)
      endif
 
c...  Read in temperature field.
 
      call vecin(w,titl,rshl,1,nr,8,1)
      if(ispec/2.eq.1 .or. ispec/2.eq.4) then
         call collect(s,w,iproc,nr+1)
         if(mod(ispec, 2) .eq. 0) go to 30
      end if
 
c...  Read in velocity field.
 
      call vecin(w,titl,rshl,3,-1,8,0)
      if(mod(ispec, 2) .eq. 1) then
         call collect(v,w,iproc,3*(nr+1))
         if(ispec/2.eq.1 .or. ispec/2.eq.4 .or.
     &      ispec/2.eq.6 .or. ispec/2.eq.7) go to 30
      end if
 
c...  If there is variable viscosity, read in viscosity field.
 
      vscmax  = propr(18)
      tvscscl = propr(19)
      if(vscmax.gt.0. .and. tvscscl.gt.0.)
     &   call vecin(w,titl,rshl,1,nr,8,0)
      if(ispec/2 .eq. 3) then
         call collect(s,w,iproc,nr+1)
         go to 30
      end if
 
c...  If EOS is compressible, read in shear heating field.
 
      ieos = propr(6)
      if(ieos .ge. 10) call vecin(w,titl,rshl,1,nr,8,0)
      if(ispec/2 .eq. 9) then
         call collect(s,w,iproc,nr+1)
         go to 30
      end if
 
c...  Read in strain rate field.
 
      call vecin(w,titl,rshl,1,nr,8,0)
      if(ispec/2 .eq. 2) call collect(s,w,iproc,nr+1)
 
 30   close (8)
 
 40   continue
 
      open ( 8, file=cname//'.render.'//char4//char5, status='unknown')
 
      if(ispec/2 .eq. 1) then
         call eosset
         do ir=1,nr+1
            adb = max(0., tmprf(ir) - 1900.)
            do ii=1,nn
               s(ii,ir) = max(800., min(2300., s(ii,ir) - adb))
            end do
         end do
      elseif(ispec/2 .eq. 3) then
         do ir=1,nr+1
            do ii=1,nn
               s(ii,ir) = max(20.4, min(22.8, s(ii,ir)))
            end do
         end do
      end if
 
      call vecoutform(s,1,nr,mt,8)
 
 50   continue
 
      stop
      end
*dk nulavg
      subroutine nulavg(v,nr,mt)
 
c     This routine, for each radial layer of nodes, subtracts the
c     average value of the nodal scalar field v at that radius.
 
      real v(0:mt,mt+1,10,nr+1)
 
      do ir=1,nr+1
 
         sum = v(0,1,1,ir) + v(0,1,6,ir)
 
         do id=1,10
            do i2=1,mt
               do i1=1,mt
                  sum = sum + v(i1,i2,id,ir)
               end do
            end do
         end do
 
         sum = sum/(10*mt*mt+2)
 
         do id=1,10
            do i2=0,mt
               do i1=1,mt+1
                  v(i1,i2,id,ir) = v(i1,i2,id,ir) - sum
               end do
            end do
         end do
 
      end do
 
      end
*dk vecoutform
      subroutine vecoutform(u,nj,mr,mt,nf)
 
c...  This routine writes the nodal field u to logical unit nf.
 
      real u((mt+1)**2,10,nj,(mr+1))
 
      write(nf,15) mr, mt
 
      do ir=1,mr+1
         do id=1,10
            do ij=1,nj
               do ii=1,(mt+1)**2,8
                  write(nf,25) u(ii  ,id,ij,ir), u(ii+1,id,ij,ir),
     &                         u(ii+2,id,ij,ir), u(ii+3,id,ij,ir),
     &                         u(ii+4,id,ij,ir), u(ii+5,id,ij,ir),
     &                         u(ii+6,id,ij,ir), u(ii+7,id,ij,ir)
               end do
            end do
         end do
      end do
 
 15   format(2(i5))
 25   format(8(e10.4,3x))
 
      end
*dk eosset
      subroutine eosset
 
c     This routine initializes the equation of state parameters.
 
      include 'size.h'
      common /oper/ ra(3,8,nr+1)
      common /radl/ rshl(nr+1), ird, ibc
 
      call rshlgen
 
      call rgen
 
      call morse(rshl,ra)
 
      end
*dk morse
      subroutine morse(rshl,ra)
 
      include 'size.h'
      real ra(3,8,*), rshl(*), c1(129), c2(129), c3(129)
      common /eos1/ rhorf(129), tmprf(129), drhdp(129), grv(129)
      common /eos2/ rhocv(129), gamma(129), alpha(129), prf(129),
     &               cond(129)
      common /prop/ ieos,  rho0, visc,  grav,  texpn, tcond,
     &              sheat, hgen, tb(2), cl410, cl660
      common /grad/ rg(3,2,nr+1)
      include 'pcom.h'
      common /mors/ rhor(4), bmod(4), dbmd(4), cvmor, gammor
      common /refr/ pi, gc, corems, nslc
 
      lc     = 0
      lm     = 0
      c4     = -1./3.
      tmorse = 1900.
 
      do 10 ir=1,nr+1
      depth = rshl(1) - rshl(ir)
      if(depth .lt. 410.e3) then
         jr = 1
      elseif(depth .lt. 510.e3) then
         jr = 2
      elseif(depth .lt. 660.e3) then
         jr = 3
      else
         jr = 4
      endif
      if(depth.ge. 660.e3 .and. lm.eq.0) lm = ir
      if(depth.ge.2100.e3 .and. lc.eq.0) lc = ir
      c1(ir)    = 3.*bmod(jr)/(dbmd(jr)-1.)
      c2(ir)    = 1./rhor(jr)
      c3(ir)    = dbmd(jr) - 1.
      alpha(ir) = 2.40e-5
      tmprf(ir) = tmorse + 0.3e-3*depth
      if(depth.le.450.e3)
     &   tmprf(ir) = 300. + 2000.*exp(-65.e3/(depth + 1.e3))
c     if(depth.gt.2700.e3)
c    &   tmprf(ir) = 2600. + 600.*(1. - exp(-60.e3/(2891.e3 - depth)))
      rhorf(ir) = rhor(jr)*(1. - alpha(ir)*tmprf(ir))
      q         = c2(ir)*rhorf(ir)
      r         = q**c4
      e         = exp(c3(ir)*(1. - r))
      bm        = c1(ir)*r*q*e*(2.*(e - 1.) + c3(ir)*r*(2.*e - 1.))/3.
      drhdp(ir) = rhorf(ir)/bm
      rhocv(ir) = rhorf(ir)*cvmor
      alpha(ir) = gammor*rhocv(ir)/bm
      if(jr.eq.4) alpha(ir) = alpha(lm)*(rhorf(lm)/rhorf(ir))**4
      if(jr.eq.4) rhocv(ir) = rhocv(lm)*(rhorf(lm)/rhorf(ir))**0.1
      gamma(ir) = alpha(ir)*bm/rhocv(ir)
 10   continue
      cond(1)   = tcond
      prf(1)    = 0.
      grv(nr+1) = gc*corems/rshl(nr+1)**2
 
      pb = 0.
      k  = 0
 20   k  = k + 1
      am = corems
      do 30 ir=nr,1,-1
      rt = rshl(ir)
      rb = rshl(ir+1)
      r3 = rt**3 - rb**3
      r4 = rt**4 - rb**4
      qt = (3.*r4 - 4.*rb*r3)/(12.*(rt - rb))
      qb = (3.*r4 - 4.*rt*r3)/(12.*(rb - rt))
      am = am + 4.*pi*(qt*rhorf(ir) + qb*rhorf(ir+1))
      grv(ir) = gc*am/rt**2
 30   continue
 
      do 65 it=1,3
      do 60 ir=3,nr
      if(rshl(1) - rshl(ir) .lt.  450.e3) go to 60
      if(rshl(1) - rshl(ir) .gt. 2700.e3) go to 60
      dx  = 1./nslc
      dr  = (rshl(ir-1) - rshl(ir))*dx
      do 50 l=1,10
      tmp = tmprf(ir-1)
      x   = -0.5*dx
      do 40 i=1,nslc
      x   = x + dx
      omx = 1. - x
      tx  = x*tmprf(ir-1) + omx*tmprf(ir)
      ax  = x*alpha(ir-1) + omx*alpha(ir)
      gmx = x*gamma(ir-1) + omx*gamma(ir)
      rcx = x*rhocv(ir-1) + omx*rhocv(ir)
      rx  = x*rhorf(ir-1) + omx*rhorf(ir)
      gvx = x*  grv(ir-1) + omx*  grv(ir)
      tmp = tmp + dr*ax*gvx*tx*rx/(rcx*(1. + ax*gmx*tx))
 40   continue
      tmprf(ir) = tmp
 50   continue
 60   continue
 65   continue
 
      prf(1) =  0.
      prf(2) = -(ra(2,7,1)*rhorf(1)*grv(1)
     &         + ra(3,7,1)*rhorf(2)*grv(2))/rg(3,2,1)
      do 70 ir=2,nr
      prf(ir+1) = -(ra(1,7,ir)*rhorf(ir-1)*grv(ir-1)
     &            + ra(2,7,ir)*rhorf(ir  )*grv(ir  )
     &            + ra(3,7,ir)*rhorf(ir+1)*grv(ir+1)
     &            + rg(1,2,ir)*prf(ir-1) + rg(2,2,ir)*prf(ir))
     &             /rg(3,2,ir)
 70   continue
 
      if(abs(prf(nr+1) - pb) .lt. 0.00001*prf(nr+1)) go to 100
 
      pb = prf(nr+1)
 
      if(k.gt.10) then
         if(mynum .eq. 0) write(6,75)
 75      format(" *****reference pressure calculation",
     &          " did not converge")
         stop
      endif
 
      do 90 ir=2,nr+1
 
      rho1 = rhorf(ir)
      j  = 0
 
 80   j  = j + 1
 
      q  = c2(ir)*rho1
      r  = q**c4
      e  = exp(c3(ir)*(1. - r))
      pz = c1(ir)*q*r*e*(e - 1.)
      bm = c1(ir)*r*q*e*(2.*(e - 1.) + c3(ir)*r*(2.*e - 1.))/3.
      drhdp(ir) = rho1/bm
      rhocv(ir) = rho1*cvmor
      alpha(ir) = gammor*rhocv(ir)/bm
      if(ir.gt.lm) alpha(ir) = alpha(lm)*(rhorf(lm)/rho1)**4
      if(ir.gt.lm) rhocv(ir) = rhocv(lm)*(rhorf(lm)/rho1)**0.1
      gamma(ir) = alpha(ir)*bm/rhocv(ir)
      cond(ir)  = tcond
      if(ir.ge.lc) cond(ir) = tcond*(tmprf(ir)/tmprf(lc))**4
      pt   = bm*alpha(ir)*tmprf(ir)
      rho2 = rho1*(1. + (prf(ir) - pz - pt)/bm)
 
      if(abs(rho2 - rho1) .gt. 0.00001*rho2) then
         rho1 = rho2
         if(j.lt.50) go to 80
         if(mynum .eq. 0) write(6,85) ir
 85      format(" ***reference density calculation did not converge",
     &          " for ir =",i4)
         stop
      else
         rhorf(ir) = rho2
      endif
 
 90   continue
 
      go to 20
 
 100  continue
 
      rho0 = 0.75*(am - corems)/(pi*(rshl(1)**3 - rshl(nr+1)**3))
 
      if(mynum .eq. 0) write(6,120) rho0
 120  format(/' The mean mantle density is ',1pe11.4,' kg/m**3.'/)
 
      if(mynum .eq. 0) write(6,200)
 200  format('     radius     density   temperature   pressure',
     &       '    gravity')
      do 220 ir=1,nr+1
      if(mynum .eq. 0) write(6,210) rshl(ir), rhorf(ir), tmprf(ir),
     &                              prf(ir), grv(ir)
 210  format(1p5e12.4)
 220  continue
 
      if(mynum .eq. 0) write(6,230)
 230  format(/'     radius      alpha        cv        drho/dp ',
     &        '     gamma')
      do 250 ir=1,nr+1
      cv = rhocv(ir)/rhorf(ir)
      if(mynum .eq. 0) write(6,240)  rshl(ir), alpha(ir), cv,
     &                              drhdp(ir), gamma(ir)
 240  format(1p5e12.4)
 250  continue
 
      end
*dk rflayr
      subroutine rflayr(rf,rt,rb,nr)
 
c...  This routine generates the radial factors needed to assemble the
c...  3-D node-to-node operators for the shell between radii rb and rt.
 
      real rf(3,9)
 
      d2 = 1./(rt - rb)**2
      r1 = d2*(rt    - rb)
      r2 = d2*(rt**2 - rb**2)/2.
      r3 = d2*(rt**3 - rb**3)/3.
      r4 = d2*(rt**4 - rb**4)/4.
      r5 = d2*(rt**5 - rb**5)/5.
 
      call nulvec(rf,24)
 
      rf(1,1) = -r3 + (rb+rb)*r2 - rb*rb*r1
      rf(2,1) =  r3 - (rt+rb)*r2 + rt*rb*r1
      rf(3,1) = -r3 + (rt+rt)*r2 - rt*rt*r1
      rf(1,2) = -r3 + rb*r2
      rf(2,2) =  r3 - rb*r2
      rf(3,2) = -r3 + rt*r2
      rf(1,3) = -r3 + rb*r2
      rf(2,3) =  r3 - rt*r2
      rf(3,3) = -r3 + rt*r2
      rf(1,4) = -r3
      rf(2,4) =  r3
      rf(3,4) = -r3
      rf(1,5) = -r3 + (rb+rb)*r2 - rb*rb*r1
      rf(2,5) =  r3 - (rt+rb)*r2 + rt*rb*r1
      rf(3,5) = -r3 + (rt+rt)*r2 - rt*rt*r1
      rf(1,6) = -r3
      rf(2,6) =  r3
      rf(3,6) = -r3
      rf(1,7) =  r5 - (rb+rb)*r4 + rb*rb*r3
      rf(2,7) = -r5 + (rt+rb)*r4 - rt*rb*r3
      rf(3,7) =  r5 - (rt+rt)*r4 + rt*rt*r3
      rf(1,8) =  r4 - (rb+rb)*r3 + rb*rb*r2
      rf(2,8) = -r4 + (rt+rb)*r3 - rt*rb*r2
      rf(3,8) =  r4 - (rt+rt)*r3 + rt*rt*r2
      rf(1,9) =  r4 - rb*r3
      rf(2,9) = -rf(1,9)
      rf(3,9) =  r4 - rt*r3
 
      end
*dk rgen
      subroutine rgen
 
c...  This routine generates the radial factors needed
c...  to assemble the finite-element operators.
 
      include 'size.h'
      common /radl/ rshl(nr+1), ird, ibc
      common /oper/ ra(3,8,nr+1), alp(7,(nt+1)**2,2),
     &              atn(4,7,(nt+1)**2,9)
      common /grad/ rg(3,2,nr+1), grd(7,(nt+1)**2,3,2)
      real rfu(3,9), rfl(3,9)
 
      call nulvec(rfu, 27)
 
      do ir=1,nr+1
 
         if(ir .le. nr) then
            rtop = rshl(ir)
            rbot = rshl(ir+1)
            call rflayr(rfl,rtop,rbot,nr)
         endif
 
         qu = 1.0
         ql = 1.0
         if(ir .eq. 1)    qu = 0.0
         if(ir .eq. nr+1) ql = 0.0
 
         do m=1,7
            ra(1,m,ir) = qu*rfu(2,m)
            ra(2,m,ir) = qu*rfu(3,m) + ql*rfl(1,m)
            ra(3,m,ir) = ql*rfl(2,m)
            if((ir.eq.1 .or. ir.eq.nr+1)
     &         .and. (m.ge.2 .and. m.le.3)) ra(2,m,ir) = 0.
         end do
 
         rg(1,1,ir) = qu*rfu(2,8)
         rg(2,1,ir) = qu*rfu(3,8) + ql*rfl(1,8)
         rg(3,1,ir) = ql*rfl(2,8)
         rg(1,2,ir) = qu*rfu(2,9)
         rg(2,2,ir) = qu*rfu(3,9) + ql*rfl(1,9)
         rg(3,2,ir) = ql*rfl(2,9)
 
         do j=1,3
            do i=1,9
            rfu(j,i) =  rfl(j,i)
            end do
         end do
 
         rfu(2,2) = -rfu(3,2)
         rfu(2,3) = -rfu(1,3)
         rfu(2,9) = -rfu(3,9)
 
      end do
 
      end
*dk rshlgen
      subroutine rshlgen
 
c...  This routine generates the nodal radial locations for the grid
c...  type specified by parameter ird for all grids with N .le. nr.
 
      include 'size.h'
      common /radl/ rshl(nr+1), ird, ibc
      common /dpth/ dep(128,4)
 
      pi   = 3.141592653589793
      lvr  = 1.45*log(real(nr))
      rmax = rshl(1)
      rmin = rshl(nr+1)
 
      do ir=2,nr
 
         fr = real(nr+1-ir)/real(nr)
 
         if(ird .eq. 1) then
            rshl(ir) = rmin + (rmax - rmin)*fr
         elseif(ird .le. 4) then
            aa    = 0.3 + 0.20*(ird - 2)
            rshl(ir) = (1. - aa)*(rmin + (rmax - rmin)*fr)
     &            + aa*(rmax + rmin - (rmax - rmin)*cos(pi*fr))*0.5
         else
            rshl(ir) = rshl(ir-1) - dep(ir-1,lvr-3)*1.e3
         endif
 
      end do
 
      end
      block data bdcvinit
 
      common /mors/ rhor(4), bmod(4), dbmd(4), cvmor, gammor
      data rhor/  3425.,   3695.,   3725.,   4220./
      data bmod/1.40e11, 1.60e11, 1.60e11, 2.60e11/
      data dbmd/   5.00,    4.00,    4.00,    3.85/
      data cvmor/1371./, gammor/1.05/
 
      common /refr/ pi, gc, corems, nslc
      data pi/3.141592653589793/, gc/6.6732e-11/, corems/1.938e24/
      data nslc/50/
 
      end
