*DK sphplt
      program splot
 
c     This routine generates plots of vector and/or scalar fields for
c     a spherical shell.  Required libraries are CLAMS, CGSCFT, and
c     CGSHIGH.  If outlines of the continents are to be requested,
c     files CMAP and MAPDAT must be in the local file space.
 
      include 'size.h'
      parameter (nn=(mt+1)**2*10)
 
      common /flds/ v(nn*(nr+1)*3), s(nn*(nr+1)), w(nn*(nr+1),3),
     &              pmap(nn*2)
      common /mesh/ xn((mt+1)**2,10,3)
      common /radl/ rshl(nr+1), ird, ibc
      common /prty/ propr(20)
      include 'pcom.h'
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
      common /fnam/ vname, sname, mname
      character*8 titl(4,4), vname, sname, mname
      character cname*4, fname*12
      character char1*1, char2*1, char3*1, char4*1, char5*1, char6*1
 
      open ( 1, file='plot'    , status='unknown')
      open ( 5, file='inplot'  , status='old')
      open (10, file='mapdat'  , status='unknown')
c     open (10, file='/h4p/wyang/lib/mapdat'  , status='unknown')
 
      read (5,10) cname, ispec, iclr, iscl, isctn, ieqar,
     &            ipole, nequa, nskp, irmax, imap, idbeg, idend
 10   format(a4/i2/i2/i2/i2/i2/i2/i2/i2/i2/i2/i2/i2)
 
      write(6,20) cname, ispec, iclr, iscl, isctn, ieqar,
     &            ipole, nequa, nskp, irmax, imap, idbeg, idend
 20   format('cname = ',a4/'ispec = ',i2/'iclr  = ',i2/'iscl  = ',i2/
     &       'isctn = ',i2/'ieqar = ',i2/'ipole = ',i2/'nequa = ',i2/
     &       'nskp  = ',i2/'irmax = ',i2/'imap  = ',i2/'idbeg = ',i2/
     &       'idend = ',i2)
 
      nproc = (mt/nt)**2*10/nd
      icptn = 1
 
      do 50 idump=idbeg,idend
 
      char5 = char(48 + idump/10)
      char6 = char(48 + mod(idump,10))
 
      do 40 iproc=0,nproc-1
 
      char1 = char(48 + iproc/1000)
      char2 = char(48 + mod(iproc/100,10))
      char3 = char(48 + mod(iproc/10,10))
      char4 = char(48 + mod(iproc,10))
      fname = cname//'.'//char1//char2//char3//char4//'.'//char5//char6
 
      open (8, file=fname, status='unknown')
 
c...  Read in geoid field.
 
      call vecin(w,titl,rshl,1, 0,8,0)
      if(ispec/2 .eq. 6) then
         call collect(s,w,iproc,1)
         if(mod(ispec, 2) .eq. 0) go to 30
      end if
 
c...  Read in topography field.
 
      call vecin(w,titl,rshl,1, 1,8,0)
      if(ispec/2 .eq. 7) then
         call collect(s,w,iproc,2)
         if(mod(ispec, 2) .eq. 0) go to 30
      end if
 
c...  If there are lithospheric plates, read in plate map field.
 
      nplate = propr(20)
      if(nplate .gt. 0) call vecin(w,titl,rshl,1, 1,8,1)
      if(ispec/2 .eq. 4) then
         mname = 'terra   '
         call collect(pmap,w,iproc,2)
      endif
 
c...  Read in temperature field.
 
      call vecin(w,titl,rshl,1,nr,8,1)
      if(ispec/2.eq.1 .or. ispec/2.eq.4) then
         call collect(s,w,iproc,nr+1)
         if(mod(ispec, 2) .eq. 0) go to 30
      end if
 
c...  Read in velocity field.
 
      call vecin(w,titl,rshl,3,-1,8,0)
      if(mod(ispec, 2).eq.1 .or. ispec.eq.16) then
         call collect(v,w,iproc,3*(nr+1))
         if(ispec/2.eq.1 .or. ispec/2.eq.4 .or.
     &      ispec/2.eq.6 .or. ispec/2.eq.7) go to 30
      end if
 
c...  If there is variable viscosity, read in viscosity field.
 
      vscmax  = propr(18)
      tvscscl = propr(19)
      if(vscmax.gt.0. .and. tvscscl.gt.0.)
     &   call vecin(w,titl,rshl,1,nr,8,0)
      if(ispec/2 .eq. 3) then
         call collect(s,w,iproc,nr+1)
         go to 30
      end if
 
c...  If EOS is compressible, read in shear heating field.
 
      ieos = propr(6)
      if(ieos .ge. 10) call vecin(w,titl,rshl,1,nr,8,0)
      if(ispec/2 .eq. 9) then
         call collect(s,w,iproc,nr+1)
         go to 30
      end if
 
c...  Read in strain rate field.
 
      call vecin(w,titl,rshl,1,nr,8,0)
      if(ispec/2 .eq. 2) call collect(s,w,iproc,nr+1)
 
 30   close (8)
 
 40   continue
 
      if(idump .eq. idbeg) then
 
         call grdgen(xn,mt)
         call gplot('u','sclrplt',7)
 
      endif
 
      call sphplot(v,s,pmap,titl,rshl,xn,w)
 
      if(ieos.eq.5 .and. ispec.eq.3) call conmanout(v,s,rshl,xn)
 
 50   continue
 
      call gdone
 
      stop
      end
*dk conmanout
      subroutine conmanout(u,t,rshl,xn)
 
      include 'size.h'
      real u(0:mt,mt+1,10,3,nr+1), xn(0:mt,mt+1,10,3)
      real t(0:mt,mt+1,10,nr+1), rshl(nr+1)
 
      open (20, file='conman.TT', status='unknown')
 
      do jd=1,3
 
         if(jd .eq. 1) then
            id  = 1
            iib = mt/4 + 1
            iie = mt/2
         elseif(jd .eq. 2) then
            id  = 6
            iib = 1
            iie = mt/2
         elseif(jd .eq. 3) then
            id  = 2
            iib = 1
            iie = mt/2 + 1
         end if
 
         do ii=iib,iie
 
            i1 = mt + 1 - ii
            i2 = mt/2 + ii
 
            do ir=nr+1,1,-1
 
               jr = nr + 2 - ir
 
               write(20,10) jr,  rshl(ir)*xn(i1,i2,id,2),
     &            rshl(ir)*xn(i1,i2,id,1), u(i1,i2,id,2,ir),
     &            u(i1,i2,id,1,ir), t(i1,i2,id,ir)-0.16
 10            format(i6,1p2e11.3,3e13.5)
 
            end do
 
         end do
 
      end do
 
      end
*dk collect
      subroutine collect(a,ap,kproc,nc)
 
c...  This routine reads the subarray ap for process kproc into
c...  the appropriate portion of the global array a.  Array a has
c...  dimensions (mt+1,mt+1,10,nc).
 
      include 'size.h'
      real a(mt+1,mt+1,10,nc), ap(nt+1,nt+1,nd,nc)
 
c...  Determine subdomain limits.
 
      mproc = (mt/nt)**2
      iproc = mod(kproc, mproc)
      id0   = (kproc/mproc)*nd
      rnm   = real(nt)/real(mt)
      j0    = iproc*rnm
      i0    = (real(iproc)*rnm - j0)/rnm
      ibeg  = i0*nt + 1
      jbeg  = j0*nt + 1
      iend  = ibeg + nt - 1
      jend  = jbeg + nt - 1
      if(iend .eq. mt) iend = iend + 1
      if(jend .eq. mt) jend = jend + 1
 
c...  Load process subarray ap into global array a.
 
      do ic=1,nc
 
         do id=1,nd
 
            jd = id + id0
 
            j = 0
            do jj=jbeg,jend
               j = j + 1
 
               i = 0
               do ii=ibeg,iend
                  i = i + 1
 
                  a(ii,jj,jd,ic) = ap(i,j,id,ic)
 
               end do
 
            end do
 
         end do
 
      end do
 
      end
*dk dot
      function dot(p,x,y,z)
 
      real p(3)
 
      dot = p(1)*x + p(2)*y + p(3)*z
 
      end
*dk dotpr
      function dotpr(e,xn,i1,i2,id,nt)
 
c...  This routine computes the dot product of the vector e
c...  with the vertex coordinate array xn at vertex (i1,i2,id).
 
      real xn(0:nt,nt+1,10,3), e(3)
 
      dotpr = e(1)*xn(i1,i2,id,1) + e(2)*xn(i1,i2,id,2)
     &      + e(3)*xn(i1,i2,id,3)
 
      end
*dk dprd
      function dprd(x,y)
 
c...  This routine computes the dot product of the vectors x and y.
 
      real x(3), y(3)
 
      dprd = x(1)*y(1) + x(2)*y(2) + x(3)*y(3)
 
      end
*dk grdgen
      subroutine grdgen(xn,nt)
 
c...  This routine generates the nodal coordinates xn for an
c...  icosahedral grid on the unit sphere.  The grid resolution
c...  corresponds to a subdivision of the edges of the original
c...  icosahedral triangles into nt equal parts.
 
      real xn(nt+1,nt+1,10,3)
 
      fifthpi = 0.4*asin(1.)
      w       = 2.0*acos(1./(2.*sin(fifthpi)))
      cosw    = cos(w)
      sinw    = sin(w)
      lvt     = 1.45*log(real(nt))
      nn      = (nt+1)**2*10
 
      do id=1,10
 
         sgn = 1.
         if(id .ge. 6) sgn = -1.
         phi = (2*mod(id, 5) - 3 + (id - 1)/5)*fifthpi
 
         xn(   1,   1,id,1) =  0.
         xn(   1,   1,id,2) =  0.
         xn(   1,   1,id,3) =  sgn
         xn(nt+1,   1,id,1) =  sinw*cos(phi)
         xn(nt+1,   1,id,2) =  sinw*sin(phi)
         xn(nt+1,   1,id,3) =  cosw*sgn
         xn(   1,nt+1,id,1) =  sinw*cos(phi + fifthpi + fifthpi)
         xn(   1,nt+1,id,2) =  sinw*sin(phi + fifthpi + fifthpi)
         xn(   1,nt+1,id,3) =  cosw*sgn
         xn(nt+1,nt+1,id,1) =  sinw*cos(phi + fifthpi)
         xn(nt+1,nt+1,id,2) =  sinw*sin(phi + fifthpi)
         xn(nt+1,nt+1,id,3) = -cosw*sgn
 
         do k=0,lvt-1
 
            m  = 2**k
            l  = nt/m
            l2 = l/2
 
c...        rows of diamond--
 
            do j1=1,m+1
               do j2=1,m
                     i1 = (j1-1)*l + 1
                     i2 = (j2-1)*l + l2 + 1
                     call midpt(xn(i1,i2,id,1),xn(i1,i2-l2,id,1),
     &                          xn(i1,i2+l2,id,1),nn)
               end do
            end do
 
c...        columns of diamond--
 
            do j1=1,m+1
               do j2=1,m
                     i1 = (j2-1)*l + l2 + 1
                     i2 = (j1-1)*l + 1
                     call midpt(xn(i1,i2,id,1),xn(i1-l2,i2,id,1),
     &                          xn(i1+l2,i2,id,1),nn)
               end do
            end do
 
c...        diagonals of diamond--
 
            do j1=1,m
               do j2=1,m
                     i1 = (j1-1)*l + l2 + 1
                     i2 = (j2-1)*l + l2 + 1
                     call midpt(xn(i1,i2,id,1),xn(i1-l2,i2+l2,id,1),
     &                          xn(i1+l2,i2-l2,id,1),nn)
               end do
            end do
 
         end do
 
      end do
 
      end
*dk midpt
      subroutine midpt(x,x1,x2,nn)
 
c...  This routine finds the midpoint x along the shorter great circle
c...  arc between points x1 and x2 on the unit sphere.
 
      real x(nn,3), x1(nn,3), x2(nn,3)
 
      do j=1,3
         x(1,j) = x1(1,j) + x2(1,j)
      end do
 
      xnorm = 1./sqrt(x(1,1)**2 + x(1,2)**2 + x(1,3)**2)
 
      do j=1,3
         x(1,j) = xnorm*x(1,j)
      end do
 
      end
*dk nulvec
      subroutine nulvec(v,nn)
 
      real v(*)
 
      do ii=1,nn
         v(ii) = 0.
      end do
 
      end
*dk psum
      subroutine psum
      end
*dk uradtng
      subroutine uradtng
      end
*dk vecin
      subroutine vecin(u,titl,rshl,nj,mr,nf,ifmt)
 
c...  This routine reads the nodal field u from logical unit nf
c...  using 1pe10.3 format when ifmt = 0 and f10.3 when ifmt = 1.
 
      include 'size.h'
      real u(*), rshl(*)
      common /prty/ propr(20)
      character*8 titl(4,4)
 
      read(nf,10) kr, kt
 10   format(2i5)
 
      if(kr.ne.nr .or. kt.ne.nt) then
         print *,'Array dimensions of data file and size.h inconsistent'
         stop
      end if
 
      read(nf,20) titl
 20   format(4a8)
 
      read(nf,30) (rshl(i),i=1,nr+1)
      read(nf,30) propr
 30   format(1p10e15.8)
 
      kr = mr
      if(mr .lt. 0) kr = nr
 
      if(ifmt .eq. 0) then
 
         read(nf,40) (u(ii),ii=1,(nt+1)**2*nd*nj*(kr+1))
 40      format(1p15e10.3)
 
      elseif(ifmt .eq. 1) then
 
         read(nf,50) (u(ii),ii=1,(nt+1)**2*nd*nj*(kr+1))
 50      format(15f10.3)
 
      endif
 
      end
*dk vecset
      subroutine vecset(v,value,nn)
 
      real v(*)
 
      do ii=1,nn
         v(ii) = value
      end do
 
      end
      block data bdsphplt
 
      common /fnam/ vname, sname, mname
      character*8 vname, sname, mname
      data vname/'terra   '/, sname/'terra   '/, mname/'        '/
 
      end
